// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:x offset:
//f1:y offeet:
//f2:scale:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.5, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

// http://glslsandbox.com/e#39649.0

float time = float(itime) + ftime;

float circle(vec2 coord, float spd) {
    float reso = 2.0 + (20.0 * f2) ;
    float cw = tres.x / reso;

    vec2 p = mod(coord, cw);
    float d = distance(p, vec2(cw / 2.0));

    float rnd = dot(floor(coord / cw), vec2(1323.443, 1412.312));
    float t = time * 2.0 + fract(sin(rnd)) * 6.2;

    float l = cw * (sin(t * spd) * 0.25 + 0.25 );
    return clamp(l - d, 0.0, 1.0);
}

//---------------------------------------------------------------------------------------------------
void main(void) {

    vec2 p = gl_FragCoord.xy;
    vec2 dp = vec2(7.9438 *f0 * .5, 1.3335* f1) * time;
    float c1 = circle(p - dp, 1.0);
    float c2 = circle(p + dp, 1.4);
    float c = max(0.0, abs(c1 - c2));
    gl_FragColor = vec4(c, c, c, 1);

   
} //endof main


