// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

//f0:generator speed:
//f1:cell blur:
//f2:skip time:

float f0 = clamp(fparams[0], 0.05, 0.95);
float f1 = clamp(fparams[1], 0.05, 0.95);
float f2 = mix(0.5, 0.95, fparams[2]);

float mytime = float(itime) + ftime;

//---------------------------------------------------------------------------------------------------
// source : http://glslsandbox.com/e#35957.0

void main(void) {

vec2 point1 = vec2(0.2, (sin(mytime) / 2.0) + f0);
vec2 point2 = vec2(0.2, ((-sin(mytime)) / 2.0) + f2);

vec2 position = gl_FragCoord.xy / tres.xy;
position.x *= tres.x / tres.y;

float deepness = sin((distance(position, point1) * 40.0) - (mytime * 10.0)) + sin((distance(position, point2) * 40.0) - (mytime * 10.0));

float pixelIntensity = (deepness / 2.0) + f1;

gl_FragColor = vec4(vec3(pixelIntensity), 1.0);

} //endof main


