// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:ball size:
//f1:grid size:
//f2:light strength:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);


float time = float(itime) + ftime;
vec2 resolution = tres;
// http://www.xdr.com/dash/blog/index.php?entry=entry121018-015739

void main( void ) {

#define RADIUS (.2 * f0 + .1 )
float h = .2 * ( 1.0*resolution.x/resolution.y - pow(2.0 * fract(time*.4) - 1.0, 2.0));
float xpos = fract(time*.11);
if(xpos > .5) xpos = 1.0 - xpos;

xpos = RADIUS + 2.0 * xpos * (1.0 - RADIUS * 2.0);
vec2 center = resolution * vec2(xpos, RADIUS + h);

vec2 position = ( (gl_FragCoord.xy - center) / resolution.xx );

#define SCALE (5.0929581*f1)
position *= (1.0 / RADIUS);
float r = length(position);
vec3 color = vec3(1.0, 0.0, 0.0);
float spec = 0.0;
float diffuse = 0.0;
if(r <= 1.0)
{
float z = sqrt(1.0 - r*r);
vec3 norm = vec3(position, z);
vec3 fix = norm;
float tilt = -0.2;
vec2 mat = vec2(cos(tilt), sin(tilt));
fix.x = dot(norm.xy, mat);
fix.y = dot(norm.xy, vec2(-mat.y, mat.x));
float lat = asin(fix.y);
float lon = atan(fix.x, fix.z)+xpos*10.0;
float y = SCALE * log(1.0 / cos(lat) + tan(lat));
float x = lon * SCALE;
float t = fract(y);
if(fract(x) < .5) t = 1.0 - t;
if(t < .5) color.g = color.b = .9;
vec3 lightpos = normalize(vec3(-1.0, 1.0, 0.5));
diffuse = dot(norm, lightpos) * f2;
diffuse = max(diffuse, 0.0) + .2;
vec3 halfdir = normalize(lightpos + vec3(0.0, 0.0, 1.0));
spec = dot(halfdir, norm);
spec = pow(max(spec, 0.0), 60.0);
}

gl_FragColor = vec4( color*diffuse + vec3(1.0, 1.0, 1.0)*spec, 1.0 );

}


