// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;//
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:pattern radius:
//f1:zoom:
//f2:pattern slices:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
//---------------------------------------------------------------------------------------------------

// Created by Stephane Cuillerdier - @Aiekick/2016 - //www.shadertoy.com/view/XdKGRD - original clickable www.shadertoy.com/view/XdG3zm

#define PI 3.1415926535897932384626

// count radial section
float sections = 1.;
vec3 startColor = vec3(.5,0.26,0);
vec3 endColor = vec3(0.99,0.2,0.49);

float zoom = 2.6; // screen coord zoom

float neutralSection = 8.;  // if of central section

float neutralZone = 2. *f0; // radius of neutral zone (in center) wich show the neutralSection id

vec3 GetHexPattern(vec2 uv, vec4 v, vec3 k) {
    float a = atan(uv.x, uv.y)/4.14159*floor(k.y);
float r = length(uv)*4.;
uv = vec2(a,r);// polar uv

    uv.x *= floor(uv.y)-k.x; //along r with alternance
uv.x += time ; // rotate each radius offset with constant speed

    vec3 color = mix(startColor, endColor, vec3(floor(uv.y)/4.));

    uv = abs(fract(uv)-0.5);

return color / (abs(max(uv.x*v.x + uv.y*v.y,uv.y*v.z) - v.w)*k.z);
}

vec2 GetUV(vec2 s, vec2 h, float z) {
return z * (h+h-s)/s.y *f1*2.; // central uv
}

float GetID(vec2 s, vec2 h) {
vec2 uv = GetUV(s, h, zoom);
float a = 0.;
if (uv.x >= 0.) a = atan(uv.x, uv.y);
    if (uv.x < 0.) a = 3.14159 - atan(uv.x, -uv.y);
a = ceil(a *  (floor(sections*4.)*f2)/3.14159);
float r = length(uv);
    return ( r < neutralZone ? neutralSection : a);
}


//---------------------------------------------------------------------------------------------------
void main(void) {

vec2 pos = gl_FragCoord.xy;

vec2 uv = GetUV(tres.xy, pos, zoom);

float cellID = GetID(tres.xy, pos);

vec4 p = vec4(0); // hex width, hex height, hex height limit, hex scale

vec3 k = vec3(-3, 2,1 ); // Alternance, Density, Glow

if (cellID == 1.) {p = vec4(1.2,0.92,1.88,0.8);}
if (cellID == 2.) {p = vec4(2.2,0,1.88,0.8);}
if (cellID == 3.) {p = vec4(2.2,0,4,0.8);}
if (cellID == 4.) {p = vec4(1,0,4,0.8);}
if (cellID == 5.) {p = vec4(1.2,0,2.12,0.64);}
if (cellID == 6.) {p = vec4(4,4,1,0.8);}
if (cellID == 7.) {p = vec4(1,2.96,4,0.8);}
if (cellID == 8.) {p = vec4(1.5,0.96,1.8,0.4);}
//if (cellID == 9.) {p = vec4(1.2,2.24,0,0.68);}

// refuse to save if i uncomment this ..... wtf ?

vec3 hexPattern = GetHexPattern(uv, p, k);

vec3 col = clamp(hexPattern, 0., 1.); // intensity limit for glow

gl_FragColor = vec4(col, 1.);

} //endof main


