// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;//
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:x pos:
//f1:y pos:
//f2:zoom:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.2, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
//---------------------------------------------------------------------------------------------------
void main() {

vec2 position = 2.0 * (gl_FragCoord.xy / resolution.xy) -1. * vec2(f0,f1) * 2.;
position.x *= resolution.x / resolution.y;

//position += vec2(cos(time * 0.25), sin(time * 0.5)) * 0.8;

vec3 colour = vec3(0.0);

float u = sqrt(dot(position, position))* f2;
float v = atan(position.y, position.x);

float t = time + 1.0 / u;

float val = smoothstep(0.0, 1.0, sin(5.0 * (time + sin(1.0/u * 7.0)) + 10.0 * v) + cos(t * 10.0));

colour = vec3(val * 0.8, val, 0.0) + (1.0 - val) * vec3(0.05, 0.05, 0.05);
colour *= clamp(u * 1.0, 0.0, 1.0);

gl_FragColor = vec4(colour, 1.0);

}


