// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

//---------------------------------------------------------------------------------------------------
// other functions
#define PI 3.1415926535897932384626
vec2 mouse = vec2(fparams.x, fparams.y);
float time = float(itime) + ftime;
vec2 resolution = tres;// for easier glslsandbox.com conversion

float random(vec2 st) {
   return fract(sin(dot(st.xy, vec2(12.9898, 78.233))) * 43758.5453123);
}

//---------------------------------------------------------------------------------------------------
void main(void) {
//f0:horz stretch:
//f1:vert stretch:
//f2:zoom up:

//float f0 = mix(0.25, 0.95, fparams[0]);
float f0 = (0.95 - 0.25) * fparams[0] + 0.25;
float f1 = clamp(fparams[1], 0.05, 0.95);
float f2 = mix(0.5, 0.95, fparams[2]);

   vec2 p = gl_FragCoord.xy / resolution.xy * f2 * 2.;
   
   
   float x = p.x * f0;
   float speed = 0.5;
   x += time * speed;
   
   x = floor(x * 10.0 );
   
   float y = floor(p.y * 20.0 * f1);
   
   float v = random(vec2(x, y));
   
   v = floor(v * 2.0);

   gl_FragColor = vec4(vec3(v), 1.0);


} //endof main


