// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

// other functions
float time = float(itime) + ftime;
vec2 resolution = tres;// for easier glslsandbox.com conversion

//---------------------------------------------------------------------------------------------------
// http://www.glslsandbox.com/e#42055.0
void main(void) {
//f0:horz slide:
//f1:vert scroll:
//f2:diag zoom:
//float f0 = clamp(fparams[0], 0.05, 0.95);
float f0 = (0.95 - 0.25) * fparams[0] + 0.25;
float f1 = clamp(fparams[1], 0.05, 0.95);
float f2 = mix(0.5, 0.95, fparams[2]);



vec2 position = ( gl_FragCoord.xy / resolution.xy * f2 * 2.0 );

float x = position.x * position.x;
float y = position.y * position.y;
float color = min(abs(floor((x - f0 * f0) * 100.) / 10.), abs(floor((y - f1 * f1) * 100.) / 10.));

gl_FragColor = vec4( vec3( color , floor(sin(color - time) * 100.), (cos(x + time) + sin(y + time))), 1.0 );


} //endof main


