// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:center box:
//f1:diag thick:
//f2:box shade:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
// https://www.shadertoy.com/view/MdccWS


vec3 smoothborder( vec2 uv, float a, float b ) {
    vec2 leftbottom = smoothstep(vec2(a), vec2(b), uv);
    vec2 topRight = smoothstep(vec2(a), vec2(b), 1. - uv);
    float point = leftbottom.x * leftbottom.y * topRight.x * topRight.y / f2; 
    vec3 color = vec3( point );
    return color;
}

vec3 createSmoothRect(float width, float inward, float outward,vec2 uv, float x) {
    vec3 color1 = smoothborder(uv, x, x + inward);
    vec3 color2 = smoothborder(uv, x + width, x + width + outward );   
    vec3 rect = color1 - color2;
    return rect;
}

float plot(vec2 st, float pct){
  return  smoothstep( pct-0.005 /f1, pct, st.y) -
          smoothstep( pct, pct+0.005 /f1, st.y);
}

//---------------------------------------------------------------------------------------------------
void main(void) {

    // Normalized pixel coordinates (from 0 to 1)
    vec2 uv = gl_FragCoord.xy/tres.xy;
    float x = abs(mod(1. - time / 4., 1.)) * 0.5 - 0.1;
    float y =abs(mod(1. - time / 4. - .5, 1.)) * 0.5 - 0.1;
    float widthX = 0.01 * (1. - x) * (1. - x)* (1. - x);
    float widthY = 0.01 * (1. - y) * (1. - y) * (1. - y);
    vec3 rect1 = createSmoothRect(widthX, 0.001, 0.05, uv, x);
    vec3 rect2 = createSmoothRect(widthY, 0.001, 0.05, uv, y);
    float middleRectWidth = .2 + (.28 * f0);
    vec3 rect3 = createSmoothRect(0.004, 0.001, 0.001, uv, middleRectWidth);
    vec3 rect4 = 1. - createSmoothRect(middleRectWidth, 0.001, 0.001, uv, middleRectWidth + 0.004);
    
    vec3 color;
    float z = uv.x;
    color = vec3(plot(uv, z));
    float z2 = 1. - uv.x;
    color += vec3(plot(uv, z2));
    
    color += rect1 + rect2 + rect3;
    
    color *= rect4;
    
    // Output to screen
    gl_FragColor = vec4(color, 1.0);
   
} //endof main


