// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:zoom:
//f1:lungs:
//f2:red zoom:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
// by rotwang

void main(void) {
    vec2 p = (2.0*gl_FragCoord.xy-resolution)/resolution.y / f0;


    float x = abs(p.x);
    float y = abs(p.y)/8.0;

    float a = atan(x*x/f1,y)/3.141593 ;

    float st = 0.125 + 0.25*sin(time) * f1;

    float r = mix( length(p)- st*0.5, length(p)* st, sin(time));
    float invr = 1.0-r ;

  
    float absa = abs(a);

    float shade = smoothstep(r, r+0.1,absa);
    shade *= pow(1.0-r/absa,0.75 * f1);

    float g = 1.0-length(p) * f2 * 2.;
    vec3 clr = vec3(shade+g,shade*0.9,shade*0.9-g);


    gl_FragColor = vec4(clr,1.0);

}


