// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:horz stretch:
//f1:gear teeth move:
//f2:gear thickness:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
// @rotwang:

vec3 hsv2rgb(float h,float s,float v) {
return mix(vec3(1.),clamp((abs(fract(h+vec3(3.,2.,1.)/3.)*6.-3.)-1.),0.,1.),s)*v;
}


void main( void ) {

float aspect = resolution.x / resolution.y;
vec2 unipos = (gl_FragCoord.xy / resolution.xy);
vec2 bipos = unipos*2.0-1.0;
bipos.x *= aspect * 2. *f0;

float angle = atan(bipos.x , bipos.y * f1);

float scale = 0.2 / f2 * .5;
//float distance = 1.0 - scale * ((distanceVector.x * distanceVector.x) + (distanceVector.y * distanceVector.y));

float distance = (1.0 - length(bipos)) * scale;

float cogMin = 0.01; // 'min' is actually the outer edge because I'm using 1/distance... for reasons I can't remember :(
float cogMax = 0.05; // 'max' is the inner edge, so this controls the size of the hole in the middle - the higher the value the smaller the hole

// tooth adjust makes the teeth slope so they get smaller as they get further out
float toothAdjust = 2.4 * (distance - cogMin);
// 12 defines the number of cog teeth
float angleFoo = sin(angle*24.0 - time * 4.0) - toothAdjust;
cogMin += 1.5 * clamp(1.0 * (angleFoo + 0.5), 0.0, 0.01); // add 0.2 to make teeth a bit thinner, the 0.015 clamp controls the thickness of the cog ring

// By multiplying values up and clamping we can get a solid cog with slight anti-aliasing
float isSolid = clamp(2.0 * (distance - cogMin) / cogMax, 0.0, 1.0);
isSolid = clamp(isSolid * 50.0 * (cogMax - distance), 0.0, 1.0);


float hue = 0.56;
float sat = 0.6;
float lum = isSolid * length(bipos*0.25)*8.0;
vec3 rgb = hsv2rgb(hue, sat, lum);

gl_FragColor = vec4(rgb, 1.0);
}


