// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:horz trip:
//f1:vert trip:
//f2:details:

float f0 = mix(0.35, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

//https://www.shadertoy.com/view/ldc3RB

float time = float(itime) + ftime;
vec2 resolution = tres;// for easier glslsandbox.com conversion

vec2 hash22(vec2 p) {
    p = vec2( dot(p,vec2(127.1,311.7)),
  dot(p,vec2(269.5,183.3)));
    //return normalize(-1.0 + 2.0 * fract(sin(p)*43758.5453123));
    return -1.0 + 2.0 * fract(sin(p)*43758.5453123);
}

float hash21(vec2 p) {
float h = dot(p,vec2(127.1,311.7));

    return -1.0 + 2.0 * fract(sin(h)*43758.5453123);
}

float perlin_noise(vec2 p) {
    vec2 pi = floor(p);
    vec2 pf = p - pi;
    
    vec2 w = pf * pf * (3.0 - 2.0 * pf);
    
    return mix(mix(dot(hash22(pi + vec2(0.0, 0.0)), pf - vec2(0.0, 0.0)), 
                   dot(hash22(pi + vec2(1.0, 0.0)), pf - vec2(1.0, 0.0)), w.x), 
               mix(dot(hash22(pi + vec2(0.0, 1.0)), pf - vec2(0.0, 1.0)), 
                   dot(hash22(pi + vec2(1.0, 1.0)), pf - vec2(1.0, 1.0)), w.x),
               w.y);
}

float value_noise(vec2 p) {
    vec2 pi = floor(p);
    vec2 pf = p - pi;
    
    vec2 w = pf * pf * (3.0 - 2.0 * pf);
    
    return mix(mix(hash21(pi + vec2(0.0, 0.0)), hash21(pi + vec2(1.0, 0.0)), w.x),
               mix(hash21(pi + vec2(0.0, 1.0)), hash21(pi + vec2(1.0, 1.0)), w.x),
               w.y);
}

float simplex_noise(vec2 p) {
    float K1 = 0.366025404; // (sqrt(3)-1)/2;
    float K2 = 0.211324865; // (3-sqrt(3))/6;
    
    vec2 i = floor(p + (p.x + p.y) * K1);
    
    vec2 a = p - (i - (i.x + i.y) * K2);
    vec2 o = (a.x < a.y) ? vec2(0.0, 1.0) : vec2(1.0, 0.0);
    vec2 b = a - (o - K2);
    vec2 c = a - (1.0 - 2.0 * K2);
    
    vec3 h = max(0.5 - vec3(dot(a, a), dot(b, b), dot(c, c)), 0.0);
    vec3 n = pow(h,vec3(4.0)) * vec3(dot(a, hash22(i)), dot(b, hash22(i + o)), dot(c, hash22(i + 1.0)));
    
    return dot(vec3(70.0, 70.0, 70.0), n);
}


float noise_sum_abs(vec2 p) {
    float f = 0.0;
    p = p * 4.;
    f += 1.0000 * abs(simplex_noise(p)); p = 2.0 * p / f0;
    //f += 0.5000 * abs(simplex_noise(p)); p = 2.0 * p;
    f += 0.2500 * abs(simplex_noise(p)); p = 2.0 * p / f1;
    //f += 0.1250 * abs(simplex_noise(p)); p = 2.0 * p;
    f += 0.0625 * abs(simplex_noise(p)); p = 2.0 * p;
    return f;
}

float noise_sum_abs_sin(vec2 p) {
    float f = noise_sum_abs(p);
f *= 4.0 * f2;
    f = sin(f * 1.5 + p.x * 4.0); //brigthness
    return f * f ;
}


//---------------------------------------------------------------------------------------------------
void main(void) {

    float speedTime = time * 0.05;

    vec2 p = gl_FragCoord.xy / tres.xy - vec2(f0,f1) * 2.;
    vec2 uv = p * vec2(tres.y/tres.x, 1.0);
    vec3 col = vec3(0.0, 0.0, 0.0);
    float f = 0.0;
    
    //f = noise_sum_abs(uv);
    f = noise_sum_abs_sin(uv.yx);
    col =vec3(f);
    
    gl_FragColor = vec4(col, 1.0);

   
} //endof main


