// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:sharp edge:
//f1:hole size:
//f2:diag zoom:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

float textureRND2D(vec2 uv) {
vec2 f = fract(uv);
f = f*f*(6.0*f0-2.0*f);
uv = floor(uv);
float v = uv.x+uv.y*1e3;
vec4 r = vec4(v, v+1., v+1e3, v+1e3+1.);
r = fract(1e5*sin(r*1e-3));
return mix(mix(r.x, r.y, f.x), mix(r.z, r.w, f.x), f.y);
}

void main( void ) {
vec2 p = gl_FragCoord.xy/resolution.xy;
float c = step(textureRND2D(p*5./f2+vec2(0.,-time)),p.y*.9 * f1+.1);
gl_FragColor = vec4(mix(vec3(1.2,.5,0.2)*p.y, vec3(p.y), c),1.0);
}


