// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:wave 1:
//f1:wave 2:
//f2:highlights:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
// by wststreet // www.kamehamehaaa.org // wststreet2@gmail.com

float line(float x){
return -0.01*sin(30.0*x+time) / f0+
0.02/f1*sin(10.0*x+time*1.0)+
-0.03*sin(3.0*x+time*0.5)+0.5;
}

float hdist(float x, float y){
return (y-x)>0.0?y-x*f2:x-y*f2;
}
void main( void ) {

vec2 position = ( gl_FragCoord.xy / resolution.xy );

vec4 color ;

float lineposx = line(position.x);

if(position.y < lineposx-0.003){
color=vec4(0.0,0.3,0.5,1.0);
}
else if (position.y > lineposx+0.003){
color=vec4(0.0,0.7,1.0,1.0);
}
else{
color=vec4(0.3,0.7,0.7,1.0)/abs(200.0*(position.y-lineposx));
}
float t_color = hdist(position.y,line(position.x));
color -= vec4(t_color, t_color, t_color, t_color);

gl_FragColor = color;

}



