// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:vert offset:
//f1:move zoom:
//f2:soft zoom:
float f0 = mix(0.4, 0.6, fparams[0]);
float f1 = mix(0.3, 0.6, fparams[1]);
float f2 = mix(0.2, 0.7, fparams[2]);

//http://www.glslsandbox.com/e#42185.0
#define PI 3.1415926535897932384626
float time = float(itime) + ftime;
vec2 resolution = tres;// for easier glslsandbox.com conversion



//---------------------------------------------------------------------------------------------------
void main(void) {

float N = 90.0;

vec2 st = (gl_FragCoord.xy * 4.0 *f1  - resolution) / min(resolution.x, resolution.y) * 2. * f1;

st *= (4.0 * f2) + 2.;

float brightness = 0.0;
vec3 baseColor = vec3(0.0, 0.1, 0.3);
float speed = time * 0.35;

brightness = N * 0.002 / abs(sin(PI * st.x) * sin(PI * st.y) *  sin( speed + floor(st.x /f0) + floor(st.y)) );

gl_FragColor = vec4(baseColor * brightness, 1.0);


} //endof main


