// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:wave height:
//f1:wave dip:
//f2:wave horizon:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);


float time = float(itime) + ftime;
vec2 resolution = tres;
// https://github.com/elemel/water-shader/blob/master/water.frag-  TranquilMarmot


float pi           = 3.14159265358979323846264;
float surface_y    = 210.0 + ( 40.0 * f2); // where the waves occur on the y axis
float wave_height  = 10.0 + 250. * f0; // how high each wave is
float wave_length  = 625.0; // how long each wave is
float wave_speed   = 0.1;   // how fast the waves travel across the screen (positive for right-moving waves, negative for left)
float wave_dip     = 0.7 * f1;   // how much of a 'dip' there is between waves (0.0 for a smooth wave)
float wave_distort = 0.9;   // how much the peaks curve towards eachother
vec4  wave_color   = vec4(0.01, 0.44, 0.91, 1.0); // color of water
vec4  sky_color    = vec4(0.1,  0.2,  0.9,  1.0);    // background color

void main( void ) {
float yThreshold = surface_y + (0.2 * wave_height);
float wave1 = wave_dip * wave_height * abs(sin(2.0 * pi * -wave_speed * time + 2.0 * pi * gl_FragCoord.x / wave_length));
float wave2 =  wave_distort * wave_height * pow(sin(4.0 * pi * -wave_speed * time + pi * gl_FragCoord.x / wave_length), 2.0);


if (gl_FragCoord.y < yThreshold - (wave1 + wave2))
gl_FragColor = wave_color;
else
gl_FragColor = sky_color;
}


