// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:x pos:
//f1:y pos:
//f2:circle size :

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.6, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

float sphereSdf(vec3 p) {
return length(p) - f2;
}

float sdf(vec3 p) {
vec3 q = fract(p) - 0.5;
return sphereSdf(q);
}

//---------------------------------------------------------------------------------------------------
//http://glslsandbox.com/e#52058.0
void main(void) {

vec2 position = ((gl_FragCoord.xy / resolution.xy) - 0.5) * 2.0;
position.x *= resolution.x / resolution.y;

vec3 origin = vec3(f0-.5 , f1-.5, time);
vec3 ray = vec3(position.xy, 1.0);
vec3 march = normalize(ray);
for (int i = 0; i < 8; i++) {
vec3 p = origin + ray;
ray += march * sdf(p);
}

float rayLength = length(ray);
float brightness = 2.0 / (rayLength * rayLength);
gl_FragColor = vec4(vec3(brightness), 1.0);

   
} //endof main


