// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:zoom:
//f1:offset 1:
//f2:offset 2:
float f0 = mix(0.2, 0.95, fparams[0]);
float f1 = mix(0.4, 0.95, fparams[1]);
float f2 = mix(0.5, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

float wave(vec2 pos, float angle) {
vec2 dir = vec2(cos(angle), sin(angle)) / f1;
return cos(dot(pos  , sin(dir) -f2));
}

void main( void ) {

vec2 position = ( gl_FragCoord.xy / resolution.xy );

    vec2 p = (position - 0.5) * 60. * f0;

    float brightness = 0.;
    for (float i = 1.; i <= 3.; i++) {
        brightness += wave(p, time / i *.2);
    }
brightness += smoothstep(sin(time / 4.0), cos(time / 2.0), time / 10.0);
    gl_FragColor.rgb = vec3(brightness);
    gl_FragColor.a = 1.;
}


