// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:horz stretch:
//f1:vert stretch:
//f2:zoom:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.2, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
// @rotwang

void main( void ) {

float aspect = resolution.x / resolution.y;
vec2 unipos = gl_FragCoord.xy / resolution;
vec2 pos = unipos*2.0-1.0;

vec2 apos = abs(pos /f2);
float shade = 0.33;

float dx = 22.0 * f0 * apos.x + time;
float sdx = sin(dx);
shade += sdx*0.5;


float dy = 22.0 * f1 * apos.y + time;
float sdy = sin(dy);
shade += sdy*0.5;

gl_FragColor = vec4( vec3(shade), 1.0);

}


