// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:zoom:
//f1:slide:
//f2:ripple:
float f0 = mix(0.5, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
//Connected
const float PI = 3.1415926535;
const float TWOPI = PI*2.0;

vec2 rotate(vec2 point, float rads) {
float cs = cos(rads);
float sn = sin(rads);
return point * mat2(cs, -sn, sn, cs);
}

float unsin(float t) { 
return sin(t)*0.5+0.5;
}

float curve( float x) {
return smoothstep( 0.0, 3.0, unsin(x*TWOPI) + cos(x*PI) + sin(x*PI)  ) + unsin(x*TWOPI);
}

float thing(vec2 pos) {
float offset = 0.;
float row = floor((pos.y-1.)/2.) ;
if (mod(row, 2.0) <= 1.0)
offset = curve(unsin(pos.x)*sin(time)*f2);
float a = 2.5-curve(pos.x + curve(unsin(pos.y)*sin(time)*0.25));
float b = sin(time * 0.25)*1.75+curve(pos.y - offset);
float c = (distance(a, b) / sqrt(a/b)) * length(a*b) + 0.25 * 0.5;
return clamp(c, 0.0, 1.0);
}

void main(void) 
{
vec2 position = ( gl_FragCoord.xy / resolution );
vec2 world = position * 14.0 - 7. *f1;
world.x *= resolution.x / resolution.y;
world = rotate(world / f0, radians(time * 10.0));
float dist = thing(world);

gl_FragColor = vec4( dist, dist, dist, 1.0 );
}


