// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:pos:
//f1:offset 1:
//f2:radius 2:
float f0 = mix(0.25, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);


float time = float(itime) + ftime;
vec2 resolution = tres;

void main(void) {

vec2 position = ( gl_FragCoord.xy / resolution.xy );
position -= 0.5;
  position *= 0.15 * pow(length(position), -1.6);
  position += .5;

  vec2 p = -1.0 + 2.0 * position *f0;

    float t = time*0.5;
    vec2 offset1 = vec2(0.5*cos(6.0*t),0.5*sin(3.0*t)) *f1;
    vec2 offset2 = vec2(0.6*sin(3.0*t),0.4*cos(2.0*t));

    float radius1 = sqrt(dot(p-offset1,p-offset1));
    float radius2 = sqrt(dot(p-offset2,p-offset2)) * f2;
        
    bool toggle1 = mod(radius1,0.2)>0.1;
    bool toggle2 = mod(radius2,0.2)>0.1;

    //xor via if statements
    float col = 0.0;
    if (toggle1) col = 1.0;    
    if (toggle2) col = 1.0;
    if ((toggle1) && (toggle2)) col = 0.0;

    gl_FragColor = vec4(col,col,col,1.0);
}


