// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:top margin:
//f1:horz stretch:
//f2:diag zoom:
     float f0 = mix(0.01, 0.95, fparams[0]);
float f1 = mix(0.30, 1.95, fparams[1]);
float f2 = mix(0.02, 0.04, fparams[2]);

// http://www.glslsandbox.com/e#39877.0
float time = (float(itime) + ftime) * 10.0;
vec2 resolution = tres;

float random(in float x){ return fract(sin(x)*43758.5453); }
float random(in vec2 st){ return fract(sin(dot(st.xy ,vec2(12.9898,78.233))) * 43758.5453); }

float randomChar(vec2 outer,vec2 inner){
    float grid = 7.;
    vec2 margin = vec2(f0 * .3 +.01, (0.1 + (f0 * 0.85)) ); // these make interest

    vec2 borders = step(margin,inner+f0)*step(margin,1.-inner*.5);
    vec2 ipos = floor(inner*grid);
    ipos = abs(ipos-vec2(3.,0.));
    return step(.5, random(outer*64.+ipos)) / borders.x * borders.y ;
}



//---------------------------------------------------------------------------------------------------
void main(void) {

    vec2 resolution = vec2(640.0,200.0);// only 1 char if set
    vec2 st = gl_FragCoord.st/resolution.xy;
    float ratio = resolution.x / resolution.y * f1 * 2.;
    st.x *= ratio;
    vec3 color = vec3(0.0);

    float rows = f2 * 40. + 2.;
    //rows += floor(mod(time*0.01,24.));
    
    float time = time * 0.05;
    vec2 vel = vec2(0.,-floor(time));
    
    vec2 ipos = floor(st*rows);
    vec2 fpos = fract(st*rows);
    
    float pct = 1.0;
    pct *= randomChar(mod(ipos + vel,vec2(9.)),fpos);
    if (ipos.y > 0.0 || ipos.x < fract(time)*rows*ratio) {
        color = vec3(pct);
    }  

    gl_FragColor = vec4(1.-color , 1.0);



} //endof main


