// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:pos 1:
//f1:pos 2:
//f2:pos 3:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
//Set the controls for the heart of the sun

const float PI = 3.14159265358979323;
const float TWOPI = PI*2.0;

float osc1 = sin(time)*0.5+0.5;
float env1 = fract(time*0.25);

vec2 rotated(float a, float r) {
return vec2(cos(a*TWOPI)*r, sin(a*TWOPI)*r);
}

float circle(vec2 pos, float radius, float smooth) {
float len = length( pos );
float d = smoothstep( radius-smooth, radius+smooth, len );
return d;
}

float unatan(vec2 p, float start) {
float a= atan(p.x * p.x, p.y *f2);
a/=TWOPI;
a += 0.5 * f2;
a = fract(a+start);
return a;
}

vec3 ring01(vec2 p) {
//vec2 gr = rotated(0.5, 1.0);
float shade = unatan(p, -time + pow(length(p), 0.05) );
float shade2 = unatan(p, time * 1.3 + pow(length(p), 2.0) );
vec3 a = vec3(max(shade2, max(0.0, 2.0 - pow(length(p), 2.0))) * 0.3 + sin(time) * 0.1 + 0.2, 0.0, 0.0);
vec3 b = vec3(1.0, 0.8, 0.0);
//shade *= max(g, dot(p,rotated(g,1.0)));
shade *= 1.0-length(p) / f0;
vec3 clr = a + b * shade / f1;
return clr;

}

void main( void ) {

float speed = time *0.5;
float aspect = resolution.x / resolution.y;
vec2 unipos = ( gl_FragCoord.xy / resolution );
vec2 pos = unipos*2.0-1.0;
pos.x *=aspect;

float sint = sin(time);
float usint = sint*0.5 +0.5;


vec3 clr = ring01(pos);
    
        gl_FragColor = vec4(clr,1.0);

}


