// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:x mod:
//f1:y mod:
//f2:diag zoom:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

vec2 mouse = vec2(fparams.x, fparams.y);
float time = float(itime) + ftime;
vec2 resolution = tres;
//@ME //Connected2

const float PI = 3.1415926535;
const float TWOPI = PI*2.0;

vec2 rotate(vec2 point, float rads) {
float cs = cos(rads);
float sn = sin(rads);
return point * mat2(cs, -sn, sn, cs);
}

float unsin(float t) {
return sin(t)*0.5+0.5;
}

float curve( float x) {
return smoothstep( 0.0, 3.0, unsin(x*TWOPI) + cos(x*PI+mouse.y*10.) + sin(x*PI+mouse.x*10.)  ) + unsin(x*TWOPI);
}

float thing(vec2 pos) {
float offset = 0.;
float row = floor((pos.y-1.)/2.);
if (mod(row, 2.0) <= 1.0)
offset = curve(unsin(pos.x)*sin(time));
float a = curve(pos.x + curve(unsin(pos.y)*sin(time)));
float b = curve(pos.y - offset);
float c = distance(a, b);
return c;
}

void main(void) {
vec2 position = ( gl_FragCoord.xy / resolution );
vec2 world = position * 14.0 * f2 - 7.;
world.x *= resolution.x / resolution.y;
world = rotate(world, radians(45.));
float dist = 2.0*thing(world);

gl_FragColor = vec4( dist , sin(dist+time) , 1.0-dist , 1.0 );
}


