// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:ripple speed:
//f1:ripple highlight:
//f2:ripple highlight2:
float f0 = mix(0.3, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.25, 0.75, fparams[2]);

// http://www.glslsandbox.com/e#42046.1
float time = float(itime) + ftime;
vec2 resolution = tres;// for easier glslsandbox.com conversion

void main(void) {

    vec2 sp = tcoord;
    sp *= 1.-dot(sp,sp) * f0 * 0.005;
    sp = sin(sp*3.141592)/(1.+sp*3.141592);

    vec2 r = vec2(0.125,0.125 * f0);//resolution;

    vec2 o = sp.xy - r/2.;
    o = vec2(dot(o,o) / r.y - .2, (o.y,o.x));    

    vec4 s = 0.09 * cos(1.5 * vec4(0,1,2,4) + time + o.y + f2 + cos(o.y) * cos(time));
    vec4 e = s.yzwx * f1 * 10.;
    vec4 f = min(o.x-s,e-o.x);
    gl_FragColor = vec4(vec3(dot(fract(f), 7050.*(s-e)) * (s-.1) + f), 1.0);


} //endof main


