// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

float time = float(itime) + ftime;
vec2 resolution = tres;// for easier glslsandbox.com conversion


//f0:shade depth:
//f1:shade size:
//f2:red radius:
float f0 = mix(0.2, 0.5, fparams[0]);
float f1 = mix(0.3, 0.75, fparams[1]);
float f2 = mix(0.01, 0.05, fparams[2]);

#define numRegions 8 

//---------------------------------------------------------------------------------------------------
//http://www.glslsandbox.com/e#41997.0

void main(void) {

vec2 p = ( gl_FragCoord.xy / resolution.xy );
p -= 0.5;

float TIME = time / 10.;

float closest = 0.;
vec2 cpt = vec2(0.);
float d = 20. + (100. * f1);
for(int i = 0; i < numRegions; i++) {
float fi = float(i);
vec2 pt = vec2(float(i)/float(numRegions) - 0.5 + sin(TIME+fi)/3., sin(TIME+fi) + cos(TIME/2.+fi/2.));
float dist = distance(p, pt) * f0 ;
;
if(dist < d) {
closest = dist;
d = dist;
cpt = pt;
}
}

vec3 color = vec3( pow(min(1., closest*3. + f1), 7.) );

if(closest < f2)
//if(closest < 0.01)
{
color = vec3(0.7, 0.1, 0.1);
if(closest < 0.005)
color.x -= 0.5;
}

gl_FragColor = vec4(color , 1.0 );


} //endof main


