// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

#define PI 3.1415926535897932384626
float time = float(itime) + ftime;
vec2 resolution = tres;// for easier glslsandbox.com conversion

vec3 col1 = vec3(0.216, 0.471, 0.698); // blue
vec3 col2 = vec3(1.00, 0.329, 0.298); // yellow
vec3 col3 = vec3(0.867, 0.910, 0.247); // red

//f0:bulge zoom 1:
//f1:bulge zoom 2:
//f2:red thickness:
float f0 = mix(0.3, 0.95, fparams[0]);
float f1 = mix(0.3, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float disk(vec2 r, vec2 center, float radius) {
return 1.0 - smoothstep( radius-0.008, radius+0.008, length(r-center));
}

//---------------------------------------------------------------------------------------------------
// https://www.shadertoy.com/view/Xs2GDd
void main(void) {

float t = time*2.;
//vec2 r = (2.0*tcoord.xy) / tres.y;
vec2 r = (2.0*tcoord.xy) * f0;
r *= 1.0 + 0.05*sin(r.x*5.+time) + 0.05*sin(r.y*3.+time);
r *= 1.0 + 0.2*length(r);
float side = f1;
vec2 r2 = mod(r, side);
vec2 r3 = r2-side/2.;
float i = floor(r.x/side)+2.;
float j = floor(r.y/side)+4.;
float ii = r.x/side+2.;
float jj = r.y/side+4.;

vec3 pix = vec3(1.0);

float rad, disks;

rad = 0.15 + f2 * .5 *sin(t+ii*jj);
disks = disk(r3, vec2(0.,0.), rad);
pix = mix(pix, col2, disks);

float speed = 2.0;
float tt = time*speed+0.1*i+0.08*j;
float stopEveryAngle = PI/2.0;
float stopRatio = 0.7;
float t1 = (floor(tt) + smoothstep(0.0, 1.0-stopRatio, fract(tt)) )*stopEveryAngle;

float x = -0.07*cos(t1+i);
float y = 0.055*(sin(t1+j)+cos(t1+i));
rad = 0.1 + 0.05*sin(t+i+j);
disks = disk(r3, vec2(x,y), rad);
pix = mix(pix, col1, disks);

rad = 0.2 + 0.05*sin(t*(1.0+0.01*i));
disks = disk(r3, vec2(0.,0.), rad);
pix += 0.2*col3*disks * sin(t+i*j+i);

pix -= smoothstep(0.3, 5.5, length(r));
gl_FragColor = vec4(pix,1.0);

} //endof main


