// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:red length:
//f1:green length:
//f2:blue length:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

float PI = 3.1415926535;
float sections = 6.0;

float atan2(in float y, in float x) {
    return x == 0.0 ? sign(y) * PI / 2.0 : atan(y, x);
}

bool belongs(float time, vec2 uv, float near, float far, float sections) {
    near += sin(uv.x - time * 8.0) / 50.0;
    far += cos(uv.y - time * 8.0) / 50.0;
    vec2 center = vec2(0.5, 0.5);
    vec2 xy = uv - center;
    float dist = distance(xy, vec2(0.0, 0.0));
    float angle = mod(atan2(xy.y, xy.x) + time * 2.5 + sin(time * 4.0) / 1.0, PI * 2.0);
    float oddity = mod(angle / (2.0 * PI) * sections * 2.0, 2.0);
    if (dist > near && dist < far && floor(mod(oddity, 2.0)) == 0.0) {
        return true;
    } else {
        return false;
    }
}

//---------------------------------------------------------------------------------------------------
void main(void) {
    
    float r,g,b = 0.;
    vec2 UV = gl_FragCoord.xy/resolution.yy;
    UV.x -= (resolution.x / resolution.y - 1.0) / 2.0;

    //if (belongs(time, UV, 0.2, .25, 3.0) { gl_FragCoolor += vec4(1.0, 0.0, 0.0, 0.0);}
    //if (belongs(time + 0.5, UV, 0.3, 0.35, 6.0) { gl_FragCoolor += vec4(0.0, 1.0, 0.0, 0.0);    } 
    //if (belongs(time + 1.0, UV, 0.4, 0.45, 8.)) { gl_FragCoolor += vec4(0.0, 0.0, 1.0, 0.0);    }

    if (belongs(time,       UV, 0.1, .15  + (.2 * f0), 8.0) ) { r = 1.0; }
    if (belongs(time + 0.5, UV, 0.2, 0.35 + (.2 * f1), 6.0) ) { g = 1.0; } 
    if (belongs(time + 1.0, UV, 0.35, 0.45 + (.4 * f2), 4.0) ) { b = 1.0; }
   
    gl_FragColor = vec4(r, g, b, 1.0);
} //endof main


