// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:ring thickness:
//f1:ring brightness:
//f2:ring offset:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
// Based on davedes simple circle outline, not the best technique...

void main( void ) {

vec3 color;
const float smooth1 = 10.0;
const float smooth2 = 100.0;
vec2 c = resolution *0.5;
for (float i = 1.; i < 8.; ++i) {
float s = mod(time,i);
s = (s > 3.) ? 32. * f2 -s : s / f2;
float dist = resolution.y/s - distance(gl_FragCoord.xy, c);
vec3 clr = vec3(dist);
clr = mix(vec3(f1), vec3(0.0), smoothstep(smooth1, smooth2, dist*dist * f0));
clr = clamp(clr, 0.0, 1.0);
clr *= vec3(pow(1.02,i*i),20./s,s*i);
float m = fract(time*0.1)*0.5;
m = m > 0.25 ? 0.5-m : m;
m *= .5;
color = mix(color,clr,m);
}
gl_FragColor = vec4(color, 1.0 );

}


