// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;//
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:blade count:
//f1:zoom:
//f2:y pos:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;


const float PI=3.14159;

vec4 getTexture(vec2 p) {
float t = time;
vec4 color = vec4(0.,0.,0., 0.);

float a0 = (fract(0.+ p.x * .2) < .3)?0.:1.;
float b0 = (fract(t + p.y * .1) < .7)?0.:1.;

float a1 = (fract(.2 + p.x * .7) < .13)?0.:1.;
float b1 = (fract( t -  p.y * .2) < .25)?0.:1.;

color = (a1*b1) + a0*b0 * vec4(1,0,1, 1);

return color * .5;
}


vec3 tunnel_uvw(vec2 pos) {
float u = length(pos);
return vec3 (u, atan(pos.y, pos.x), 1.0/u);
}

vec3 tunnel_coord(vec2 p, float frekv, float radius, vec3 eltolas, vec3 nezet, vec3 irany) { 
vec3 cp=eltolas, ct=cp+nezet, cd=normalize(ct-cp);
vec3 cr=normalize(cross(cd,irany)), cu=cross(cr,cd), rd=normalize(radius*cd+cr*p.x+cu*p.y);
vec3 o = cp;
vec3 d = rd;
float D=1./(d.y*d.y+d.z*d.z);
float a=(o.y*d.y+o.z*d.z)*D;
float b=(o.y*o.y+o.z*o.z-36.)*D;
float t=-a-sqrt(a*a-b);
o+=t*d;

return vec3(o.x, atan(o.y,o.z)*(frekv/PI), t);
}


//---------------------------------------------------------------------------------------------------
void main(void) {

vec2 position = ( gl_FragCoord.xy / resolution.y);
float aspectRatio = ( resolution.x / resolution.y); 

float ttime = 0.;

vec3 tunnel_pos = tunnel_coord(
position-vec2(aspectRatio*.5,f2), 
10.*f0, 
.125 * f1, 
vec3(-5.*ttime, sin(2.*ttime), cos(2.*ttime)),
vec3(1., 0., 0.), 
vec3(0.,cos(cos(ttime)),sin(sin(ttime)))
);
tunnel_pos += time;

gl_FragColor.rgb =  (1.+.05*tunnel_pos.z) * getTexture(tunnel_pos.xy).rgb;
gl_FragColor.a = 1.0;
}


