// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:zoom:
//f1:blades 1:
//f2:blades 2:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

float ring(vec2 pos, vec2 center){
return length(pos - center);
}

void main( void ) {

vec2 position = gl_FragCoord.xy / resolution.y - vec2(resolution.x / resolution.y / 2.0, 0.5);

float radius = ring(position, vec2(0.0, 0.0));
float depth = f0 / radius + 0.2;
float angle = atan(position.y, position.x);
vec3 pos = vec3(position*depth, depth);


vec3 color = vec3(0, 0, 0);

if(mod(floor(depth + time), 2.0) == 0.0)
color = vec3(0.9, 0.9, 0.9);
else
color = vec3(0.2, 0.2, 0.2);

vec3 lightpos = vec3(0, 0.4, mod(floor(depth), 10.0));

color += 0.5 / pow(length(pos - lightpos), 2.0);

float t = time;
float a = atan(position.x, sin(position.y*2.0)*4.0 / f1);
a += t* (0.4 +f2 *0.005);
a = fract(a) + sin(t*1.0)*0.1;
a = float(a > .3) + float(a < .2);

gl_FragColor = vec4(a*color, 1.0 );

}


