// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:grid thickness:
//f1:grid rotate:
//f2:white amount:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);


float time = float(itime) + ftime;
vec2 resolution = tres;
// posted by Trisomie21

const float pi_2_f = 3.1416*2.0;
float lineTickness = f0 * 4.;
float lumaCount = 50.0;
float hueCount = 50.0 + f1;

void main( void ) {

vec2 position =  gl_FragCoord.xy - (resolution.xy/2.0);

float d = length(position);

float v = mod(d + time/20.0*resolution.x + resolution.x/(lumaCount*2.0), resolution.x/lumaCount);
v = abs(v - resolution.x/(lumaCount*2.0)) - lineTickness;

float angle = acos(position.y/d) / pi_2_f;
if(position.x>0.0) angle += (0.5-angle)*2.0;
angle += time/60.0;

float unit = d * pi_2_f;
float a = mod(angle*unit + unit/(hueCount*2.0) , unit/hueCount);
a = abs(a - unit/(hueCount*2.0)) - lineTickness;
a = clamp(a, 0.0, 1.0);

angle += .05;
float u = 100.0;
float r = mod(angle*u + u/(5.0*2.0) , u/5.0);
r = abs(r - u/(5.0*2.0)) - 1.0;
r = clamp(r, 0.0, 1.0);

d /= length(resolution.xy);
v = min(v, a)*d / f2;

float dr = .2+(sin(time*1.1)+1.0)/8.0;
float dg = .2+(sin(time*1.2)+1.0)/8.0;
float db = .2+(sin(time*1.4)+1.0)/8.0;
gl_FragColor = vec4(v/(r+dr),v/(r+dg),v/(r+db),1);
}


