// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:zoom:
//f1:color pos 1:
//f2:color pos 2:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.5, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
// @mod* rotwang

float rand(vec2 co){
    return fract(sin(dot(co.xy ,vec2(0,0))) * 431.5453);
}

void main() {
float tmin = time*0.25;
vec2 pos = -1.0 + 2.0 * gl_FragCoord.xy / resolution;
pos.x *= (resolution.x / resolution.y);

float u = length(pos)*2.0;
float v = atan(pos.y, pos.y);
float t = tmin + 8.0 / u * f0;

vec3 color = vec3(abs(asin(t * 4.0 + v))) * u *f1 ;
color += vec3(abs(sin(t - v))) * u * 0.29;

color.y *=  f2;
color.z *= 0.2;
color.yz *= rand(vec2(t, v)) +u*u;

gl_FragColor = vec4(color, 1.0);
}


