// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:center x:
//f1:center y:
//f2:zoom:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);


float time = float(itime) + ftime;
vec2 resolution = tres;
uniform sampler2D backbuffer;
vec2 center = vec2(0.5,0.5*resolution.y/resolution.x);

vec4 checker3D(vec3 texc, vec4 color0, vec4 color1) {
  if (mod((floor(texc.x) + floor(texc.y) + floor(texc.z)),2.0) == 0.0)
    return color0;
  else
    return color1;
}

vec3 RotateZ( const in vec3 vPos, const in float fAngle ) {
float s = sin(fAngle);
float c = cos(fAngle);

vec3 vResult = vec3( c * vPos.x + s * vPos.y, -s * vPos.x + c * vPos.y, vPos.z);

return vResult;
}

void main( void ) {
vec2 position = gl_FragCoord.xy/resolution+vec2(-1.) * vec2(f0,f1);
position *= vec2(50.,50.*resolution.y/resolution.x) + 40. * f2;
vec2 mousep = vec2(f0, f1);// * vec2(50.,50.*resolution.y/resolution.x);
float color = distance(mousep,gl_FragCoord.xy/resolution.xy)*4.0;
position.xy += RotateZ(vec3(position,1.0), time+0.1*distance(position, vec2(0,0))).xy;
gl_FragColor = checker3D(vec3(position,0)*0.2,vec4(1),vec4(0))+0.95*texture2D(backbuffer, gl_FragCoord.xy/resolution.xy);
}


