// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:square size:
//f1:center shade:
//f2:square offset:

float f0 = mix(0.05, 0.5, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

// http://glslsandbox.com/e#39157.2

float time = float(itime) + ftime;
//---------------------------------------------------------------------------------------------------
void main(void) {

vec2 pos = ( gl_FragCoord.xy / tres.xy ) - vec2(0.5,0.5);
        float horizon = 0.0; 
        float fov = 0.6 *f0 ; 
float scaling = 0.1+0.3*sin(0.1*abs(pos.x));

vec3 p = vec3(pos.x, fov, pos.y*0.6 - horizon);      
vec2 s = vec2(p.y/p.x, p.y/p.z) * scaling;

//checkboard texture

float dupa = 1.0 *f2;

//if(pos.y < 0.0) dupa = .0;

float color = sign((mod(4.*s.x * 0.5+0.08*sin(time), 0.1) - 0.05) * (mod(s.y + dupa * mod(time * 0.05, 1.5), 0.1) - 0.05));

//Shading closer to the axes
color *= smoothstep(0.,0.2, abs(pos.x)) * smoothstep(0., 0.1 + (f1), abs(pos.y));


gl_FragColor = vec4( vec3(color), 1.0 );
   
} //endof main


