// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:sun bright:
//f1:size:
//f2:speed:

float f0 = mix(0.1, 0.95, fparams[0]);
float f1 = mix(0.25, 0.95, fparams[1]);
float f2 = mix(0.2, 0.5, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

mat2 rot (float angle){
return mat2(cos(angle),-sin(angle),sin(angle),cos(angle));
}

//---------------------------------------------------------------------------------------------------
// http://glslsandbox.com/e#38101.0
void main(void) {

  
vec2 p = 2. * tcoord - .5; // was surfacePosition

vec3 color = vec3(1.0);

p.x+=0.1*cos(time);
p*= rot(45.0);
p*= rot(0.0 + 0.1*sin(time));

vec3 pos =  vec3 (p.x, 0.5, abs(p.y))*3.0;
vec2 sur =  vec2 (pos.x/pos.z, pos.y/pos.z)/9.0/f1;

sur.y += time/2.0+sin(time/4.0) / f2;
float f = (sign((mod(sur.x,0.5)-0.1) * (mod(sur.y,0.3)-0.1)));
f*= pos.z*pos.z*5.0;

p*= rot(11.0 + 0.1*sin(time));

vec3 pos1 =  vec3 (p.x, 0.5, abs(p.y))*2.0;
vec2 sur1 =  vec2 (pos1.x/pos1.z, pos1.y/pos1.z)/9.0/f1;
sur1.y += time/2.0+sin(time/4.0) / f2;
float sf = (sign((mod(sur1.x,0.5)-0.1) * (mod(sur1.y,0.3)-0.1)));
sf*= pos1.z*pos1.z*2.0;

float l  =    0.1+0.05*abs(clamp(sin(time/4.0),0.1,0.5))/length(p-vec2(.07*sin(time),   0.007*sin(time/2.2)));
float l1 =l + 0.1+0.01*abs(clamp(sin(time/4.0),0.1,0.5))/length(p-vec2(.07*sin(time/1.2),0.07*sin(time/2.1)));
f+=(l+l1) / f0;

color.b=  sf*f;
color.g=  f+sf;
color.b+=-f+sf;


gl_FragColor = vec4(mix(color,vec3(0.1*f,0.15*f,.25*f*sf),0.75),1.0);
 
} //endof main


