// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
//
//
// .default fragment shader

varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

//---------------------------------------------------------------------------------------------------
// metadata
// source : http://glslsandbox.com/e#36069.0

const float PI = 3.14159265;
//f0:center zoom:
//f1:outer inertia:
//f2:center bright:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.25, 0.9, fparams[1]);
float f2 = mix(0.05, 0.8, fparams[2]);


float check(vec2 p, float size) {
return mod(floor(p.x * size) + floor(p.y * size),2.0);
}


void main() {

float mytime = float(itime) + ftime;

vec2 p = ((gl_FragCoord.xy / tres) - 0.5) * (1.0 + 2.0*f0) ;
p.x *= tres.x/tres.y ;

//inertia towards the edges
float t = sin(mytime*10. - 4.0*distance(p, vec2(0.0)))*f1;
p *= mat2(cos(t), -sin(t),
  sin(t),  cos(t)
);

gl_FragColor = vec4(check(p, 3.0) * (1.0/length(p))*f2);
gl_FragColor.w = 1.0;




} //endof main


