// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

float time = float(itime) + ftime;
vec2 resolution = tres;// for easier glslsandbox.com conversion

//f0:arc thickness:
//f1:arc dense+rotate:
//f2:num rings:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.3, 0.8, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

#define TAU 6.28318531

float rand(float x){return fract(sin(x)*1e4);}
float rds(float x) {return -1.+2.*step(.5 *fparams.x,rand(x));}

//---------------------------------------------------------------------------------------------------
// https://www.shadertoy.com/view/4dXfR7
void main(void) {

//    vec2 uv = (tcoord.xy -.5)/tres.y;
    vec2 uv = tcoord.xy - 0.5;

    //float r=length(uv)* (50. * f0 + 10.);
    float r=length(uv)* 50.;
    float ri=floor(r);
    float sg=floor(10.+rand(ri)*10.0);

    //float sp=rds(ri*15.)*(.1+.4*rand(ri*70.));// .4 is speed
    float sp=rds(ri*15.)*(.1+.4*rand(ri*70.));// .4 is speed
    float a=floor(fract(atan(uv.y,uv.x)/TAU+time*sp)*sg / f1);
    float c=step(.7,rand(a+ri*40.));
    c*=smoothstep(-.9,-.85,sin(time*rand(ri*805.)));
    c*=step(f0,fract(r));
    c*=step(2.,ri)-step(30. * f2, ri);
    gl_FragColor = vec4(c, c, c, 1.0);

} //endof main


