// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:scale:
//f1:arc length:
//f2:arc size:
float f0 = mix(0.25, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.15, 0.35, fparams[2]);


float time = float(itime) + ftime;
vec2 resolution = tres;

#define PI 3.1415927
#define PI2 (PI*2.0)
// http://glsl.heroku.com/e#7109.0 simplified by logos7@o2.pl

void main(void) {
vec2 position = 100.0 * ((2.0 * gl_FragCoord.xy - resolution) / resolution.xx) ;

float r = 2.0*length(position) * f0;
float a = atan(position.y, position.x) * f1;
float d = r  - a + PI2;
float n = PI2 * float(int(d / PI2)) *f2*0.6;
float k = a + n;
float rand = sin(1.0*floor(0.015 * k * k + (0.3*time)));

gl_FragColor.rgba = vec4(fract((0.1*time)*rand*vec3(1.0, 2.0, 6.0)), 1.0);
}


