// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:zoom:
//f1:density:
//f2:spotlight:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.5, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);
// http://glslsandbox.com/e#40690.0
float time = float(itime) + ftime;

vec2 sphIntersect( in vec3 ro, in vec3 rd) {

float b = dot( ro, rd );
float c = dot( ro, ro )-81.0;
float h = b*b - c;
if( h<0.0 ) return vec2(-1.0,-2.0);
return vec2(-b - sqrt( h ),-b+sqrt(h));
}

vec4 insidebox(vec3 pos, vec3 dir) {
    vec3 lens = (1.0-pos*sign(dir))/abs(dir)*step(abs(pos),vec3(1.0 * (f1*2.)));
    float len = min(min(lens.x,lens.y*f1),lens.z);
    return vec4(len,lens);
}
//---------------------------------------------------------------------------------------------------
void main(void) {

    time *= .5;
    vec2 uv = (gl_FragCoord.xy * 2.0 - tres.xy) / tres.y;
    
    vec3 pointlight = vec3(4.0,0.0,-10.0);
    
    vec3 pos = 1.-1./(vec3(cos(time)*3.0,sin(time)*3.0,-20.0));
    vec3 dir = normalize(vec3(uv,1.5 * f0));
    
    vec2 len = sphIntersect(pos,dir);
   pos += mix(len.x,len.y,sin(time)*0.5+0.5)*dir;
    vec3 normal = normalize(pos);
    vec4 len2 = insidebox(mod(pos,2.4)-1.2, dir);

    if (len2.x > 0.0) {
        normal = -step(len2.yzw,len2.xxx)*sign(dir);
    }

    if(len.y > len.x) {
        gl_FragColor = vec4(abs(normal),1.0);
        
        vec3 lightnorm = (pointlight-pos);
        float lightdist = length(lightnorm);
        lightnorm /= lightdist * f2;
        
        gl_FragColor = vec4(max(dot(normal,lightnorm),0.1));
        
    } 
   
} //endof main


