// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:horz count:
//f1:vert count:
//f2:color offset:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);


float time = float(itime) + ftime;
vec2 resolution = tres;

vec3 hsv(float h,float s,float v) { return mix(vec3(1.),clamp((abs(fract(h+vec3(3.,2.,1.)/3.)*6.-3.)-1.),0.,1.),s)*v; }

void main( void ) {

float PI = 3.14159265358979323846264;

f0 += 0.001;
f1 += 0.001;

float alpha = 1.;
vec2 pos = -1.0 + 2.0 * gl_FragCoord.xy / resolution.xy;
pos.y = cos(pos.y * 2.);

pos.x = cos(pos.x * 2.);

float distanceFromCenter = sqrt(pos.x * (2.* f1 - 1.) * pos.x + pos.y * pos.y * (2. * f0 - 1.) );

float hue = (atan(pos.x, pos.y) / PI + time * 1.);
float value = (cos(distanceFromCenter * 100. + 10. * time) + 1.) / f2;

//gl_FragColor = vec4(0, value, 0, 1.); //vec4(hsv(hue, 1., value), 1.);
gl_FragColor = vec4(hsv(hue, 1., value), 1.);
}


