// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:reveal:
//f1:density:
//f2:block radius:

float f0 = mix(0.20, 1., fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

// http://glslsandbox.com/e#48993.1

float time = float(itime) + ftime;

// original https://twitter.com/beesandbombs/status/1035545423069503488
// forked https://www.shadertoy.com/view/XlVcW1
#define RAD .1
#define e ( 3. / tres.y )

float tt = .12 *f1;

float makeCircle(in vec2 uv, in vec2 c, in float r){
return smoothstep(e, 0., abs( distance(uv, c) - r /f2) );
}

float row(in vec2 uv){
    float color = 0.,
    s = sign(mod(floor((uv.y * .5 + .5)/RAD), 2.) - .5),
    rad = RAD/2. + RAD/2. * sin(uv.x * 4. - time * 1.5) * .75 * s;
    for(float i=-1.; i<5.; i++)
    color += makeCircle(mod(uv, RAD * 2.), vec2(i * tt, RAD), rad);
    return color;
}
//---------------------------------------------------------------------------------------------------
void main(void) {

    vec2 uv = (gl_FragCoord.xy * 2. - tres.xy)/tres.y + vec2(time * .05, 0.);
    gl_FragColor = vec4(row(uv) * step(abs(uv.y), .65 *f0));
   
} //endof main


