// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:mod 1:
//f1:mod 2:
//f2:mod 3:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

float circle(vec2 st, vec2 center, float radius) {
return 1. - smoothstep(radius, radius + .1, length(st - center));
}

mat4 translateMat(vec3 t) {
return mat4(
1., 0., 0., 0.,
0., 1., 0., 0.,
0., 0., 1., 0.,
t.x, t.y, t.z, 1.
);
}

//---------------------------------------------------------------------------------------------------
void main(void) {

//mouse.x = sin(time);
//mouse.y = 1. - cos(time);

vec2 st = (gl_FragCoord.xy / resolution) * 2.0 - 1.0;
st.x *= resolution.x / resolution.y;
vec2 m = vec2(f0,f1) * 2. - 1. *f2;

vec3 vup = vec3(0., 1., 0.);
vec3 cam = vec3(m.x, m.y, 1.);
vec3 tar = vec3(0., 0., 0.);

vec3 back = normalize(cam - tar);
vec3 right = normalize(cross(vup, back));
vec3 up = cross(back, right);

mat4 viewM = mat4(
right.x, right.y, right.z, 0.,
up.x, up.y, up.z, 0.,
back.x,back.y, back.z, 0.,
0., 0., 0., 1.
);

float v = 0.;

for(int x = -2; x <= 2; x++) {
for(int z = -2; z <=2; z++) {
vec3 p = vec3(float(x), 0., float(z));
p = (viewM * vec4(p, 1.)).xyz;
v += circle(st, p.xy *sin(time) * 2., 0.2);
}
}

gl_FragColor = vec4(vec3(v), 1.);
   
} //endof main


