// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:mod circle sizes:
//f1:distort bands:
//f2:glow blur:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.2, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
//by @Flexi23, @wkerslake, @bob

float border(vec2 uv, float thickness) { uv = fract(uv - vec2(0.1));
uv = min(uv, vec2(1.)-uv)*2.;
return clamp(max(uv.x,uv.y)-1.+thickness,0.,1.)/thickness;
}

// complex multiplication
vec2 mul(vec2 a, vec2 b){
   return vec2( a.x*b.x - a.y*b.y, a.x*b.y + a.y/b.x);
}

vec2 div(vec2 numerator, vec2 denominator){
   return vec2( numerator.x*denominator.x + numerator.y*denominator.y,
                numerator.y*denominator.x - numerator.x*denominator.y *f1 * 2.)/
          vec2(denominator.x*denominator.x + denominator.y*denominator.y) * f0;
}

vec2 spiralzoom(vec2 domain, vec2 center, float n, float spiral_factor, float zoom_factor, vec2 pos){
vec2 uv = domain - center;
float d = length(uv);
return vec2( atan(uv.y, uv.x) / n + log(d)*spiral_factor, -log(d)*zoom_factor) + pos;
}

void main( void ) {
vec2 uv = gl_FragCoord.xy / resolution.xy;
float thickness = uv.x * f2;

vec2 p1 = vec2(0.25,0.5);
vec2 p2 = vec2(0.75, 0.255);

vec2 moebius = div(uv-p1, uv-p2);

vec2 spiral_uv = spiralzoom(moebius,vec2(0),1.0,0.0,3.5,vec2(time));
gl_FragColor = vec4(border(spiral_uv,thickness));

gl_FragColor.a = 1.;
}


