// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
//
//
// .default fragment shader

varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

//---------------------------------------------------------------------------------------------------
// metadata
// http://www.glslsandbox.com/e#43335.2
#define PI 3.1415926535897932384626
float time = float(itime) + ftime;
vec2 resolution = tres;// for easier glslsandbox.com conversion

//f0:horz move:
//f1:vert move:
//f2:complexity+diag:
float f0 = mix(0.2, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);


const int   complexity      = 16;   // More points of color.
float mouse_factor    = 0.003; // Makes it more/less jumpy.
float mouse_offset    = f2 + 0.5;  // Drives complexity in the amount of curls/cuves.  Zero is a single whirlpool.
float fluid_speed     = .05;  // Drives speed, smaller number will make it slower.
float color_intensity = 0.7 ;

const float Pi = 3.14159;

// see http://devmaster.net/forums/topic/4648-fast-and-accurate-sinecosine/
float sinApprox(float x) {
  x = Pi + (2.0 * Pi) * floor(x / (2.0 * Pi)) - x;
  return (4.0 / Pi) * x - (4.0 / Pi / Pi) * x * abs(x);
}


//---------------------------------------------------------------------------------------------------
void main(void) {

  vec2 p = (2.0*gl_FragCoord.xy - resolution) / max(resolution.x, resolution.y);
  for(int i=1; i <= complexity; i++) {
    p.x += 0.2/float(i)*sinApprox(float(i)*p.y + time*fluid_speed+0.3*float(i+5)) + (f0*tres.x) * mouse_factor + mouse_offset;
    p.y += 0.2/float(i)*sinApprox(float(i)*p.x + time*fluid_speed+0.3*float(i+10)) + (f1*tres.y) * mouse_factor + mouse_offset;
  }
  gl_FragColor = vec4(
    color_intensity*sinApprox(4.0*p.x) + color_intensity,
    color_intensity*sinApprox(4.0*p.y) + color_intensity,
    color_intensity*sinApprox(p.x+p.y) + color_intensity, 1.0);

} //endof main


