// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
//cut uniform sampler2D tex;// texture one
//cut uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:center x:
//f1:center y:
//f2:spoke brightness:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);


vec2 mouse = vec2(fparams.x, fparams.y);
float time = float(itime) + ftime;
vec2 resolution = tres;

// added a little hack to effectively keep the thickness of the white lines constant in screen-space,

//cut uniform float time;
//cut uniform vec2 mouse;
//cut uniform vec2 resolution;

vec3 rotXY(vec3 p, vec2 rad) {
vec2 s = sin(rad);
vec2 c = cos(rad);

mat3 m = mat3(
c.y, 0.0, -s.y,
-s.x * s.y, c.x, -s.x * c.y,
c.x * s.y, s.x, c.x * c.y
);
return m * p;
}

vec2 repeat(vec2 p, float n) {
vec2 np = p * n;
vec2 npfrct = fract(np);
vec2 npreal = np - npfrct;
np.x += fract(npreal.y * 0.5);

return fract(np) * 2.0 - 1.0;
}

float hexDistance(vec2 ip) {
const float SQRT3 = 1.732050807568877;
const vec2 TRIG30 = vec2(0.25, 0.866025403784439); //x:sine, y:cos

vec2 p = abs(ip * vec2(SQRT3 * 0.5, 0.5+sin(time)*0.5));
float d = dot(p, vec2(-TRIG30.x, TRIG30.y)) - SQRT3 * 0.125;

return (d > 0.0)? min(d, (SQRT3 * 0.5 - p.x)) : min(-d, p.x);
}

float smoothEdge(float edge, float margin, float x) {
return smoothstep(edge - margin, edge + margin, x);
}

void main(void) {
const float PI = 3.1415926535;
vec3 rgb;

vec2 nsc = (gl_FragCoord.xy - resolution * 0.5) / resolution.yy * 2.0;
vec3 dir = normalize(vec3(nsc, -2.0));
dir = rotXY(dir, vec2((mouse.yx - 0.5) * PI * 0.35 * f2));
//dir = rotXY(dir, vec2(( 0.0) * PI * 0.35));
vec2 uv = vec2(atan(dir.y, dir.x) / (PI * 2.0) + 0.5, dir.z / length(dir.xy));

float t= time*0.25;
vec2 pos = uv * vec2(1.0, 0.2) - vec2(t * 0.05, t * 0.5);

vec2 p = repeat(pos, 3.0);

float d = hexDistance(p);
float dist = dir.z/length(dir.xy);
d/=-dist;
float fade = 1.0 / pow(1.0 / length(dir.xy) * 0.3, 2.0);
fade = clamp(fade, 0.0, f2);
rgb  = mix(vec3(1.0)*fade, vec3(0.0), smoothEdge(0.03, 0.01, d));
rgb += mix(vec3(1.0, 0.6, 0.0)*fade, vec3(0.0), smoothEdge(0.03, 0.5, d)) * 0.5;
rgb += mix(vec3(1.0, 0.6, 0.0)*fade, vec3(0.0), smoothEdge(0.03, 1.0, d)) * 0.15;

rgb = mix(rgb, vec3(0.0,1.0,0.0),dir.y);
gl_FragColor = vec4(rgb, 1.0);

}


