// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:ripples:
//f1:zoom:
//f2:colors:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

#define PI 3.1415927
#define PI2 (PI*2.0)
//---------------------------------------------------------------------------------------------------
// http://glslsandbox.com/e#51601.0
void main(void) {

vec2 position = f1 * 64.0 * ((2.0 * gl_FragCoord.xy - resolution) / resolution.xx);

float r = length(position);
float a = atan(sin(position.x), cos(position.y) ) + 1. *PI2 ;
float d = r - a + PI2; 
float n = PI2 * float(int((d / PI2)));
float da = a + n;
float pos = (PI*0.02*f0/10.0*da * da - time/5.);
vec3 norm;
norm.xy = vec2(fract(pos) - .5, fract(d / PI2) - .5)*2.0 * f2;
pos = floor(pos);
float len = length(norm.xy);
vec3 color = vec3(0.0);
if (len < 1.0)
{
norm.z = sqrt(1.0 - len*len);
vec3 lightdir = normalize(vec3(0.0, 1.0, 1.0));
float dd = dot(lightdir, norm);
dd = max(dd, 0.25);
color = dd*vec3(0.5*cos(pos+2.0)+0.5, 0.5*cos(pos+4.0)+0.5, 0.5*cos(pos)+0.5);
vec3 halfv = normalize(lightdir + vec3(0.0, 0.0, 1.0));
float spec = dot(floor(halfv), norm);
spec = max(spec, 0.0);
spec = pow(spec, 50.0);
color += vec3(spec);
}

color = fract(color*(10.*f1));


gl_FragColor.rgba = vec4(color,1.0);
   
} //endof main


