// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:offset:
//f1:blur:
//f2:scroll:

float f0 = mix(0.4, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.75, 0.95, fparams[2]);

// http://glslsandbox.com/e#39994.0

float time = float(itime) + ftime;

#define PI 3.14159265359
#define TWO_PI 6.28318530718

vec3 colorA = vec3(f0,0.0,1.0);
vec3 colorB = vec3(1,f1,1);
vec3 colorC = vec3(1.0,0.0,f2);

vec3 hsb2rgb(in vec3 c) {
vec3 rgb = clamp( abs( mod(c.x * 6.0 + vec3(0.0,4.0,2.0), 6.0) -3.0) - 1.0, 0.0, 1.0);
return rgb;
}


vec3 hsb2rgb_smooth(in vec3 c) {
vec3 rgb = clamp( abs( mod(c.x * 6.0 + vec3(0.0,4.0,2.0), 6.0) -3.0) - 1.0, 0.0, 1.0);
rgb = rgb * rgb * (3.0-2.0*rgb);
return rgb;

}

vec3 palette( in float t, in vec3 a, in vec3 b, in vec3 c, in vec3 d ) {
d/= f0 * .8;
b/= f1;
c*= f2;
    return a + b*cos( 6.28318*(c*t+d) );
}


//---------------------------------------------------------------------------------------------------
void main(void) {

vec2 uv = gl_FragCoord.xy / tres.xy;

vec2 center = vec2(0.5)-uv;
float angle = atan(center.y, center.x);
float rad = length(center) / 2.0;

uv.x += 0.03 * time;

//vec3 color = palette(angle/TWO_PI, vec3(0.5), vec3(0.5), vec3(1.0), vec3(0., 0.33, 0.67));
vec3 color;
 color = palette(uv.x, vec3(0.5), vec3(0.5), vec3(1.0), vec3(0., 0.33, 0.67));
if(uv.y > (1.0/7.0)) color = palette(uv.x, vec3(0.5), vec3(0.5), vec3(1.0), vec3(0., 0.10, 0.20));
if(uv.y > (2.0/7.0)) color = palette(uv.x, vec3(0.5), vec3(0.5), vec3(1.0), vec3(0.3, 0.2, 0.2));
if(uv.y > (3.0/7.0)) color = palette(uv.x, vec3(0.5), vec3(0.5), vec3(1.0,1.0,0.5), vec3(0.8, 0.9, 0.3));
if(uv.y > (4.0/7.0)) color = palette(uv.x, vec3(0.5), vec3(0.5), vec3(1.0,0.7,0.4), vec3(0.0, 0.15, 0.20));
if(uv.y > (5.0/7.0)) color = palette(uv.x, vec3(0.5), vec3(0.5), vec3(2.0,1.0,0.0), vec3(0.5, 0.2, 0.25));
if(uv.y > (6.0/7.0)) color = palette(uv.x, vec3(0.8,0.5,04), vec3(0.2,0.4,0.2), vec3(2.0,1.0,1.0), vec3(0.0, 0.25, 0.25));

//band
float f = fract(uv.y * 7.0);
color *= smoothstep(0.50, 0.46, abs(f-0.5));

//shadow
color *= 0.5 + 0.5* sqrt(4.0*f*(1.0-f));

vec3 hsl = vec3(uv.x, 1.0, uv.y);
//vec3 rgb_o = hsb2rgb(hsl);
//vec3 rgb_o = hsb2rgb_smooth(hsl);
//vec3 color = hsb2rgb_smooth( vec3( ( (angle/TWO_PI)) + 0.5, rad, 1.0));


gl_FragColor = vec4(color,1.0);
   
} //endof main


