// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
//
//
// .default fragment shader

varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

//---------------------------------------------------------------------------------------------------
// source :  http://glslsandbox.com/e#35836.0
#define PI 3.1415926535897932384626

#define F 4.0
//f0:ring colors1:
//f1:ring colors2:
//f2:ring colors3:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

//---------------------------------------------------------------------------------------------------
void main(void) {

float time = float(itime) + ftime;
    vec2 p = ( gl_FragCoord.xy / tres.xy ) *2.0 - 1.0;

    p.x *= tres.x / tres.y * clamp(sin(f0),0.05,0.95);
    p.y *= tres.x / tres.y * clamp(sin(f0), 0.05,0.95);

    float l = length(p) + f1;

float x = cos(1.0 * PI * F * l- 1.5 * time) * f0;
float y = cos(2.0 * PI * F * l) * -f2;
float z = cos(3.0 * PI * F * l- 2.0 * time);

gl_FragColor = vec4(x,y,z, 1.0);

} //endof main


