// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:horz center:
//f1:vert center:
//f2:highlights:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
/* fragment fun by guti */

float K = (1.0/6.0);
float K2 = (16.0) * f2;
float K3 = (0.5/K2);

vec3 rgbFromHue(in float h) {
h = h - floor(h);
float r = smoothstep( 2.0*K, 1.3*K, h) + smoothstep( 4.0*K, 5.0*K, h);
float g = smoothstep( 0.0*K, 1.0*K, h) - smoothstep( 3.0*K, 4.0*K, h);
float b = smoothstep( 2.0*K, 3.0*K, h) - smoothstep( 5.0*K, 6.0*K, h);
return vec3(r,g,b);
}

void main( void ) {
vec2 rP = 2.0 * ( gl_FragCoord.xy / resolution.xy ) + vec2(f0,f1) * -2.;
rP *= vec2(resolution.x/resolution.y, 1.0);

vec2 P0 = vec2(sin(time*2.0013),cos(time*0.5999))*0.5;
vec2 P1 = vec2(cos(time*1.4011),sin(time*2.0007))*0.5;

float d0 = distance(rP,P0);
float d1 = distance(rP,P1);

vec3 color =  vec3( rgbFromHue(2.0/d0 - 2.0/d1 + time) * smoothstep(10.01, 10.0, 1.0/d0 + 1.0/d1));

float factor = resolution.x/K2;

color.r *= color.r*0.5+mod(gl_FragCoord.y, factor * d0) * K3;
color.g *= color.g*0.5+mod(gl_FragCoord.x, factor * d1) * K3;
color.b *= color.b*0.5+mod(gl_FragCoord.y - gl_FragCoord.x, factor * d0-d1) * K3;
gl_FragColor = vec4(color, 1.0);

}


