// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
	varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:line size:
//f1:saturation:
//f2:density:
float f0 = mix(0.0045, 0.15, fparams[0]);
float f1 = mix(0.00, 2.00, fparams[1]);
float f2 = mix(0.05, 1.0, fparams[2]);

// http://www.glslsandbox.com/e#42046.1
float time = float(itime) + ftime;
vec2 resolution = tres;// for easier glslsandbox.com conversion

void main(void) {

   vec2 tcoordshift = tcoord;
   tcoordshift.x = (((tcoordshift.x-0.5)*2.0)*5.0/4.0)/2.0 + 0.5;

   tcoordshift = mod((tcoordshift-0.5)*2.0,f2);


   float size = f0;
   float color = 0.0;

   vec4 outc = vec4(0.0, 0.0, 0.0, 1.0);

   if( tcoordshift.x < size || (f2-tcoordshift.x) < size ){
      outc.xyz = vec3(1.0-tcoord.x,0.0,tcoord.x);
      color=1.0;
   }
           
   if( tcoordshift.y < size || (f2-tcoordshift.y) < size){   
      outc.xyz = vec3(1.0,1.0-tcoord.y,tcoord.y);
      color=1.0; 
   }

   if(color>0.0){
      float fn = f1;
      if(fn>1.0){
         fn = fn - (f1-1.0)/1.5;
      }
      outc.rgb = mix(vec3(1.0),outc.rgb,fn);
   }

   gl_FragColor = vec4(outc);
} //endof main


