// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:horz stretch:
//f1:vert stretch:
//f2:white level:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);


float time = float(itime) + ftime;
vec2 resolution = tres;

vec4 textureRND2D(vec2 uv){
uv = floor(fract(uv)*1e3);
float v = uv.x+uv.y*1e3;
return fract(1e5*sin(vec4(v*1e-2, (v+1.)*1e-2, (v+1e3)*1e-2, (v+1e3+1.)*1e-2)));
}

float noise(vec2 p) {
vec2 f = fract(p*1e3);
vec4 r = textureRND2D(p);
f = f*f*(3.0-2.0*f);
return (mix(mix(r.x, r.y, f.x), mix(r.z, r.w, f.x), f.y));
}

vec3 plasma(vec2 uv) {
   float x = uv.x*400.;
   float y = uv.y*400.;
   float mov0 = x+y+cos(sin(time)*2.)*100.+sin(x/100.)*1000.;
   float mov1 = y / resolution.y / 0.2 + time;
   float mov2 = x / resolution.x / 0.2;
   float c1 = abs(sin(mov1+time)/2.+mov2/2.-mov1-mov2+time);
   float c2 = abs(sin(c1+sin(mov0/1000.+time)+sin(y/40.+time)+sin((x+y)/100.)*3.));
   float c3 = abs(sin(c2+cos(mov1+mov2+c2)+cos(mov2)+sin(x/1000.)));
   return vec3(c1,c2,c3);   
}



#define pi 3.141592653589793238462643383279
void main(void) {
    vec2 p = -1.0 + 2.0 * gl_FragCoord.xy / resolution.xy;
    vec2 m = -1.0 + 2.0 * vec2(f0, f1) / resolution.xy;

float frametime=time*2.0;
float i=(((p.x+1.0)/2.0)*40.0);
    float j=(((p.y+1.0)/2.0)*30.0);

    float intens = 1.0;
float x,y;
float x_2, y_2;


/*
// EFFECT 1
    x=i*0.05;
    y=j*0.05;    x+=y*exp(sin(x+frametime*0.7)*1.0)*0.52389;
    y+=(1.0-x)*exp(cos(y+frametime*4.2345)*1.0)*0.3;
    x+=(1.0-y)*exp(cos(y+frametime*2.0)*1.0)*0.24;
    y+=x*exp(sin(x+frametime*1.5234)*1.0)*0.3235;
    x+=y*(1.0-y)*sin(x+y+frametime*2.54)*0.3235;

// EFFECT 2
   float fak=(1.0-exp((0.0-frametime)*0.3))*64.0;
   float arms = 2.0;
   
float cj=(j-sin(frametime*0.5)*13.0-15.0);
   float ci=i-cos(frametime*1.3)*16.0-20.0;
   float cj2=(j-sin(1.234+frametime*.1)*13.0-15.0);
   float ci2=i-cos(2.342+frametime*0.443)*16.0-20.0;
   float at1=arms*atan(ci,cj);
   float at2=atan(ci2,cj2);
   x=i*0.05*(30.0+fak+fak*(1.0+sin((ci2-cj2)/10.0))*sin(frametime+2.0*(0.5*(at1+at2))))/256.0;
   y=j*0.05*(30.0+fak+fak*(1.0+cos((ci-cj)/10.0))*cos(frametime+2.0*(0.5*(at1+at2))))/256.0;

   intens = (sin(4.0*frametime+2.0*((at1+at2)))+1.0)/2.0;
   x_2 = sin(x*2.0);
   y_2 = cos(y*2.0);

*/
// EFFECT 3
    float x2,y2;

    x2=x=i*0.05 / f0 * .5;
    y2=y=j*0.05 / f1 * .5;

    float ff1=(1.0+sin(sin(x)+frametime*0.7)+cos(sin(y)+frametime*0.3));
    float ff2=0.5+0.5*sin(x+y+frametime*1.4);
    x+=max(ff1,ff2);

    ff1=(1.0+cos(sin(y)+frametime*0.345)+sin(sin(x)+frametime*0.64));
    ff2=0.5+0.5*cos(y+x+frametime*1.3);
    y+=max(ff1,ff2);

    x2+=(1.0+sin(sin(x2)+frametime*0.25)+cos(sin(y2)+frametime*0.3));
    y2+=(1.0+cos(sin(y)+frametime*0.565)+sin(sin(x2)+frametime*0.64));

    x=max(x,x2);
    y=max(y,y2);

    intens=((sin(x*4.0+frametime)*cos(y*4.0+frametime))+1.0)/2.0 /f2;


    vec2 uv;

    uv.x = x;
    uv.y = y;
 

//    vec3 col = vec3(noise(uv/(4.*sin(time/3.0)+4.)), noise(uv/(4.*cos(time/6.0)+4.)), noise(uv/(4.*sin(time/4.0)+4.)));
//    col.x+=col.y/4.;
//    col.y+=col.x/3.;
//    col.z+=col.y/6.;


    gl_FragColor = vec4(plasma(uv)*intens,1.0);
}


