// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:thickness:
//f1:color pos:
//f2:zoom:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.1, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
// by rotwang
const float PI = 3.1415926535;
const float TWOPI = PI*2.0;


vec3 hsv2rgb(float h,float s,float v) {
return mix(vec3(1.),clamp((abs(fract(h+vec3(3.,2.,1.)/3.)*6.-3.)-1.),0.,1.),s)*v;
}

float ring( vec2 p ) {
float len = length(p)-0.55;
len *= length(p*p)-0.66 /f0;
  float d = len*len*512.0;

    return 1.0-d*d;
}


vec3 ring_clr( vec2 p ) {
float d = ring( p );
float angle = (atan(p.x, p.y)+PI)/TWOPI;
angle +=  f1 * sin(time);
float hue = angle;
float lum = d;
vec3 clr = hsv2rgb(hue,0.66,lum + .1 * sin(time) );

    return clr;
}

vec2 sincostime( vec2 p ){
p.x=p.x+sin(p.x*2.0+time)*0.4-cos(p.y*1.0-time)*0.5-sin(p.x*3.0+time)*0.3+cos(p.y*3.0-time)*0.1;
p.y=p.y+sin(p.x*5.0+time)*0.7+cos(p.y*8.0-time)*0.3+sin(p.x*4.0+time)*0.5-cos(p.y*6.0-time)*0.3;
return p;
}

void main(void)
{

vec2 unipos = (gl_FragCoord.xy / resolution);
vec2 pos = unipos*2.0-1.0;
pos.x *= resolution.x / resolution.y;

pos=sincostime(pos * f2);
vec3 clr = ring_clr(pos);

gl_FragColor = vec4(clr,1.0);

}


