// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:thickness:
//f1:vert stretch:
//f2:side bends:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

#define PI 3.14159265359

float triWave(float x) {
    float m = 1.;
return m-abs(mod(x,2.0*m)-m);    
}

float polar(vec2 st,  float radius, int N) {
    float r = 2.0 * PI / float(N);
    float tMod = triWave(time / 25.0) * 12.0 * f2;
    float a = atan(st.x, st.y) * st.x * tMod / 10.0;
    float polar = cos(floor(0.5 + a/r * (2.0 + tMod))*r - a + tMod);
polar *= fract(length(st) * 5.0-time);
    polar *= 2.0;
    return 1.0 - step(dot(radius,radius), dot(polar,polar));
}

//---------------------------------------------------------------------------------------------------
//http://glslsandbox.com/e#49818.0
void main(void) {

    vec2 st = gl_FragCoord.xy / resolution.xy;
    st = st*4.0 *vec2(.5,f1) - 1.0;
    
    float d = polar(st, f0, 4 );
    gl_FragColor = vec4(d, d*st.x, d*st.y, 1.0);
   
} //endof main


