// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:horz stretch:
//f1:vert stretch:
//f2:wiggle speed:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

#define iter 8 
#define speed 0.25
#define grid 20.0
#define scale 1.3

/*
#define iter 150
#define speed 0.1
#define grid 4.0
#define scale 0.8
*/

void main() {
vec2 uv = scale * gl_FragCoord.xy / max(resolution.x, resolution.y);
float t = time * speed;
vec2 p = uv;
for(int i=1; i<=iter; ++i) {
vec2 np = p;
np.x += f0/float(i)*cos(float(i)*p.y+t) - 1.0;
np.y += f1/float(i)*sin(float(i)*p.x+t) + 1.0;
p=np;
}
gl_FragColor = vec4(cos(grid*f2*p), sin(grid*f2*(p.x + p.y)), 1.0);
}


