// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
//
//
// .default fragment shader

varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

//---------------------------------------------------------------------------------------------------
// metadata
// http://www.glslsandbox.com/e#39828.25
// other functions
#define PI 3.1415926535897932384626
float time = (float(itime) + ftime) *10.;
vec2 resolution = tres;
//f0:wave offset:
//f1:amplitute:
//f2:glow speed:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(-0.5, .05, fparams[1]);
float f2 = mix(0.25, 0.75, fparams[2]);


//---------------------------------------------------------------------------------------------------
void main(void) {

float amplitude = 1.0  +f1;
float glowT = f2 * 2.;
float glowFactor = mix( 0.015, 0.035, glowT );

vec2 p = vec2(0.0, 0.8) + 5.*gl_FragCoord.xy / resolution.xy;

vec3 c = vec3(0.);
vec3 basecol[4];
basecol[0] = vec3(1., .25, .25);
basecol[1] = vec3(.25, 1., .25);
basecol[2] = vec3(.25, .25, 1.);
basecol[3] = vec3(.5, .25, .75);


c += basecol[0] * ( glowFactor * abs( 1.0 / tan(p.y + cos( p.x + f0  + time*1.3+1. ) * amplitude*1.2 ) )) * (.5-.45*abs(cos(p.x+time*1.6)))
   + basecol[1] * ( glowFactor * abs( 1.0 / tan(p.y + cos( p.x + time+2. ) * amplitude*1.1 ) )) * (.65-.6*abs(cos(p.x+time*1.1)))
   + basecol[2] * ( glowFactor * abs( 1.0 / tan(p.y + cos( p.x + time/1.5 ) * amplitude ) )) * (.65-.6*abs(cos(p.x+time*1.1)))
   + basecol[3] * ( glowFactor * abs( 1.0 / tan(p.y + cos( p.x + time/2. ) * amplitude ) )) * (.65-.6*abs(cos(p.x+time*1.1)))
   + basecol[0] * ( glowFactor * abs( 1.0 / tan(p.y + cos( p.x + time/2.5+1. ) * amplitude*.9 ) )) * (.35-.3*abs(cos(p.x+time*2.1)))
   + basecol[1] * ( glowFactor * abs( 1.0 / tan(p.y + cos( p.x + time/3.+3. ) * amplitude*1.3 ) )) * (.32-.15*abs(cos(p.x+time*2.)));

gl_FragColor = vec4( c, 1.0 );


} //endof main


