// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:thickness:
//f1:zoom:
//f2:wiggle:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);


float time = float(itime) + ftime;
vec2 resolution = tres;
// bars - thygate@gmail.com // rotation and color mix modifications by malc (mlashley@gmail.com) // waves modified by @hintz 2013-05-01

vec2 position;
float c = cos(time*0.5);
float s = sin(time*0.5);
mat2 R = mat2(c,-s,s,c);

float barsize = 0.15 * f0;
float barsangle = 200.0*sin(time*0.0001);

vec4 bar(float pos, float r, float g, float b) {
//pos*=3.0;
return max(0.0, 4.0-fract(pos - position.y + 0.5*sin(2.0*time+sin(1.0-pos*2.0)*4.0*position.x)) / barsize) * vec4(r, g, b, 1.0);
}

void main(void) {
position = (gl_FragCoord.xy - 0.5*resolution.xy) / resolution.xx;
position = (1.5 / f1 +0.3)  *position * R; 

float t = time*0.05 + (f2 * 5.5);

vec4 color = bar(sin(t), 1.0, 0.0, 0.0);
color += bar(sin(t+barsangle*2.), 1.0, 0.5, 0.0);
color += bar(sin(t+barsangle*4.), 1.0, 1.0, 0.0);
color += bar(sin(t+barsangle*6.), 0.0, 1.0, 0.0);
color += bar(sin(t+barsangle*8.), 0.0, 1.0, 1.0);
color += bar(sin(t+barsangle*10.), 0.0, 0.0, 1.0);
color += bar(sin(t+barsangle*12.), 0.5, 0.0, 1.0);
color += bar(sin(t+barsangle*14.), 1.0, 0.0, 1.0);

gl_FragColor = normalize(color)*1.5;
}


