// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:horz stretch:
//f1:vert stretch:
//f2:zoom:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);


float time = float(itime) + ftime;
vec2 resolution = tres;
// Title: Time for Fun * Tweaked by: dapumptu

uniform sampler2D backbuffer;

float two_pi = 4.0 * asin(1.0);
const float proj_coeff = 0.2;
const float rot_coeff = 0.05;
const float move_coeff = 0.3;
const float fog_coeff = 1.8;
const float fog_exp = 0.1;

float chessboard(vec2 uv, vec2 nuv) {
uv = floor(mod(uv*nuv, 2.));
return mod(uv.x+uv.y, 2.);
}

vec4 texture(vec2 pos) {
float fval = chessboard(pos, vec2(0.00001, 10.0));
return vec4(fval, fval, fval, 1.0);
}

void main( void ) {
vec2 p = gl_FragCoord.xy/resolution.xy - 0.5;
p = vec2(pow(p.x, 0.25), pow(p.y, 0.25));
float bpm = 50. ;
bpm = bpm*4./60.;
//p *= abs(sin(time*bpm))*.25+1.;
//p += vec2(sin(time*bpm*.12), cos(time*bpm*.125)) * 1.;
p += vec2(f0, f1) +  0.125 * sin(time);
float check = chessboard(p, vec2(8. * f2  + 2.));

vec3 bb = texture2D(backbuffer, (1.+sin(time*bpm)*.05) * (gl_FragCoord.xy/resolution.xy-.5)+.5).rgb * vec3(.8, .8, 0.9);
//check += check < 0.5 ? bb * 0.9 : (1.-bb * 0.9);

gl_FragColor = vec4(check + (check < 0.5 ? bb * 0.99 : bb * 0.), 1.);
}


