// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:arc blur:
//f1:arc offset:
//f2:zoom:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;

float random(vec2 st) {
   return fract(sin(dot(st, vec2(12.4352, 31.682))) * 45649.421);
}

float cubic(float v) {
   return v * v * (80.0 * f0 - 2.0 * v);
}

float valuenoise(vec2 st) {
   
   float v1 = random(floor(st));
   float v2 = random(floor(st) + vec2(1.0, 0.0));
   float v3 = random(floor(st) + vec2(0.0, 1.0));
   float v4 = random(floor(st) + vec2(1.0, 1.0));
   
   //return mix(mix(v1, v2, fract(st.x)), mix(v3, v4,  fract(st.x)), fract(st.y));
   //return mix(mix(v1, v2, smoothstep(0.0, 1.0, fract(st.x))), mix(v3, v4, smoothstep(0.0, 1.0, fract(st.x))), smoothstep(0.0, 1.0, fract(st.y)));
   return mix(mix(v1, v2, cubic(fract(st.x))), mix(v3 *f1, v4, cubic(fract(st.x))), cubic(fract(st.y)));  
}

//---------------------------------------------------------------------------------------------------
void main(void) {
   vec2 p = gl_FragCoord.xy / tres.yy;
   
   float v = valuenoise(p  * 10.0 * f2 + time);   
   
   gl_FragColor = vec4(vec3(v), 1.0); 

}//endof main


