// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:color slide:
//f1:twist:
//f2:black size:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.1, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

float cdist(vec2 v0, vec2 v1){
v0 = abs(v0-v1);
return min(v0.x,v0.y);
}

//---------------------------------------------------------------------------------------------------
// http://glslsandbox.com/e#36234.0
void main(void) {

  
vec2 p = (gl_FragCoord.xy * 2.0 - tres) / min(tres.x, tres.y) ;
vec2 q = vec2(p.x / p.y, abs(1.0 / p.y) + mod(time, 1.0)) + vec2(.5) * 2. /vec2(f1,-f1);

float grid = 2.0 * cdist(vec2(f0), mod(q, 1.0));

float grid_Color = smoothstep(0.0, 1.00*f2 , grid) * abs(p.y);

float modifier_A = abs(floor(q.x + 0.5) + floor(q.y + 0.5)) * abs(p.y);
float modifier_B = abs(floor(-q.x + 0.5) + floor(q.y + 0.5)) * abs(p.y);
float modifier_C = mod(abs(floor(q.x + 0.5) + floor(q.y + 0.5)), 3.0) * abs(p.y) ;

vec3 color = vec3 (grid_Color * modifier_A, grid_Color * modifier_B, grid_Color * modifier_C);

gl_FragColor = vec4(color, 1.0);
 
} //endof main


