// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:diag count:
//f1:line density:
//f2:diag slide:
float f0 = mix(0.3, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.5, 0.95, fparams[2]) + .275;

float time = float(itime) + ftime;
float hash(vec2 p) {
return fract(sin(dot(p, vec2(15.38, 35.76))) * 43728.23);
}

//---------------------------------------------------------------------------------------------------
void main(void) {

float mytime = (float(itime) + ftime) * 10.0;

vec2 p = ( gl_FragCoord.xy / tres.xy ) * 0.5;
float span = 20.;
float gt = mod(mytime, span * 4.0) / (span * 4.0);
float m = 1.0;
float n = 1.0;

float t = mod(mytime, span) / span;
p = 2.0 * p - 1.0 /f0;
p.x *= tres.x / tres.y;
vec2 k = p;

p *= 28.0625; // number of squares
vec2 q = p * f2 * 2. ;
float o = hash(floor(q / (5.0 * sqrt(2.0))));
float r = floor(o * 64.0) * 3.141592 / 2.0;

p = mod(p, sqrt(2.0) * 5.0) - sqrt(2.0) * 2.5;
p *= f1 * 2.;

float co = cos(3.141592 / 4.0);
float si = sin(3.141592 / 4.0);

if(gt < 0.25) { m = 1.0; n = 1.0; }
else if(gt < 0.5) { m = 1.0; n = -1.0; }
else if(gt < 0.75) { m = -1.0; n = 1.0; }
else { m = -1.0; n = -1.0; }

p = mat2(co, -n * si, n * si, co) * p;
p = mat2(cos(r), -sin(r), sin(r), cos(r)) * p;
p.x += m * -(sin(t * 3.14 * 0.5) * 2.0 - 1.0);
p.y += m * -1.0;
float c = 0.0;
//c = max(abs(p.x), abs(p.y)) - 0.5;
//c = length(p) - 0.5;
c = sin(max(abs(p.x), abs(p.y)) * 3.14 * (0.1 + 4.9 * o) - (o > 0.5 ? -1.0 : 1.0) * mytime * (0.1 + 4.9 * o));
c = 0.2 / (clamp(c, 0.0, 1.0) + 0.1);
//c = smoothstep(0.0, 0.2, c);

//c *= (0.5 + 0.5 * o);
c = 2.5 - c;
c *= (0.35 + 0.2 * k.x);
vec3 col =  vec3(c * (1.0 - o), c * 0.5, c + sin(o * 3.14 * 10.0));
gl_FragColor = vec4(vec3(col), 1.0 );


} //endof main


