// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:sphere zoom:
//f1:all zoom:
//f2:glow:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);
//http://glslsandbox.com/e#48154.0

float time = float(itime) + ftime;

float sphere(float t, float k) {
    float d = 1.0+t*t-t*t*k*k;
    if (d <= 0.0)
        return -3.0;
    float x = (k - sqrt(d))/(1.0 + t*t);
    return asin(x*t);
}

//---------------------------------------------------------------------------------------------------
void main(void) {
    // bg texture
    vec4 texColor = vec4(0.5,0.,0.3,0.5);
    
    vec2 uv = gl_FragCoord.xy - 0.5*tres.xy;
    float v = tres.x;
    if (v > tres.y)
        v = tres.y;
    uv /= v;
    uv *=f0 * 8.0 + 2.;
    float len = length(uv) /f1;
    float k = 1.0;
    float len2;

    len2 = sphere(len*k,sqrt(2.0))/sphere(1.*k,sqrt(2.0));
uv = uv * len2 * 0.5 / len;
uv = uv + 0.5;

    vec2 pos = uv;
    float t = time/1.0;
    float r, g, b;
    
    //val += sin((pos.x*scale1 + t*2.))*3.;
    r = cos(pos.x*90.+t)+sin(pos.y*40.-t*0.77);
    g = r+sin((pos.y*10. * cos(t*.4)));
    //g = r*sin((pos.y*10. * cos(t*.3)));
    b = g-sin((pos.x+pos.y + cos(t*.3)));

    float glow =  1.40 /f2  / (0.01 + 0.5*distance(len, 1.));
    
    //val = (cos(PI*val) + 1.0) * 0.5;
    vec4 col2 = vec4(r, g, b, 1.0);
    
    gl_FragColor = step(len, 1.) * 0.5 * col2 + glow * col2 ;
   
} //endof main


