// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
//
//
// .default fragment shader

varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

//---------------------------------------------------------------------------------------------------
// metadata
// http://www.glslsandbox.com/e#40476.0
#define PI 3.1415926535897932384626
vec2 mouse = vec2(fparams.x, fparams.y);
float time = float(itime) + ftime;

vec2 resolution = tres;

//f0:start zoom:
//f1:vertical spread:
//f2:horizontal spread:
float f0 = mix(0.2, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

//---------------------------------------------------------------------------------------------------
void main(void) {

vec2 p = (gl_FragCoord.xy * 2.0 - resolution) / min(resolution.x, resolution.y) * f0;
vec3 color = vec3(0.0, 0.3, 0.5);


float f = 0.0;
for(float i = 0.0; i < 10.0; i++){

float s = sin(time + i * PI / 4.0 ) * 0.8 +f1;
float c = cos(time + i * PI / 5.0 ) * 0.8 +f2;
 
f += 0.001 / (abs(p.x + c) * abs(p.y + s));
}


gl_FragColor = vec4(vec3(f * f * color), 1.0);


} //endof main


