// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:sphere size:
//f1:density:
//f2:rotate:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.15, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

const float PI = 3.14159265;

float sphere(float t, float k) {
    float d = 1.0+t*t-t*t*k*k;
    if (d <= 0.0)
        return -1.0;
    float x = (k - sqrt(d))/(1.0 + t*t);
    return asin(x*t);
}

//---------------------------------------------------------------------------------------------------
//http://glslsandbox.com/e#49823.4
void main(void) {

    // bg texture
    vec4 texColor = vec4(0.1,0.,0.3,0.5);
    
    vec2 uv = gl_FragCoord.xy - 0.5*resolution.xy;
    float v = resolution.x;
    if (v > resolution.y) {
        v = resolution.y / f0 *.5 ;
    }
    uv /= v;
    uv *= 3.0;
    float len = length(uv);
    float k = 1.0;
    float len2;

    len2 = sphere(len*k,sqrt(2.0))/sphere(1.*k,sqrt(2.0));
uv = uv * len2 * f1 / len;
uv = uv + 0.1 /f2;

    vec2 pos = uv;
    float t = time/1.0;
    float r, g, b;
    
    //val += sin((pos.x*scale1 + t*2.))*3.;
    r = cos(pos.x*90.+t)+sin(pos.y*40.-t*0.77);
    g = r+sin((pos.y*10. * cos(t*.4)));
    //g = r*sin((pos.y*10. * cos(t*.3)));
    b = g-sin((pos.x+pos.y + cos(t*.3)));

    float glow =  1.40 / (0.01 + 0.5*distance(len, 1.));
    
    //val = (cos(PI*val) + 1.0) * 0.5;
    vec4 col2 = vec4(r, g, b, 0.1);
    
    gl_FragColor = step(len, 1.) * 0.1 * col2 + glow * col2 ;
   
} //endof main


