// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;       //
uniform sampler2D tex;     // texture one
uniform sampler2D tex2;    // texture two
uniform vec2 tres;         // size of texture (screen)
uniform vec4 fparams;      // 4 floats coming in
uniform ivec4 iparams;     // 4 ints coming in
uniform float ftime;       // 0.0 to 1.0
uniform int itime;         // increases when ftime hits 1.0
//f0:dark 1:
//f1:bright 1:
//f2:bright 2:

   float f0 = mix(0.0, 1.0, fparams[0]);
   float f1 = mix(0.0, 1.0, fparams[1]);
   float f2 = mix(0.0, 1.0, fparams[2]);

//https://www.shadertoy.com/view/XslGDN

float time = float(itime) + ftime;
vec2 resolution = tres;// for easier glslsandbox.com conversion
//---------------------------------------------------------------------------------------------------

//Based on Andrew Baldwin's noise tutorial: http://thndl.com/?15

float rand(vec2 p, float timeOffset) {
p += 0.2127*timeOffset + p.x + 0.3713*p.y;
vec2 r = (123.789)*sin(1.823*(p));
return fract(r.x*r.y);
}

float sn(vec2 p, float timeOffset) {
vec2 i=floor(p-0.5);
vec2 f=fract(p-0.5);
f = f*f*f*(f*(f*6.0-15.0)+6.0);
float rt=mix(rand(i, timeOffset),rand(i+vec2(1.,0.), timeOffset),f.x);
float rb=mix(rand(i+vec2(0.0,1.0), timeOffset),rand(i+vec2(1.0,1.0), timeOffset),f.x);
return mix(rt,rb,f.y);
}

void main(void) {

//vec2 r=fract(456.789*sin(789.123*c.xy));
//f=vec4(r.x*r.y)

//create random noise
//vec2 r = 123.0*sin(1.823*gl_FragCoord.xy);


vec2 p = gl_FragCoord.xy*vec2(0.015);

//gl_FragColor = vec4(vec3(sn(vec2(0.08)*gl_FragCoord.xy,1.0)),1.0);

gl_FragColor = vec4(vec3(
0.5*sn(p, 1.0) * f2
+0.25*sn(2.0*p, 1.0) /f0
-0.125*sn(4.0*p, 1.0) /f1
+0.0625*sn(8.0*p, sin(time*0.5))
//+0.03125*sn(16.0*p, sin(time*0.032))
//+0.015*sn(32.0*p, sin(time*0.046))
),1.);
   
} //endof main


