// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
//
//
// .default fragment shader

varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

//---------------------------------------------------------------------------------------------------
// metadata
// source : http://glslsandbox.com/e#36284.0
const float PI = 3.14159265;

//f0:num rings:
//f1:speed+dir:
//f2:red level:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float fangle(vec2 u){
return (atan(u.x,u.y)+PI)/(PI*2.);
}


//---------------------------------------------------------------------------------------------------
void main(void) {

float mytime = float(itime) + ftime;

vec2 uv=(gl_FragCoord.xy/tres.xy) - 0.5;//center on scree..
uv.x*=tres.x/tres.y;

float wm_size = 5.0 + (f0 * 10.);//smaller = less draws
float a=fract(fangle(uv)+(wm_size*length(uv))+mytime+ f1 * 20.  );
a=sin(a*PI*2.)*40.;

vec3 b=vec3(f2,0.,0.);
vec3 c=vec3(1.,1.,0.8) ;

gl_FragColor=vec4(mix(b,c,clamp(a,0.,1.)),1.);

} //endof main


