// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:wave 1:
//f1:wave 2:
//f2:center brightness:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.2, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
// structure header
// by rotwang, some scrolling shapes for Krysler

vec3 waves(vec2 pos) {

float shade = 1.0/( sin( pos.x + time )+sin(pos.x*5.0+time*10.0)*0.1 - pos.y );

shade = pow(shade, 0.5)/3.0;

vec3 clr_a = vec3(shade*0.2, shade*0.66, shade);
vec3 clr_b = vec3(shade*0.2, shade*0.5, shade*0.6);
vec3 clr = clr_a*pos.y*0.5; //  + clr_b*(1.0-p.y)*0.25;

clr += clr_b*(1.0-pos.y);

return clr;
}

float waves2(vec2 pos) {

float shade = 1.0/( sin( pos.x + time )+sin(pos.x*5.0+time*10.0)*0.1 - pos.y );

shade = pow(shade, 0.5)/3.0;


return shade;
}

void main( void ) {

float aspect = resolution.x / resolution.y;
vec2 unipos = ( gl_FragCoord.xy / resolution );
 vec2 pos = unipos*2.0-1.0;//bipolar
pos.x *= aspect;

vec3 clr = waves(pos*vec2(3.1415*(4./f0 +.5) , cos(time)*2.0+4.0));
clr += waves(pos*vec2(3.1415*(8./f1 +.5)+sin(time*0.2), sin(time)*0.5+10.0)) * 2.;

float vignette = pow(1.0-abs(pos.x*0.4), 4.0 /f2 );
clr *= vignette;
gl_FragColor = vec4(clr,  1.0);
}


