// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
//
//
// .default fragment shader

varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

//---------------------------------------------------------------------------------------------------
// metadata
// source :  http://glslsandbox.com/e#35456.0
#define PI 3.1415926535897932384626
//f0:arc width:
//f1:arc zoom:
//f2:arc brightness:
float f0 = mix(0.05, 0.95, fparams[0]) * 5.;
float f1 = mix(0.05, 0.95, fparams[1]) * 10.;
float f2 = mix(0.05, 0.95, fparams[2]);

float mytime = float(itime) + ftime;

float fp = 0.5;

float map(vec2 p) {
  float a = atan(p.y, p.x) / PI * 0.5 + 0.5;
  float d = length(p) + f1;
  float col = abs(tan(a * PI * 3.0  + d - mytime));
  return sin(col * f0 *  fp);
}

vec3 calcNormal(vec2 p) {
    vec2 e = vec2(0.91, 0.0);
    vec3 nor = vec3(
        map(p + e.xy) - map(p - e.xy),
        map(p + e.yx) - map(p - e.yx),
        map(p) * 0.15
    );
    return normalize(nor);
}



//---------------------------------------------------------------------------------------------------
void main(void) {


  vec2 p = gl_FragCoord.xy / tres;
  p = 2.0 * p - 1.0 ;
  p.x *= fp + tres.x / tres.y;
  p.y -= fp * 0.4;
  vec3 rd = normalize(vec3(0.0, 0.0, -1.0));
  vec3 nor = calcNormal(p);
  vec3 lig = normalize(vec3(1.0, 2.5, 1.0));
  float dif = clamp(dot(nor, lig), 0.0, f2);
  float spe = pow(clamp(dot(reflect(rd, nor), lig), 0.0, 1.0), 64.0);
  float fre = 1.0 - dot(-rd, nor);
  float c = map(p);
  vec3 col =  vec3(1.0) * dif + spe + fre * 0.1;
  gl_FragColor = vec4(col, 1.0);

} //endof main


