// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
//
//
// .default fragment shader

varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

//---------------------------------------------------------------------------------------------------

//f0:scale 1:
//f1:scale 2:
//f2:scale 3:
float f0 = mix(0.005, 0.3, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

//---------------------------------------------------------------------------------------------------
void main(void) {
float mytime = float(itime) + ftime;

vec2 uv = (2.0 * gl_FragCoord.xy / tres.xy - 1.0) * vec2(tres.x / tres.y, 1.0);

float a = 4.0*atan(uv.y / uv.x);
uv /= f1 + 0.02 * sin(6.0 * a - mytime * 16.0)*cos(mytime/a);
uv*= 3. * f2/sin(a) ;

float f = 10.40 *f0  + 0.2 * cos(mytime * 0.14);
float d = (abs(length(uv) - f) * 10.0);

gl_FragColor += vec4(0./d, 0.5/d, 2.22/d, 1);

} //endof main


