// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform highp vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

//f0:whiteLR:
//f1:grid thickness:
//f2:grid stretch:

float f0 = clamp(fparams[0], 0.05, 0.95);
float f1 = clamp(fparams[1], 0.05, 0.95);
float f2 = mix(0.5, 0.95, fparams[2]);

float mytime = (float(itime) + ftime ) * 0.5;
vec2 resolution = tres;

//80s Sci-Fi style thing.
float linstep(float x0, float x1, float xn) {
return (xn - x0) / (x1 - x0);
}

float cdist(vec2 v0, vec2 v1) {
v0 = abs(v0-v1);
return max(v0.x,v0.y);
}

//---------------------------------------------------------------------------------------------------
// source : http://glslsandbox.com/e#35359.4
void main(void) {


float usetime = mytime * 10.0;

//vec2 aspect = (resolution.xy / cos(sin(usetime)/2.0) ) / (resolution.x / sin(sin(usetime)/1.0) );
vec2 aspect = (resolution.xy ) / (resolution.y  );

vec2 _uv = gl_FragCoord.xy / resolution.y;
vec2 cen = aspect/2.0;

vec3 color = vec3(0);


vec2 gruv = _uv-cen;

gruv = vec2(gruv.x * abs(1.4/gruv.y), abs(f2/gruv.y) + ( mod(usetime, 1.0 ) ) );
gruv.y = clamp(gruv.y,-1e2,1e2);

float grid = 2.0 * cdist(vec2(f0), mod((gruv)*1.0,vec2(1)));

float gridmix = max(pow(grid,6.0) * 1.2, smoothstep(f1,0.98,grid) * (3.0 + (3.0 * f1)) );

vec3 gridcol = (mix(vec3(0.00, 0.00, 0.90), vec3(0.90, 0.00, 0.90), _uv.y*2.0) + 1.2) * gridmix;
gridcol *= linstep(0.1,1.5,abs(_uv.y - cen.y));

color = mix(gridcol, gridcol, gridcol);
gl_FragColor = vec4( color, 1.0 );


} //endof main


