// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:box width:
//f1:box height:
//f2:zoom:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

float rand(vec2 st){
    return fract(sin(dot(st, vec2(12.9898, 78.233))) * 43758.5453);
}

float atan2(in float y, in float x){
    return x == 0.0 ? sign(y) * 3.14 / 2.0 : atan(y, x);
}

mat2 rotate2d(float _angle){
    return mat2(cos(_angle),-sin(_angle),
                sin(_angle),cos(_angle));
}

//
// http://glslsandbox.com/e#54790.0
void main( void ) {
    vec2 uv = (gl_FragCoord.xy * 2.0 - resolution) / min(resolution.x, resolution.y);
    float n = 15. * f2;
    vec2 st = (fract(uv * n) - 0.5)*2.0;
    vec2 ist = floor(uv * n);
     uv=uv*rotate2d(sin(time));

    float c = clamp(step(f0, abs(st.x)) + step(f1, abs(st.y)), 0.0, 1.0);
    c = 1.0 - c;
    float y = 1.0 - step(sin(time*10.0*rand(vec2(ist.x, 2.0))), ist.y*abs(sin(rand(vec2(ist.x, 1.0)))));
    uv *=rotate2d(time) ;
    vec3 bg = vec3(0.25, 0.5, 1.0)*c*clamp(y, 0.25, 1.0);
    uv*=rotate2d(31.0);
    gl_FragColor = vec4(bg, 1);
}


