// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:eyes 1:
//f1:eyes 2:
//f2:center pos:

float f0 = mix(0.25, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;

float saturate(float x){return clamp(x,0.,1.);}

vec4 text(vec2 u){
vec2 p=fract(fract(u)+(sin(u.y+time)/4.)) * f0 * 2.;
float f=1.-saturate((max(length(p-vec2(0.25,0.5)) * f1 * 2., length(p-vec2(0.75,0.5)))-.5)*50.);
f-=1.-saturate((length(p-.5)-(((sin(time+u.x)+2.)/3.)*.25))*50.);
return vec4(f,f,f,0.);
}

vec4 text2( vec2 g ) {
    g /= 10.;
    float color = sign((mod(g.x, 0.1) - 0.05) * (mod(g.y, 0.1) - 0.05));
    return sqrt(vec4(color));
}

//---------------------------------------------------------------------------------------------------
// http://glslsandbox.com/e#39378.0
void main(void) {

    vec2 uv = tcoord * 2.;
    
    float t = time * .5;
    uv.y += sin(t) * f2;
    uv.x += cos(t) * f2;
    float a = atan(uv.x,uv.y)/1.57;
    float d = max(max(abs(uv.x),abs(uv.y)), min(abs(uv.x)+uv.y, length(uv)));
   
    vec2 k = vec2(a,.8/d + t);
    
    vec4 tx = text(k*6.);
    vec4 tx2 = text2(k*2.);
    
    // ground
    gl_FragColor = tx2;
    
    // wall
    if (d<=abs(uv.x)+0.05||d<=abs(uv.x)+uv.y)
        gl_FragColor = tx;
    
    gl_FragColor *= d;
gl_FragColor.a = 1.;

   
} //endof main


