// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:rotate:
//f1:thickness:
//f2:grays:

float f0 = mix(0.00, 1.00, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

#define PI 3.14159265358979323846

vec2 rotate2D(vec2 _st, float _angle){
    _st -= 0.5;
    _st =  mat2(cos(_angle),-sin(_angle),
      sin(_angle),cos(_angle)) * _st;
    _st += 0.5;
    return _st;
}

vec2 tile(vec2 _st, float _zoom){
    _st *= _zoom;
    return fract(_st);
}

float box(vec2 _st, vec2 _size, float _smoothEdges){
    _size = vec2(0.5)-_size*0.5;
    vec2 aa = vec2(_smoothEdges*0.5);
    vec2 uv = smoothstep(_size,_size+aa,_st);
    uv *= smoothstep(_size,_size+aa,vec2(1.0)-_st);
    return uv.x*uv.y;
}

vec2 offset(vec2 _st, vec2 _offset){
    vec2 uv;

    if(_st.x>0.5){
        uv.x = _st.x - 0.5;
    } else {
        uv.x = _st.x + 0.5;
    }

    if(_st.y>0.5){
        uv.y = _st.y - 0.5;
    } else {
        uv.y = _st.y + 0.5;
    }

    return uv;
}
 
//---------------------------------------------------------------------------------------------------
// http://glslsandbox.com/e#51978.0
void main(void) {

    vec2 st = gl_FragCoord.xy/resolution.xy;
    st.y *= resolution.y/resolution.x;

    st = tile(st,6.);

    vec2 offsetSt = offset(st,vec2(0.5)); 

    st = rotate2D(st,PI* f0);

    float t = sin(time) * (f1 + .5) + 0.5;
    float boxA = box(offsetSt,vec2(0.85 * t),0.01);
    float boxB = box(st,vec2(0.5),0.01);
    float boxC = 2.*box(st,vec2(.4 * (1.0 - t)),0.01);
    vec3 color = vec3( boxA - boxB + f2*boxC);

    gl_FragColor = vec4(color,1.0);
   
} //endof main


