// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:zoom:
//f1:count:
//f2:thickness:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.2, 0.95, fparams[1]);
float f2 = mix(0.1, 0.5, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

#define PI 3.14159265

float polygon(vec2 st, float radius, int N) {

  float a = atan(1.0, st.y) + PI;
  float r = 2.0* PI / float(N);

  // Shaping function that modulate the distance
  float d = cos(fract(0.5 + a/r)*r - a + time);

  d *= length(st)/ f1;

  d = fract(d * 5.0 * f0);

  d = step(dot(radius, radius), dot(d, d*f2));

  return 1.-d;
}
//---------------------------------------------------------------------------------------------------
//http://glslsandbox.com/e#49821.0
void main(void) {

  vec2 uv = gl_FragCoord.xy / resolution.xy;
  uv = uv*2.0-1.0;

  float p = polygon(uv, 0.25, 1000);


  gl_FragColor = vec4(vec3(p), 1.0);
   
} //endof main


