// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
	precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:zoom:
//f1:count:
//f2:highlight:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

//FlexiFlower by CuriousChettai@gmail.com

void main( void ) {
vec2 uPos = ( gl_FragCoord.xy / resolution.y );//normalize wrt y axis
uPos -= vec2((resolution.x/resolution.y)/2.0, 0.5);//shift origin to center

float angle = atan(uPos.y, uPos.x);
float len = sqrt(uPos.x*uPos.x + uPos.y*uPos.y);

float newAngle = angle - f1*sin(len*20.0-time*8.0) - 0.9*sin(len*5.0-time);
float flower = 1.0 - smoothstep(0.2, 0.5, len * f0);
flower *= 5.0 * (sin(newAngle*20.0 )+1.0 * f2);
vec3 flowerColor = vec3(flower*0.4, flower*0.1, flower*0.6);

float gradient = smoothstep(0.5, 1.5, len);
vec3 gradientColor = vec3(gradient*0.4, gradient*0.1, gradient*0.6) ;

vec3 color = flowerColor + gradientColor;
gl_FragColor = vec4(color, 1.0);
}






