// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
//
//
// .default fragment shader

varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

//---------------------------------------------------------------------------------------------------
// metadata
// source :  http://glslsandbox.com/e#35791.0
//f0:amplitude:
//f1:luma rotate:
//f2:glow blur:
float f0 = mix(0.2, 0.95, fparams[0]) * 2.;
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

#define PI 3.1415926535897932384626
float mytime = float(itime) + ftime;

float d2y(float d){ d*= 400.; return 1./(d*d);}

vec3 hsv2rgb(vec3 c)
{
    vec4 K = vec4(1.0, 2.0 / 3.0, 1.0 / 3.0, 3.0);
    vec3 p = abs(fract(c.xxx + K.xyz) * 6.0 - K.www );
    return c.z * mix(K.xxx, clamp(p - K.xxx, f1, 1.0 - f1), c.y);
}

float gauss(float s, float x){
    return (0.85)*exp(-x*x/(2.*s*s));
}
#if 1
float blur(float dist, float width, float blur, float intens){
    float w = width;
    float e = 0.85*blur;
    dist*=f2;
    float b = smoothstep(-w-e, -w+e, dist)-smoothstep(w-e, w+e, dist);
    return 1.0*pow(b,1.9)*(1.+80.*blur)*intens;
    //return 0.9*b*intens;
}
#else
float blur(float dist, float width, float blur, float intens){
    float w = width;
    dist = max(abs(dist)-width,0.);
    float b = gauss(0.02+w*10.*blur,dist);
    return b*intens;
}
#endif
float d2y2(float d, float i){
    float b = 0.04*i+0.0001;
    return blur(d , 0.03, b, 0.4);
}



float f(float x){
    return blur(0.5*x, 0.03, 0.04+0.5, 1.);
}


#define N 4
// hauteur de la vague
float wave(float x, int i){
    float i_f=float(i);
    float fy = (3.3-0.5*i_f)*sin(x*2.+2.8*mytime+.6*i_f);
    return fy * (0.4+0.3*cos(x)) * f0;
}


//---------------------------------------------------------------------------------------------------
void main(void) {

    vec2 uv = (gl_FragCoord.xy / tres - vec2(0.5)) * vec2(tres.x / tres.y, 1.0) * 1.05;
    uv.y *= 3.2;
    uv.x *= 2.1;


    float yf = 0.*d2y(distance(uv.y*2., f(uv.x)));
    vec3 col = vec3(0.);
    for(int i = 0; i<N; ++i){
        float i_f = float(i)*0.5+1.;
        float y = d2y2(distance(2.*uv.y, wave(uv.x, i)),i_f);
        col += 0.8*y *hsv2rgb(vec3(0.00015*mytime+i_f*0.1-0.05, 0.6,1.0));

    }

    gl_FragColor = vec4(vec3(yf)+col, 1.0);

} //endof main


