// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
//
//
// .default fragment shader

varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

//---------------------------------------------------------------------------------------------------
// metadata
// source : http://glslsandbox.com/e#36660.0
//---------------------------------------------------------------------------------------------------
// other functions
//f0:divisons:
//f1:zoom:
//f2:ridges:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.15, 0.85, fparams[1]) ;
float f2 = mix(0.05, 0.95, fparams[2]);

#define TWO_PI 6.28

float mytime = float(itime) + ftime;
#define SEGMENTS (10.0 * (f0 + 0.5*cos(0.4*mytime)))

//---------------------------------------------------------------------------------------------------
void main(void) {

  vec2 uv = (gl_FragCoord.xy * 2. - tres.xy) / tres.y * f1 ;

  float t = sin(mytime*2.2);
  float a = atan(uv.x, uv.y) / TWO_PI * SEGMENTS;
  float d = length( uv) - mix(3.*sin(3.*t),.5, cos(fract(a)-.5));
    
  vec3 col = vec3(1.0) - sign(d)*vec3(0.3,0.2,0.4);
  col *= f2 - exp(-2.0*abs(d));
  col *= 0.8 + 0.2*cos(120.0*abs(d) + t*10.);
  col = mix( col, vec3(1.0), 1.0 - smoothstep(0.0,0.02, abs(d)));

  gl_FragColor = vec4( col, 1.0 );

} //endof main


