// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:horz stretch:
//f1:vert stretch:
//f2:rings:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);


float time = float(itime) + ftime;
vec2 resolution = tres;
// structure header
#define PI 3.141592653589793238462643383279


float dist(vec3 p1, vec3 p2) { 
return distance(p1,p2);
}

vec4 col(float tick, float v) {
float r = 0.166 * PI + tick * 0.05;
float g = 0.5*PI + tick * 0.05;
float b = 0.5*PI + tick * 0.1;
return vec4(cos(r+v)+1.0,cos(g+v)+1.0,cos(b+v)+1.0,1.0);
}

void main( void ) {

vec2 pos = gl_FragCoord.xy / resolution.xy;

float tick = (time * 10.0);

float modder = 8.0; 

float circle1 = tick * 0.085 / modder;
float circle2 = -tick * 0.1 / modder;
float circle3 = tick * .3 / modder;
float circle4 = -tick * .2 / modder;
float circle5 = tick * .4 / modder;
float circle6 = -tick * .15 / modder;
float circle7 = tick * .35 / modder;
float circle8 = -tick * .05 / modder;

float roll = tick * 5.0;

vec3 p = vec3(pos.x*2.0*f0-1.0,pos.y*2.0*f1-1.0, f2);
vec3 p1 = vec3( cos(circle3), sin(circle4), 0);
vec3 p2 = vec3( sin(circle1), cos(circle2), 0);
vec3 p3 = vec3( cos(circle5), sin(circle6), 0);
vec3 p4 = vec3( cos(circle7), sin(circle8), 0);

float sum = sin(dist(p,p1)) + sin(dist(p,p3)) + sin(dist(p,p4));

gl_FragColor = col(tick,sum*30.0 );
}






