// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:center hole size:
//f1:teeth:
//f2:radial lines:
float f0 = mix(0.6, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
//original author = ?
//fork by tigrou(ind) : repeat gears over x/y axis, add more colors

void main( void ) {

vec2 distanceVector = gl_FragCoord.xy;

float d = 160.0;

float newtime = time * sign(mod(distanceVector.x, d * 2.0) - d) * sign(mod(distanceVector.y, d * 2.0) - d);

distanceVector = mod(distanceVector, d) - d / 2.0;

float angle = atan(distanceVector.x, distanceVector.y);

float scale = 0.0002;
float cogMin = 0.002; // 'min' is actually the outer edge because I'm using 1/distance... for reasons I can't remember :(
float cogMax = 0.9 * f0; // 'max' is the inner edge, so this controls the size of the hole in the middle - the higher the value the smaller the hole


float distance = 1.0 - scale * ((distanceVector.x * distanceVector.x) + (distanceVector.y * distanceVector.y));


// tooth adjust makes the teeth slope so they get smaller as they get further out
float toothAdjust = 2.4 * (distance - cogMin);
// 12 defines the number of cog teeth
float angleFoo = sin(angle*12.0 - newtime * 4.0) - toothAdjust;
cogMin += 80.0 *  f1 * clamp(1.0 * (angleFoo + 0.2), 0.0, 0.015); // add 0.2 to make teeth a bit thinner, the 0.015 clamp controls the thickness of the cog ring

// By multiplying values up and clamping we can get a solid cog with slight anti-aliasing
float isSolid = clamp(2.0 * (distance - cogMin) / cogMax, 0.0, 1.0);
isSolid = clamp(isSolid * 100.0 * (cogMax - distance), 0.0, 1.0);

// Make it BlitzTech purple
float brightness = isSolid *(1.0-sin(angle*30.0 * f2-newtime));
gl_FragColor = vec4(brightness*0.5,brightness*0.25,brightness*0.5 * sign(newtime), 1.0 );
}


