// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:vert mod:
//f1:horz mod 1:
//f2:horz mod 2:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
uniform sampler2D backbuffer;
void main( void ) {
vec2 pos = gl_FragCoord.xy / resolution;
float amnt = 0.0;
float nd = 0.0;
vec4 cbuff = vec4(0.0);

//vert lines
for (float i = 0.0; i < 4.0; i++) {
nd = sin(3.14 * 1.0 * pos.x + i * 800.0 + time ) /f0 * 0.2 * (pos.x + 0.3) + 0.5;
amnt = 1.0 / abs(nd - pos.x) * 0.005;

cbuff += vec4(amnt * pos.x, amnt * 0.2, amnt * pos.x, 1.0);
}
//horz lines
for (float i = 0.0; i < 4.0; i++) {
nd = sin(3.14 * 1.0 * pos.y + i * 1600.0 + time + f1) * 0.3 * (pos.y + 0.3) + 0.5;
amnt = 1.0 / abs(nd - pos.y) * 0.005;

cbuff += vec4(amnt * 0.2, amnt * 0.3, amnt * pos.y, 1.0);
}

//slow horz
for (float i = 0.0; i < 2.0; i++) {
nd = sin(3.14 * 1.0 * pos.y + i * 3200.0 + time + f2) * 0.4 * (pos.y + 0.3) + 0.5;
amnt = 1.0 / abs(nd - pos.y) * 0.005;

cbuff += vec4(amnt * 0.7, amnt * pos.x, amnt * 0.2, 1.0);
}

vec4 dbuff =  texture2D(backbuffer, 1.0 - pos) * 0.4;
  gl_FragColor = cbuff + dbuff;
}


