// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:brightness:
//f1:open:
//f2:horz squash count:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
// structure header
// by rotwang, some scrolling shapes for Krysler

float Krysler_620(vec2 p) {

float shade = 1.0/( sin( p.x + time ) - abs(p.y) / f1 );
shade = sqrt(shade) / 3.0;

return shade;
}

vec3 Krysler_620_clr(vec2 p) {

float shade = Krysler_620(p) * f0;
vec3 clr_a = vec3(shade*0.2, shade*0.26, shade);
vec3 clr_b = vec3(shade*0.7, shade*0.5, shade*0.6);
vec3 clr = clr_a*p.y*0.5; //  + clr_b*(1.0-p.y)*0.25;

clr += clr_b*(2.0-p.y);
return clr;
}

void main( void ) {

float aspect = resolution.x / resolution.y;
vec2 unipos = ( gl_FragCoord.xy / resolution );
 vec2 pos = unipos*2.0-1.0;//bipolar
pos.x *= aspect /f2;

vec3 clr = Krysler_620_clr(pos*3.0);

gl_FragColor = vec4(clr,  1.0);
}


