// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:beam distance:
//f1:beam width:
//f2:run flip:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

float VerticalBeamDistance =  40. + 120. * f0;
float BeamWidth = 10. + 30. * f1;
float xStepsPerBeam = 27.;

void main( void ) {
float CurrentBeamIndex = floor((gl_FragCoord.x + (VerticalBeamDistance / 2.)) / VerticalBeamDistance);
float CurrentVerticalBeamX = CurrentBeamIndex * VerticalBeamDistance;
float dist = distance(CurrentVerticalBeamX, gl_FragCoord.x);
float intensity = clamp((BeamWidth - dist) / BeamWidth, 0.,1.);


CurrentBeamIndex = floor(gl_FragCoord.x / VerticalBeamDistance)+1.;
float functionX = CurrentBeamIndex*xStepsPerBeam;
float effectiveY = sqrt(mod(pow(functionX,2.),40.))*50.+70.;
effectiveY += sin(CurrentBeamIndex+time*1.7)*70.;
dist = distance(effectiveY, gl_FragCoord.y) *f2;
intensity = max(intensity, clamp((BeamWidth - dist) / BeamWidth, 0.,1.));

vec3 color = vec3(1.0,1.0,0.5);
gl_FragColor = vec4(color * intensity, 1.0);
}


