// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:thickness:
//f1:shift:
//f2:zoom:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

// http://glslsandbox.com/e#45969.0

float time = float(itime) + ftime;


vec2 ifs( vec2 _p, vec2 _shift ) {
  vec2 pos = _p;

  vec2 shift = _shift * (f1 + .5); 
  for ( int i = 0; i < 5; i ++ ) {
    float intensity = pow( 2.0, -float( i ) );
    pos = abs( pos ) - shift * intensity;
    if ( pos.x < pos.y ) { pos.xy = pos.yx; }
  }

  return pos;
}

//---------------------------------------------------------------------------------------------------
void main(void) {

//vec2 size = vec2(0.3,0.3);
vec2 size = vec2(f0,f1);

vec2 pos = ( gl_FragCoord.xy / tres.xy - 0.5 ) * (20.0 +(20.*f2) );
pos = ifs(pos, vec2(9.0, asin(sin(time /2.0)) * 7.0 + 7.5)).xy;

float color = 0.0;
color = abs( pos.x ) < size.x && ( pos.y ) < size.y ? 1.0 : 0.0;

gl_FragColor = vec4(color * vec3(1, 1, 1), 1.0 );
   
} //endof main


