// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

//f0:sphere horz:
//f1:sphere vert:
//f2:sphere brightness:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

uniform vec2 pd;
vec2 uv;

float circle(vec2 uv){
float k = length(uv)<0.09 * f0 ? 1.0:0.0;
return k;
}

float bloom(vec2 pos){
float g= 2. * f2-length(uv+vec2(pos));
return g;
}

void main(void){
uv = (gl_FragCoord.xy / resolution.xy)*2.0-1.0;
vec2 uv2 = (gl_FragCoord.xy / resolution.xy);
float r;
float j;
float h=pd.x;
float time=time;
float mx=f0*2.0-1.0;
 float my=f1*2.0-1.0;

for(float i=0.0;i<100.0;i++){
r += circle(uv+vec2(
fract(i/10.0)*2.0-0.9,
fract(floor(i/10.0)/10.0)*2.0-0.9
));
}


j=bloom(uv+vec2(mx*-2.0,my*-2.0));
r = r+j;


gl_FragColor=vec4(r,r,r,1.0);
}


