// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:wave frequency:
//f1:grid brightness:
//f2:wave color mod:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
// by @DonMilham

void main( void ) {

vec2 position = gl_FragCoord.xy / resolution.xy;
float t = time + position.x * f0;

vec2 o, off;

o = 1.0 - abs(2.0 * fract(15.0 * position) - 1.0);
off = .5 * o + .5 * pow(o, vec2(7));
float grid2 = .5 * max(off.x, off.y);

o = 1.0 - abs(2.0 * fract(1.0 * position) - 1.0);
off = .5 * o + .5 * pow(o, vec2(11));
float grid1 = .5 * max(off.x, off.y);

vec4 grid = vec4(0, f1 * grid2 + grid1, 0, 1);

float f = clamp(1.0 - abs(position.y - .3 * sin(t*6.0)-.5), 0.0, 1.0);
float func1 = pow(f, 22.0);

vec4 func = .7 * vec4(func1 - f2, func1 * f2, func1, 1);

gl_FragColor = grid + func;



}


