// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:ripple 1:
//f1:ripple 2:
//f2:blur:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

float circle(vec2 centre, float rad) {
vec2 aspect = vec2(resolution.x/resolution.y, 1.0);
float c = length(aspect*((gl_FragCoord.xy/resolution.xy) - centre)) / rad;
c = pow(c, 10.0);
return 1.0-c;
}

void main( void ) {

float m = sin(time) * 0.5;

float c = circle(vec2(0.5) + vec2(m, 0.0) * 0.1, 0.2);


vec2 centre = gl_FragCoord.xy - resolution.xy * 0.5;
centre /= resolution;

float y = centre.y / resolution.y;
float x = centre.x / resolution.x;

//float centre = gl_FragCoord - resolution * 0.5;
float d = length(centre.xy);
float angle = atan(y/x);
angle = acos(x/d);

angle += d * f0;

x = d * cos(angle*d);
y = d * sin(angle*d);

c = cos(y*100.0)*sin(time-y-cos(x*30.0));

c *= cos(x* 100.0 *f1 );

c += 1.0 * f2;
c /= 2.0;

gl_FragColor = vec4(c, c, c, 1.0);
}


