// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:center x:
//f1:center y:
//f2:ring count:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);


float time = float(itime) + ftime;
vec2 resolution = tres;

float interpolate(float x, float min_x, float max_x) {
return x * max_x + (1.0 - x) * min_x;
}

float normsin(float x) {
return (sin(x) + 1.0) / 2. * f2 + .2;
}

void main(void) {
vec2 position = ( gl_FragCoord.xy / resolution.x );

float color = normsin(30. * position.x + interpolate(normsin(25. * position.y + 10.0 * f0), 5.0, 25.) + 
      30. * position.y + interpolate(normsin(25. * position.x + 10.0 * f1), 5.0, 25.) + 2. * time);
gl_FragColor = vec4( color, color, color, 1.0 );

}


