// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:zoom:
//f1:center brightness:
//f2:scramble:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

// water turbulence effect by joltz0r 2013-07-04, improved 2013-07-07
float time = float(itime) + ftime;
#define MAX_ITER 4
void main( void ) {

//vec2 p = tcoord*4.0;
vec2 p = ( gl_FragCoord.xy / tres.xy)*8.0 - 2.;
p.y-=1.7;
p.x-=1.9;

vec2 i = p * f0 * 4.;
float c = 0.0;
float inten = 2.0 * f1 + 0.5;

for (int n = 0; n < MAX_ITER; n++) {
float t = time* (1.0 - (0.007* f2 * float(n+1)));
i = p + vec2(
cos(t - i.x) + cos(t + i.y), 
sin(t - i.y) + cos(t + i.x)
);
c += 1.0/length(vec2(
p.x / (sin(i.x+t)/inten),
p.y / (cos(i.y+t)/inten)
)
);
}
c /= float(MAX_ITER);

gl_FragColor = vec4(vec3(c), 1.0);
}


