// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
	precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:grids:
//f1:zoom:
//f2:rotate:
float f0 = mix(0.05, 1.0, fparams[0]);
float f1 = mix(0.00, 1.0, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

uniform vec2 reyboard;

const float PI = 3.1415926535;
const float TWOPI = PI*2.0;

vec2 rotate(vec2 point, float rads) {
float cs = cos(rads);
float sn = sin(rads);
return point * mat2(cs, -sn, sn, cs);
}

float unsin(float t)
{
return sin(t)*0.5+0.5;
}

float curve( float x)
{
return smoothstep( 0.0, 3., unsin(x*TWOPI) + cos(x*PI) ) - unsin(x*TWOPI);
}

float thing(vec2 pos) {
float offset = 0.;
float row = floor((pos.y-1.)/2.);
if (mod(row, 2.0) <= 1.0)
offset = curve(unsin(pos.x)*sin(time));
float a = curve(pos.x + curve(unsin(pos.y)*sin(-time)));
float b = curve(pos.y - offset);
float c = distance(a, b);
return a + b + c;
}

void main(void) {
vec2 position = ( ( gl_FragCoord.xy / resolution ) - .5 ) * f0 + .5 ;
vec2 world = position * 14.0 - 7.  ;
world.x *= resolution.x / resolution.y ;
world = rotate(world, radians(360. * f2));
float dist = 2.0*thing(world) + f1;

gl_FragColor = vec4( dist, dist, dist, 1.0 );
}



