// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:horz pos:
//f1:zoom:
//f2:color pos:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
// rotwang mod* much

vec3 hsv2rgb(float h,float s,float v) {
return mix(vec3(1.),clamp((abs(fract(h+vec3(3.,2.,1.)/3.)*6.-3.)-1.),0.,1.),s)*v;
}

void main( void ) {
float speed = time*0.5;
float aspect = resolution.x /resolution.y;
vec2 unipos = ( gl_FragCoord.xy / resolution );
vec2 pos = unipos*2.0-1.0;
pos.x *=aspect * f0;

vec2 position = (gl_FragCoord.xy - resolution * 0.7) / resolution.yy;

float longest = sqrt(float(resolution.x*resolution.x) + float(resolution.y*resolution.y))*0.5;
float dx = gl_FragCoord.x-resolution.x/2.0 * sin(f0) * 2. ;
float dy = 1.01+gl_FragCoord.y-resolution.y/2.0;
float len = sqrt(dx*dx+dy*dy) * f1;
float ds = len/longest;
float md = time*0.5;

float ang =  abs(atan(dy,(ds*dx)))/ds;


float hue = 0.5 +  sin(ang )*0.5+0.5;
hue /= 8. * f2;
float sat =  cos(ang + md*2.0);
float lum =  sin(ang  + md*2.0) * length(pos);

vec3 clr = hsv2rgb(hue,sat,lum);

gl_FragColor = vec4( clr, 1.0 );

}


