// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:x pos:
//f1:y pos:
//f2:heart size:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.2, 0.95, fparams[2]);
//va2626.glsl
float time = float(itime) + ftime;
vec2 resolution = tres;

float segm( float a, float b, float c, float x ) {
    return smoothstep(a-c,a,x) - smoothstep(b,b+c,x);
}


vec3 heart( float x, float y ) {
    float s = mod( time, 2.0 )/2.0;
    s = 0.9 + 0.1*(1.0-exp(-5.0*s)*sin(50.0*s));
    x *= s;
    y *= s;
    float a = atan(x,y)/3.141593;
    float r = sqrt(x*x+y*y);

    float h = abs(a);
    float d = (13.0*h - 22.0*h*h + 10.0*h*h*h)/(6.0-5.0*h);

    float f = smoothstep(d-0.02,d,r);
    float g = pow(1.0-clamp(r/d,0.0,1.0),0.25);
    return mix(vec3(0.5+0.5*g,0.2,0.1),vec3(1.0),f);
}


void main(void) {

    vec2 p = (-1.0+2.0*gl_FragCoord.xy/resolution.xy) * vec2(f2 * 2.);

    vec3 col = heart(2.0*p.x + 2.*(f0-.5), 2.0*p.y + 2.*(f1-.5) );
    gl_FragColor = vec4(col,1.0);
}


