// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:x offset:
//f1:y offset:
//f2:zoom:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);
//http://glslsandbox.com/e#48503.1

float time = float(itime) + ftime;
//---------------------------------------------------------------------------------------------------
#extension GL_OES_standard_derivatives : enable
#define R(a) mat2(cos(a), sin(a), -sin(a), cos(a))

float chebyshevDistance(vec2 a, vec2 b) {    
   a *= 2.5 * R(0.78332691);
   vec2 p = abs(b - a);
   return max(p.x, p.y);
}

float createTexture(in vec2 uv, float T) {
return cos(uv.x * 9.) * sin(uv.y * 9.);
}

void main(void) {

float T = time;
vec2 uv = (2. * gl_FragCoord.xy - tres) / tres.y;
float tmp = uv.y; //in order to avoid rotation of the canvas
uv *= R(T * .5);
float d = chebyshevDistance(uv, vec2(f0,f1) -0.5);
float t = 1. / d *f2;
vec2 st = uv * t + vec2(0., t + T);
vec3 color = vec3(createTexture(st, T));
gl_FragColor = mix(acos( tmp * 1.3337)-vec4(3.0, 2.0, 1.0, 0.0), vec4(0.5/color, 1.0),  8.0/(pow(d, 3.)) );
gl_FragColor.a = 1.0;
   
} //endof main


