// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
	precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:hex size:
//f1:diag zoom:
//f2:offset:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.00, 1.0, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

// @eddbiddulph - modulated hexagons by the hexagon shape itself, and added some colour.

// 1 on edges, 0 in middle
float hex(vec2 p) {
p.x *= 0.57735*2.0 ;
p.y += mod(floor(p.x), 2.0)*0.5 * 4.* f2;
p = abs((mod(p, 1.0) - 0.5)) ;
return abs(max(p.x*1.5 + p.y, p.y*2.0) - 1.0);
}

vec3 palette(float i) {
i = mod(i, 3.0);
if(i < 1.0)
return vec3(1.0, 0.4, 0.4);
else if(i < 2.0)
return vec3(0.4, 1.0, 0.4);
else
return vec3(0.4, 0.4, 1.0);
}

void main(void) {
vec2 pos = gl_FragCoord.xy;
vec2 p = pos/40.0;

float d = (hex(pos /(700.0 * f1 + 100. )) + time) ;
float df = fract(d) * f0;
float di = floor(d);

float r = 1.0 - (smoothstep(0.0, 0.3, df) - smoothstep(0.3, 0.6, df));

gl_FragColor.rgb = palette(di) * smoothstep(r, r + 0.05, hex(p));
gl_FragColor.a = 1.0;
}


