// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:twist:
//f1:center zoom:
//f2:brightness:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.2, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

vec2 mouse = vec2(f0, f1);
float time = float(itime) + ftime;
vec2 resolution = tres;
const float pi=3.1415926535;

float white=0.7;
float black=0.1;
vec2 size=resolution;
float scale=1.0;

const int num=11;

float wave(vec2 pos,float angle,float wavelength,float phase) {
return sin(dot(pos,vec2(cos(angle),sin(angle)))*2.0*pi/wavelength+phase);
}

void main() {
vec2 pos=gl_FragCoord.xy/scale-size/2.0;

float amp=0.0;
for(int i=0;i<num;i++) {
float angle=float(3*i)*pi/float(num) * f0;
amp+=wave(pos,angle,60.0 * f1,time);
}

float y=gl_FragCoord.y/mouse.x;

float c=sin(pi*12.0*(amp+float(num))/float(num)/2.0);
c=clamp(c,0.0,1.0);
c=pow(c,3.0);
c=black+(white-black)*(c+y)*0.2;
//gl_FragColor=vec4(vec3(c),1.0);

gl_FragColor=vec4(vec3(amp * f2),1.0);
}


