// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:mod movement:
//f1:light size:
//f2:flare size:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

//some bad lens flare rendering //by MrOMGWTF

float point(vec2 p, vec2 p2) {
return pow(1.0 / (distance(p, p2)) * 0.02, 0.75);
}

float bokeh(vec2 p, float r, float smooth) {
vec2 q = abs(p /f1);
float d = dot(q, vec2(0.866024,  0.5));
float s = max(d, q.y) - r * 2.;
return smoothstep(smooth, -smooth, s);
}
vec3 adjust(vec3 color) {
return color*color;
}
void main( void ) {

vec2 p = (gl_FragCoord.xy / resolution.xy - vec2(0.5,0.5)) * vec2(1.0, resolution.y/resolution.x);
vec3 color;
vec2 center = vec2(0.0);

vec2 flare = vec2(-f0 * sin(time), f0 * .5  * sin(time) +  0.7 * cos(time) * 0.5) * .55;

vec2 flaredir = normalize(center - flare);
color = vec3(0.0);
//sun
vec3 sun = vec3(0.0);
sun += pow(vec3(1.0, 0.9, 0.8) * bokeh(p -flare ,0.05, 0.1) * 1.0, vec3(2.0));
sun += vec3(1.0, 0.86, 0.8) * point(p, flare);

//ghosts
vec3 ghosts = vec3(0.0);
ghosts += adjust(vec3(1.0, 0.9, 0.8) * bokeh(p + flare * 0.3,0.05, 0.004)) * 0.2;
ghosts += adjust(vec3(1.0, 0.8, 0.7) * bokeh(p + flare * - 0.2,0.03, 0.003)) * 0.3;
ghosts += adjust(vec3(1.0, 1.0, 0.9) * bokeh(p + flare * 0.6,0.06, 0.010)) * 0.2;
ghosts += adjust(vec3(1.0, 1.0, 0.9) * bokeh(p + flare * 1.5,0.09, 0.015)) * 0.1;


ghosts = pow(ghosts, vec3( (10.0 * f2) + 2. - max(abs(flare.x),abs(flare.y))))*1.75;
ghosts = pow(ghosts, vec3(2.0)) * 3.75;

color = adjust(sun) + ghosts;

gl_FragColor = vec4(sqrt(color), 1.0 );

}


