// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:mod 1:
//f1:mod 2:
//f2:mod 3:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

vec2 mouse = vec2(f0, f1);
float time = float(itime) + ftime;
vec2 resolution = tres;
// structure header
// Antialiased mandelbrot set by Kabuto
// Set quality to 1 (or even 0.5)
// See 1603.4 for a version that renders julia sets instead

const int MAX_ITER = 2;

const float ANTIALIAS = 1.0; // .5 = smoother but wider

float point(vec2 s) {
vec4 a = vec4(s,1,0);
vec4 c = vec4(s,1,0) * (vec4(mouse, mouse) + f2);

for(int iter = 0; iter < MAX_ITER; iter++) {
// Testing every 4th iteration is enough for not getting float overflow and makes this routine much faster
a = a.x*a*vec4(1. * abs(sin(time * 3.0)),1. * sin(time * 3.0),2. * abs(sin(time * 3.0)),2)+a.y*a.yxwz*vec4(-1,1,-2,2)+c;
a = a.x*a*vec4(1. * abs(sin(time * 5.0)),1. * sin(time * 5.0),2. * abs(sin(time * 5.0)),2)+a.y*a.yxwz*vec4(-1,1,-2,2)+c;
a = a.x*a*vec4(1. * abs(sin(time * 5.0)),1. * sin(time * 5.0),2. * abs(sin(time * 5.0)),2)+a.y*a.yxwz*vec4(-1,1,-2,2)+c;
a = a.x*a*vec4(1. * abs(sin(time * 5.0)),1. * sin(time * 5.0),2. * abs(sin(time * 5.0)),2)+a.y*a.yxwz*vec4(-1,1,-2,2)+c;
if(a.x*a.x+a.y*a.y > 4.) {
return length(a.zw)/length(a.xy)/log(length(a.xy));
}
}
return 1e10;

}
 
void main( void ) {
float zoom = 1.0;

vec2 p = (( gl_FragCoord.xy / resolution.xy - .5))*vec2(resolution.x/resolution.y, 1.) * 2. * zoom + vec2(-.7476,.115);

float z = ANTIALIAS/(point(p)*zoom/resolution.y);
gl_FragColor = vec4(vec3(z)*vec3(0.15,0.5,1.0), 1.);
}


