// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:center x glow:
//f1:center y glow:
//f2:glow radius:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.5, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
// structure header
uniform sampler2D backbuffer;

void main( void ) {

vec2 position = ( gl_FragCoord.xy / resolution.xy );

float color = 0.0;
color += sin( position.x * cos( time / 15.0 ) * 80.0 ) + cos( position.y * cos( time / 15.0 ) * 10.0 );
color += sin( position.y * sin( time / 10.0 ) * 40.0 ) + cos( position.x * sin( time / 25.0 ) * 40.0 );
color += sin( position.x * sin( time / 5.0 ) * 10.0 ) + sin( position.y * sin( time / 35.0 ) * 80.0 );
color *= sin( time / 10.0 ) * 0.5;

gl_FragColor = vec4( vec3( color, color * 0.5, sin( color + time / 3.0 ) * 0.75 ), 1.0 );

        // Bump mapping starts here
vec2 uv = position;
vec2 d = 2./resolution;
float dx = texture2D(backbuffer, uv + vec2(-1.,0.)*d).x - texture2D(backbuffer, uv + vec2(1.,0.)*d).y ;
float dy = texture2D(backbuffer, uv + vec2(0.,-1.)*d).x - texture2D(backbuffer, uv + vec2(0.,1.)*d).x ;
d = vec2(dx,dy)*resolution/1024.;
gl_FragColor.z = pow(clamp(1.-1.5*length(uv  - vec2(f0,f1) + d),0.,1.),4.0 *f2 );
gl_FragColor.y = gl_FragColor.z*1.25 + gl_FragColor.x*0.4;

gl_FragColor *=1.25;


}


