// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:horz stretch:
//f1:vert stretch:
//f2:vert thickness:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);


float time = float(itime) + ftime;
vec2 resolution = tres;

float color(vec2 pos, float time) {
float r = length(pos);
float w = atan(pos.y,pos.x);
w = (fract(w/3.14159265*16.+.5)-.5)*r/16.*3.14159265;
r = fract(r-time)-.5;

return step(w*w+r*r,.1);
}

void main( void ) {

vec2 p = ( gl_FragCoord.xy - resolution.xy*.5 )/resolution.x * ( 10. + 20. * vec2(f0, f1) );

float a = .99;

p.x -= floor(a*time*.05+.5)*20.;


vec2 l = vec2(p.x,time);
l *= mat2(1,a,a,1)/sqrt(1.-a*a);
p.x = l.x;
p.y /= f2;

gl_FragColor = vec4(color(p,l.y));

}


