// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:ring stripes:
//f1:glow center:
//f2:zoom:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.3, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

float pi = 3.14159265;

float cubicPulse( float c, float w, float x ) {
    x = abs(x - c);
    if( x>w ) return 0.0;
    x /= w;
    return 1.0 - x*x*(3.0-2.0*x);
}
float innerCore(float r, float coreWidth){
//return 1.0 - (r/coreWidth); 
return 1.0 - smoothstep(coreWidth-0.05,coreWidth,r);
}

float midCore(float r, float start, float end){
float haloWidth = end - start; 
float midPoint = (start+end)/2.0;
float pulseWidth = 0.02;// + 0.01 * sin(10.0*time); 
return cubicPulse(r,pulseWidth,midPoint);
}

float graphPattern(float r, float theta, float spacing){
r*=spacing;
if(fract(r)<0.05){
return 1.0; 
}
if(fract(theta*12.0)<0.05){
return 1.0;
}
}

void main( void ) {
vec2 position = ( gl_FragCoord.xy / resolution.xy );
vec2 centre = vec2(0.5); 

float aspectRatio = resolution.x/resolution.y; 
centre.x *= aspectRatio;
position.x *= aspectRatio;
float d = distance(position,centre) * 2. * f2 ; 

vec2 offset = position - centre; 
float theta = atan(offset.y,offset.x);
theta = (theta+pi)/(pi*2.0);


float finalColor = 0.0;
finalColor += innerCore(d,.275*f1); 


float activateRing = 0.2;
if(fract(time*0.5+theta*16.0 * f0) > 0.5){
activateRing = 1.0;
}

finalColor += activateRing * midCore(d,0.2,0.4);

gl_FragColor = vec4(finalColor);
gl_FragColor.r += graphPattern(d,theta,20.0);
gl_FragColor.g += theta;

}


