// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:horz pos:
//f1:vert pos:
//f2:blade count:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);


float time = float(itime) + ftime;
vec2 resolution = tres;
// structure header
//  fork'd by @dennishjorth. Thanks to the original (#6054.0).

#ifdef GL_ES
precision mediump float;
#endif

//cut uniform float time;
//cut uniform vec2 resolution;

// Singularity -- Using this for other applications. Makes a good flare image. Thanks to whoever made this originally!

float BLADES = 2.0 + (8.0 * f2);
#define BIAS 0.2
#define SHARPNESS 5.0
#define COLOR 0.4, 0.65, 0.82
#define BG 0.34, 0.52, 0.76

void main( void ) {

vec2 sunpos = (vec2(f0,f1) - 0.5) / vec2(resolution.y/resolution.x,1.0);
sunpos.x += cos(time*0.5)*cos(time*0.1)*0.3;
sunpos.y += sin(time*0.5)*cos(time*0.1)*0.3;
vec2 position = (( gl_FragCoord.xy / resolution.xy ) - vec2(0.5)) / vec2(resolution.y/resolution.x,1.0);
vec2 t = position.yx - sunpos.yx;
float alpha = 1.; //sunpos.x * 0.5 + sin(time * 0.1) * 0.02;
//t = mat2(cos(alpha), -sin(alpha), sin(alpha), cos(alpha)) * t;

float blade = clamp(pow(sin(time*0.7+atan(t.x, t.y)*(BLADES+2.0))+BIAS, SHARPNESS), 0.0, 1.0);

float dist = .2 / distance(sunpos, position) * 0.075;
float dist2 = 2.5+0.5*cos(time*0.3);// - distance(vec2(0.0), sunpos);
dist2 = pow(dist2, 3.5);
dist *= dist2*dist2*0.02;

vec3 color = vec3(0.0);
//color = mix(vec3(0.34, 0.5, 1.0), vec3(0.0, 0.5, 1.0), (position.y + 1.0) * 0.5);

color += vec3(0.95+blade, 0.65, 0.35) * dist;
color += vec3(0.95, 0.45, 0.30) * min(1.0, blade *0.7) * dist*1.;

gl_FragColor = vec4( color.x,color.y,color.z, 1.0 );
}


