// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

float time = float(itime) + ftime;
vec2 resolution = tres;// for easier glslsandbox.com conversion

float rand(float x){return fract(sin(x)*1e4);} 
vec4 blend(vec4 c, vec4 o){return o*o.a + c*(1.-o.a);}

vec3 hsv(vec3 c) {
    vec4 k=vec4(1.,2./3.,1./3.,3.);
    vec3 p=abs(fract(c.xxx+k.xyz)*6.-k.www);
    return c.z*mix(k.xxx,clamp(p-k.xxx,0.,1.),c.y);
}

vec4 city(vec2 uv, float zoomx, float speed, float hCenter, float hAmpl, float hue, float wavespeed) {
    uv.x+=time*speed;
    uv.x*=zoomx;
    uv.x+=rand(floor(uv.x))*.5;
    uv.y+=sin(floor(uv.x)*.5+time*wavespeed)*.1;
    float h=mix(hCenter-hAmpl, hCenter+hAmpl, uv.y);
    float s=step(rand(floor(uv.x)),h);
    float y=mix(.2, 1., uv.y);
    vec3 c=hsv(vec3(hue, 1., 1.));
    return mix(vec4(c,y),vec4(0.),s);
}


//---------------------------------------------------------------------------------------------------
// https://www.shadertoy.com/view/4ssBRM
void main(void) {
//f0:bldg scal:
//f1:hue cycle:
//f2:bldg wave:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.0, 1. , fparams[1]);
float f2 = mix(0.4001,  0.401 , fparams[2]);

    vec2 uv = tcoord.xy;
    vec4 c=vec4(hsv(vec3(.75,1.,mix(.6,.1,uv.y))),.0);
    for (int i = 0; i < 4; ++i) {
        float f=float(i);
    c=blend(c,city(uv, 40.-f*8.,.2 - f*.04 , .8*f0+.05*f, .4+.2*f, .7-f*f1, 2.+f*f2));
    }
gl_FragColor = vec4(c.rgb, 1.0);

} //endof main


