// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:checker size:
//f1:wave size:
//f2:color rotate:
float f0 = mix(0.2, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
// @rotwang: testing smoothrect

vec3 hsv2rgb(float h,float s,float v) {
return mix(vec3(1.),clamp((abs(fract(h+vec3(3.,2.,1.)/3.)*6.-3.)-1.),0.,1.),s)*v;
}

float smoothrect( float f) {
    float r = sign(sin( f * f0));
    float s = sin( f * f1);
    return mix(r,s, 1.0 - abs(s));
}

void main( void ) {

float aspect = resolution.x /resolution.y;
vec2 unipos = ( gl_FragCoord.xy / resolution.xy );
unipos.x *=aspect;

float sint = sin(time);
float cost = cos(time) * f2;
float size = 32.0;

float a = sint * smoothrect(  unipos.x *size);
float b = cost * smoothrect(  unipos.y *size );
float shade = mix(a,b, pow(sint*4.0,cost));
shade = clamp(shade,0.0,0.45);
shade *= unipos.x*2.0;

gl_FragColor = vec4(hsv2rgb(shade, 0.86, shade*2.0), 1.0); 

}


