// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
	precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:x pos:
//f1:y pos:
//f2:spiral n dots:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

const float PI = 3.14159;
const float TWO_PI = 2.0 * PI;
const float a = 0.1;
const float b = 0.15;

void main( void ) {

vec2 position = ( gl_FragCoord.xy / resolution.xy );

vec2 toCenter = position - vec2(0.5) * vec2(f0,f1) * 2.;
float diff = length( toCenter ) ;
float angle = acos(dot(toCenter, vec2(0.0, 1.0)) / diff);
if (toCenter.x > 0.0)
angle = TWO_PI - angle;
angle /= TWO_PI;

float testTheta = log(diff / a) / b * 2. * f2;
testTheta += time;
testTheta = fract(testTheta / TWO_PI);

float strength = 2.0 * abs( 0.5 - abs(abs(testTheta) - angle));
vec3 color = vec3(
sin(position.x * position.x + time),
sin(position.y - time),
sin(f2 * time)  * cos(position.y * time)
);
color *= strength;

gl_FragColor = vec4( color, 1.0 );

}


