// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
//
//
// .default fragment shader

varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

//---------------------------------------------------------------------------------------------------
// metadata
// source :  http://glslsandbox.com/e#35464.0
//f0:center zoom:
//f1:circle thickness:
//f2:shadow zoom:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

//---------------------------------------------------------------------------------------------------
void main(void) {

float mytime = float(itime) + ftime;

vec2 uv = ( gl_FragCoord.xy / tres.xy );
uv = uv * 2.0 - 1.0;
uv.x *= tres.x / tres.y;

float t = atan(uv.y, uv.x) * 2.0;
float r = length(uv) * f0 * 1. + 0.5;
float c = sin(pow(sin(r * 3.141592 * 3.0), -2.0 *f1) + t * 6.0 - mytime *10.0);
float k = c * log(r+f2);

gl_FragColor = vec4( k, k, k, 1.0 );

} //endof main


