// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:horz stretch:
//f1:vert stretch:
//f2:diag stretch:
float f0 = mix(0.05, 0.95, fparams[0]) * 0.5;
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.13, 0.85, fparams[2]);

// http://www.glslsandbox.com/e#39904.10
float time = (float(itime) + ftime );
vec2 resolution = tres;

float random(in float x){ return fract(sin(x)*43758.5453); }
float random(in vec2 st){ return fract(sin(dot(st.xy ,vec2(12.9898,78.233))) * 43758.5453); }
mat2 rot(float p) { return mat2(cos(p),sin(p),-sin(p),cos(p)); }
 
float randomChar(vec2 outer,vec2 inner){
    float grid = 5.;
    vec2 ipos = floor(inner*grid);
    vec2 fpos = fract(inner*grid);
    return step(.5,random(outer*64.+ipos)) * step(0.01,fpos.x) * step(0.01,fpos.y);
}



//---------------------------------------------------------------------------------------------------
void main(void) {

    vec2 st = gl_FragCoord.st/resolution.xy * vec2(f0,1.-f1) * 4.;
    st.y *= resolution.y/resolution.x; 
    //st += vec2(3e-5*time);
//   st *= rot(0.4*time);
//   st *= 1.+.4*sin(1.3*time);
     st *= 12. * f2;
 
    vec2 ipos = floor(st);
    vec2 fpos = fract(st)+vec2(floor(time*2.),0.00001);
 
    ipos += vec2(0.,floor(time*6.*random(ipos.x+1.)));
 
    float pct = 1.0;
    pct *= randomChar(ipos,fpos);
 
    time = 0.0;
    gl_FragColor = vec4(cos(ipos.x+pct+time),sin(ipos.y+pct+time),0.5, 1.);


} //endof main


