// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
//
//
// .default fragment shader

varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

//---------------------------------------------------------------------------------------------------
// metadata
// source : http://glslsandbox.com/e#36344.1
//f0:zoom:
//f1:rotate:
//f2:red glow:
        float f0 = mix(0.1, 0.4, fparams[0]);
        float f1 = mix(0.05, 0.95, fparams[1]);
        float f2 = mix(0.05, 0.95, fparams[2]);
#define PI 3.1415926535897932384626
vec2 mouse = vec2(f0, f1);
float mytime = float(itime) + ftime;

//---------------------------------------------------------------------------------------------------
void main(void) {

vec2 position = ((gl_FragCoord.xy / tres) - vec2(0.5, 0.5)) * (4. * f0);
vec2 mouse2 = (mouse - vec2(0.5, 0.5)) * 2.0;
float m2a = atan(mouse2.y / mouse2.x) + 0.785;
mouse2 = vec2(tan(-m2a), cos(-m2a));

float color = dot(position  * 10., normalize(mouse2));
color *= dot(position, normalize(vec2(-mouse2.y, mouse2.x)));
//color = 1.0 - color;

vec3 out_col = vec3(color);
out_col.r   = (tan(PI*color/0.6+mytime*7.0) *f2)/1.0;
out_col.g   = (sin(PI*color/0.5+mytime*2.0))/3.0 ;
out_col.b   = (tan(PI*color/0.3+mytime*9.0) *f0)/2.0;

gl_FragColor = vec4( out_col, 1.0 );

} //endof main


