// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
//
//
// .default fragment shader

varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

//---------------------------------------------------------------------------------------------------
// metadata
// http://www.glslsandbox.com/e#40019.1
//f0:horz:
//f1:vert:
//f2:diag pull:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.2, 0.95, fparams[2]);

#define PI 3.1415926535897932384626
float time = (float(itime) + ftime) * 10.;
vec2 resolution = tres;


float rand(float n){return fract(sin(n) * 43758.5453123);}

float rand(vec2 n) { 
return fract(sin(dot(n, vec2(12.9898, 4.1414))) * 43758.5453);
}

float noise(float p){
float fl = floor(p);
  float fc = fract(p);
return mix(rand(fl), rand(fl + 1.0), fc);
}

float noise(vec2 n) {
vec2 d = vec2(0.0, 1.0);
  vec2 b = floor(n);
vec2 f = smoothstep(vec2(0.0), vec2(1.0), fract(n));
float h = mix(
mix(rand(b), rand(b + d.yx), f.x)
, mix(rand(b + d.xy), rand(b + d.yy), f.x)
, f.y);
return h;
}

//---------------------------------------------------------------------------------------------------
void main(void) {

vec2 p= ( gl_FragCoord.xy / resolution.xy ) + vec2(f0,f1)/ 2.0;
vec2 uv = p*20. * f2;
uv.x += noise(uv*3.+6.)*clamp(sin(time*0.5-uv.y),0.,1.);
uv.y += noise(uv*3.-5.)*clamp(sin(time*0.5-uv.x),0.,1.);
float color = 0.0;
color += .05/(uv.x-floor(uv.x))+.05/(uv.y-floor(uv.y));
gl_FragColor = vec4( vec3(1.)*color, 1.0 );


} //endof main


