// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

//f0:shape offset:
//f1:shape mode:
//f2:bg shade:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;// for easier glslsandbox.com conversion

#define TAU 6.28318530718

float segment(vec2 p, vec2 a, vec2 b) {
    vec2 ab = b - a;
    vec2 ap = p - a;
    float k = clamp(dot(ap, ab)/dot(ab, ab), 0.0, 1.0);
    return smoothstep(0.0, 5.0/resolution.y, length(ap - k*ab) - 0.001);
}

float shape(float u,vec2 p, float angle) {
    float d = 100.0;
    vec2 a = vec2(1.0, f1), b;
    vec2 rot = vec2(cos(angle), sin(angle)*u);
    
    for (int i = 0; i < 3; ++i) {
        b = a;
        for (int j = 0; j < 3; ++j) {
        b = vec2(b.x*rot.x - b.y*rot.y, b.x*rot.y + b.y*rot.x);
        d = min(d, segment(p,  a, b));
        }
        a = vec2(a.x*rot.x - a.y*rot.y, a.x*rot.y + a.y*rot.x);
    }
    return d;
}


//---------------------------------------------------------------------------------------------------
void main(void) {

time *= 10.;
vec2 uv = gl_FragCoord.xy / resolution.xy;
vec2 cc = (-resolution.xy + 2.0*gl_FragCoord.xy) / resolution.y;

float numPhases=40.5;
float u;
float t;
float SpeedReal=2.;
u=0.05+(f0 * 2.2);
//u=0.005+(1.0*2.2);
t = f0/resolution.x * numPhases;

float col = shape(u,abs(cc), t+cos(0.01*(time*SpeedReal))*TAU);
col *= 0.5 + 1.5*pow(uv.x*uv.y*(1.0-uv.x)*(1.0-uv.y), 0.3);

gl_FragColor = vec4(vec3(pow(1.0-col, 2.15 * f2)),1.0);


} //endof main


