// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

vec2 mouse = vec2(fparams.x, fparams.y);
float time = float(itime) + ftime;
vec2 resolution = tres;
// structure header
//f0:path oscillation:
//f1:box size:
//f2:box vert stretch:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float pi = atan(1.)*4.;

float cdist(vec2 v1,vec2 v2)
{
return max(abs(v1.x-v2.x),abs(v1.y-v2.y)*f2*2. );
}

void main( void ) {

vec2 p = ( gl_FragCoord.xy-(resolution/2.) );

vec3 c = vec3(0);
vec3 box = vec3(0);

for(float i = 0.;i < 6.;i++)
{
float a = time+i*(pi*2./3.*f0);

box = vec3(cos(a)*256.,0,((sin(a)*.5+f1)+0.75));

c += (cdist(p,box.xy) < 64.*(1./box.z)) ? vec3(1) : vec3(0);
}

gl_FragColor = vec4( c , 1.0 );

}


