// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

//f0:horz squeeze:
//f1:vert roll:
//f2:vert pushback:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.005, 0.3, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;// for easier glslsandbox.com conversion

float modI(float a,float b) {
    float m=a-floor((a+0.5)/b)*b;
    return floor(m+0.5);
}

//---------------------------------------------------------------------------------------------------
//http://www.glslsandbox.com/e#42054.4
void main(void) {

vec2 position = ( gl_FragCoord.xy / resolution.xy );

float scaleTime = time / 1000.0 + 1. / (time * time);
float x = abs(position.x - 0.5);
x = max(x, 0.001);
x = x * x * x;
float y = abs(position.y - f1);
y = max(y, f2 *2.);
x = min(x, y);
y = y * y * max(f0,0.03);
float baseRed = 0.5;
float baseGreen = 0.5;
float red = baseRed * tan(0.5 + floor(10. * x) + scaleTime);
float green = baseGreen * tan(0.5 + floor(10. * x / y) + scaleTime);

float blue;
if (modI(ceil(time * 10. + -(y / x) * 100.), 3.) == 0.) {
//blue = 0.3 + red / green;
} else {
//blue = 0.3 + green / red;
}
if (abs(sin(x * 100.0 + time) + cos(y * 20.0 + time)) < 0.3) {
float oldBlue = blue;
blue = red;
red = green;
green = oldBlue;
}
gl_FragColor = vec4( vec3( blue, green, red), 1. );

} //endof main


