// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:horz stretch:
//f1:vert stretch:
//f2:point zoom:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

void main(  ) {
vec2 p =(8.0*( gl_FragCoord.xy / resolution.xy )-4.0) * vec2(f0,f1);
p.x*=resolution.x/resolution.y;
vec2 c=2.0*vec2(cos(time*0.2),sin(time*0.2));
vec2 d=2.0*vec2(cos(time*0.2+3.14),sin(time*0.2+3.14));
//mix inversions
p=(p-c)/dot(p-c,p-c)-(p-d)/dot(p-d,p-d) /f2;
//RGB
float r= mod(exp(p.y),exp(p.y/p.x));
float g=mod(exp(p.x),exp(dot(p,c*p)));
float b=mod(exp(p.x)*exp(p.y),exp(dot(p,d*p)));


gl_FragColor = vec4 (0.5*clamp(abs(vec3(r,g,b )),0.,2.) , 1.);
}


