// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:planet size:
//f1:ray direction:
//f2:ray brightness:
float f0 = mix(0.5, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.2, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
// @danbri trying to transcribe from 
// http://imagine.cc/2011/07/18/a-formulanimation-class-with-inigo-quilez/

vec3  paintPixel(vec2 p) {
   float r = length(p);
   float d = 0.5;
   float f = (r<d) ? 0.0:1.0;
   vec3 col =  vec3(f * cos(3. * time  / (p.y /f1 - p.x )/f1) ,f*p.x,f-p.y) * f2;
   return col;
}


void main( void ) {
//vec2 p = .8 * ( gl_FragCoord.xy / resolution.xy ) ;//+ mouse / 4.0;
vec2 p = gl_FragCoord.xy / (resolution.xy/ f0);
gl_FragColor = vec4( vec3( paintPixel(p) ), 1.0 );
}



