// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:center x:
//f1:center y:
//f2:ball size:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

vec2 mouse = vec2(fparams.x, fparams.y);
float time = float(itime) + ftime;
vec2 resolution = tres;
// rotwang: mod*, smoothing, half-circle-fill // dist: angled-half-circle v3

void main( void ) {
vec2 pos = mod(gl_FragCoord.xy, vec2(50.0, 50.0)) - vec2(25.0, 25.0);
vec2 center = floor(gl_FragCoord.xy/vec2(50.0,50.0))*vec2(50.0,50.0)+vec2(25.0,25.0);
vec2 dir = (center.xy/resolution.xy-mouse.xy);
float dist_squared = dot(pos, pos);
float angle = atan(dir.y,dir.x)-3.1415*0.5;
pos *= mat2(cos(angle),sin(angle),-sin(angle),cos(angle));
float d = smoothstep(400.0, 500.0, dist_squared / f2 * .5);
float k = step(pos.y,.5);
vec3 clr = mix( vec3(k), vec3(0.5), d);
gl_FragColor =  vec4(clr, 1.0);

vec2 p = gl_FragCoord.xy / resolution.xy;
vec2 o = abs(p-mouse);
vec3 color = clamp(vec3(1.0-min(o.x,o.y)*400.0),0.0,1.0);
gl_FragColor += vec4(color , 1.0 );

}


