// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:zoom:
//f1:offset:
//f2:angle:

float f0 = mix(0.1, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
const float PI = 3.1415926535;

//---------------------------------------------------------------------------------------------------
//http://glslsandbox.com/e#51881.0
void main(void) {

    float count = 3.0;

    vec2 coord = gl_FragCoord.xy - resolution * 0.5;
coord *= 3.0 * f0;

    float phi = atan(coord.y, coord.x + 1e-6);
    phi = phi / PI * 0.5 + f2;
    float seg = floor(phi  * count );


    float theta = (seg + 0.5) / count * PI * 2.0;
    vec2 dir1 = vec2(cos(theta), sin(theta));
    vec2 dir2 = vec2(-dir1.y, dir1.x);

    float l = dot(dir1, coord);
    float w = sin(seg * 31.415926535) * 18.0 + 20.0;
    float prog = l / w + time * 2.0;
    float idx = floor(prog);

    float phase = time * 0.8;
    float th1 = fract(273.84937 * sin(idx * 54.67458 + floor(phase    )));
    float th2 = fract(273.84937 * sin(idx * 54.67458 + floor(phase + 1.0)));
    float thresh = mix(th1, th2, smoothstep(0.75, 1.0, fract(phase)));

    float l2 = dot(dir2, coord);
    float slide = fract(idx * 32.74853) * 200.0 * time;
    float w2 = fract(idx * 39.721784) * 500.0;
    float prog2 = (l2 + slide + f1*500.) / w2;

    float c = clamp((fract(prog) - thresh) * w * 0.3, 0.0, 1.0);
    c *= clamp((fract(prog2) - 1.0 + thresh) * w2 * 0.3, 0.0, 1.0);

    gl_FragColor = vec4(c, c, c, 1);
   
} //endof main


