// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:foreground:
//f1:midground:
//f2:background:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

//http://www.glslsandbox.com/e#43330.0

float time = float(itime) + ftime;
vec2 resolution = tres;// for easier glslsandbox.com conversion

const int layers = 3;
const float speed = 0.8;

float sawTooth(float x) {
   return abs(mod(x, 2.0) - 1.0);
}

//---------------------------------------------------------------------------------------------------
void main(void) {

   vec2 position = (gl_FragCoord.xy - resolution / 2.) / resolution.x;
   position.x += mod(time,10.) * speed;
   
   float c = 0.;
   float k = 1.;
   bool brk = false;

    float h;
    float p;

// layer 1
    h = 0.;
    p = 1.;
    for (int i = 0; i < 4; i++) {
         p *= sin(position.x * f0 *0.03) + 1.5;
         h += abs(sin(p)) * (0.5*sawTooth(position.x*p) - 0.25 - position.y / sqrt(k)) / p;
    }
    c = ceil(sign(h)) * k *f0;
    if (c <= 0.) {
      k -= 1. / float(layers);
      position.x -= 10. +   speed / float(layers);
      position.y -= 0.5 / float(layers);
    } else {
brk = true;
    }


// layer 2
  if (!brk) {
      h = 0.;
      p = 1.;
      for (int i = 0; i < 4; i++) {
         p *= sin(position.x * f1 *0.09) +  1.5;
         h += abs(sin(p)) * (0.5*sawTooth(position.x*p) - 0.25 - position.y / sqrt(k)) / p;
      }
      c = ceil(sign(h)) * k *f1;
      if (c <= 0.) {
      k -= 1. / float(layers);
      position.x -= 50. * speed / float(layers);
      position.y -= 0.6 / float(layers);
    } else {
brk = true;
    }

  } //endof if brk 


// layer 3
  if (!brk) {
      h = 0.;
      p = 1.;
      for (int i = 0; i < 4; i++) {
         p *= sin(position.x * 0.1) * f2 + 1.5;
         h += abs(sin(p*.5)) * (0.5*sawTooth(position.x*p) - 0.25 - position.y / sqrt(k)) / p;
      }
      c = ceil(sign(h)) * k * f2;
      if (c <= 0.) {
      k -= 1. / float(layers);
      position.x -= 10. + time * speed / float(layers);
      position.y -= 0.2 / float(layers);
    } else {
brk = true;
    }

  } //endof if brk 


   gl_FragColor = vec2(c, 1.).xxxy;
} //endof main


