// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:scale:
//f1:color step:
//f2:length:
float f0 = mix(0.3, 0.5, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);


float time = float(itime) + ftime;
vec2 resolution = tres;
// Posted by Trisomie21 // modified by @hintz

void main(void) {
float scale = f0 * 15.0;
float ring = 20.0 * f1 + 20.;
float radius = resolution.x*1.0;
float gap = scale*.7;
vec2 pos = gl_FragCoord.xy - resolution.xy * 0.5;

float d = length(pos) * (f2 * 2.);

// Create the wiggle
d += (sin(pos.y*0.25/scale+time)*sin(pos.x*0.25/scale+time*.5))*scale*5.0;

// Compute the distance to the closest ring
float v = mod(d + radius/(ring*2.0), radius/ring);
v = abs(v - radius/(ring*2.0));

v = clamp(v-gap, 0.0, 1.0);

d /= radius;
vec3 m = fract((d-1.0)*vec3(ring*-.5, -ring, ring*.25)*0.5);

gl_FragColor = vec4(m*v, 1.0);
}


