// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;//
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:x pos:
//f1:y pos:
//f2:glow:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
//---------------------------------------------------------------------------------------------------

//Noise animation - Electric
//by nimitz (stormoid.com) (twitter: @stormoid)

#define tau 6.2831853

mat2 makem2(in float theta){float c = cos(theta);float s = sin(theta);return mat2(c,-s,s,c);}

float noise(vec2 co){
    return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);
}

float fbm(in vec2 p) {
float z=2.;
float rz = 0.;
vec2 bp = p;
for (float i= 1.;i < 5.;i++) {
rz+= abs((noise(p)-0.5)*2.)/z;
z = z*2.;
p = p*2.;
}
return rz;
}

float dualfbm(in vec2 p) {
    //get two rotated fbm calls and displace the domain
vec2 p2 = p*.7;
vec2 basis = vec2(fbm(p2-time*1.6),fbm(p2+time*1.7));
basis = (basis-.5)*.2;
p += basis;

//coloring
return fbm(p*makem2(time*0.2)) *f2;
}

float circ(vec2 p) {
float r = length(p) * f2;
r = log(sqrt(r));
return abs(mod(r*4.,tau)-3.14)*3.+.2;

}

//---------------------------------------------------------------------------------------------------
// source : http://glslsandbox.com/e#35359.4
//void mainImage( out vec4 fragColor, in vec2 fragCoord )
void main() {
//setup system
vec2 p = gl_FragCoord.xy / tres.xy-0.5 * vec2(f0,f1) * 2.;
p.x *= tres.x/tres.y;
p*=4.;

        float rz = dualfbm(p);

//rings
p /= exp(mod(time*10.,3.14159));
rz *= pow(abs((0.1-circ(p))),.9);

//final color
vec3 col = vec3(.2,0.1,0.4)/rz;
col=pow(abs(col),vec3(.99));
gl_FragColor = vec4(col,1.);
}



