// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
//
//
// .default fragment shader

varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

//---------------------------------------------------------------------------------------------------
// metadata
//http://www.glslsandbox.com/e#42184.6
//f0:circle size:
//f1:color brightness:
//f2:zoom:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.2, 0.95, fparams[2]);
#define PI 3.1415926535897932384626
float time = float(itime) + ftime;
//---------------------------------------------------------------------------------------------------
void main(void) {
vec2 st = (gl_FragCoord.xy * 2.0 - tres) / min(tres.x, tres.y);

vec2 p = st * 10. * f2;
p = mod(p, 2.);

p.x += .1 * sin(2.5 * st.x + 4.*time);
p.y += .2 * cos(2.5 * st.y + 5.*time);

float r = .5;
float l = length(p - vec2(1.0));
float d = abs(l - min(0.75, f0));

float fr = 50. + 40. * sin(3.14*time + st.x);
float fg = 50. + 40. * sin(5.27*time + st.y);
float fb = 50. + 40. * sin(7.35*time);

vec3 color = vec3(1. / (fr * d), 1. / (fg * d), 1. / (fb * d));
color = color*smoothstep(.4, f1, color);

gl_FragColor = vec4(color, 1.0);


} //endof main


