// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;//
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:grid thick:
//f1:zoom:
//f2:legs:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
//---------------------------------------------------------------------------------------------------
// Original code: https://www.shadertoy.com/view/Xd3Gzs

#define sig(x) (2.*step(0.,x)-1.)
#define ss(x,f) sig(x)*smoothstep(abs(f)+(sss),abs(f)-(sss),abs(x))

#define rpt(x,m) (mod(x,m)-m*.5)
#define pix(x,b) ((floor(x*float(b))+.5)/float(b))

#define cos2(x) (2.*(cos(x)+1.))
#define sin2(x) (2.*(sin(x)+1.))

const float pi = 3.14159265359;
const float pi2 = pi*2.;
const float pih = pi*.5;
float sq2;
float sq2h;
float sq3;
float sq3h;
float sq3t;
const float sss = 1e-3;

void init() {
    resolution = tres.xy;
    sq2h = sq2*.5;
    sq3 = sqrt(3.);
    sq3h = sq3*.5;
    sq3t = 1./sq3;
}

vec2 tr(vec2 p) {
 p /= resolution.xy;
 p = -1.0+2.0*p;
 p.y *= resolution.y/resolution.x;
 return p * 2.*f1;
}

mat2 rotmd(float a) {
 a=radians(a);
 float c=cos(a),s=sin(a);
 return mat2(c,-s,s,c);
}

mat2 rotmr(float a) {
 float c=cos(a),s=sin(a);
 return mat2(c,-s,s,c);
}

float saw(float x) {
 return abs(fract(x)*2.-1.) * f2;
}

float saw2(float x) {
 return abs(fract(x)*4.-2.)-1.;
}

float rct(vec2 p,float w,float h) {
p=abs(p) * f0;
return ss(p.x,w) *ss(p.y,h);
}

float rct(vec2 p, float s) {
return rct(p,s,s);
}


//---------------------------------------------------------------------------------------------------
// source : http://glslsandbox.com/e#35359.4
void main() {
    init();
    vec2 glfc = gl_FragCoord.xy;
    vec2 p = tr(glfc);
    vec2 q = p;
    vec3 col = vec3(0.);
    mat2 r = rotmr(time*.1);

    p+=vec2(cos(time)*.2,sin(time*.7)*.5);
    float a = atan(p.y,p.x);
    float len = length(p);

    q.x=1.5/len+.5*time;
    q.y=a*6.+time*.3;
    q.y/=pi;
  
    float v = .0 +(rct(rpt(q,1./8.),1./32.)) * saw2(.5*(q.y+2.*saw(.5*q.x))) ;

    v*=smoothstep(.0,1.,len);

    col+=v*v;
    col*=vec3(cos2(4.*q.x),cos2(4.*q.x+2.),sin2(q.x+q.y));
    col*=exp(.7);
gl_FragColor = vec4( col, 1.0 );
}





