// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:x pos:
//f1:y pos:
//f2:intensity:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;

#define MAX_ITER 4

//---------------------------------------------------------------------------------------------------
// http://glslsandbox.com/e#39611.1
void main(void) {

            vec2 v_texCoord = gl_FragCoord.xy / tres;

            vec2 p =  v_texCoord * 9.0 - vec2(20.0 *f0, 20.*f1);
            vec2 i = p;
            float c = 2.0;
            float inten = .05;

            for (int n = 0; n < MAX_ITER; n++) {
                float t = time * (1.0 - (0.0060 / float(n+1)));

                i = p + vec2(cos(t - i.x) + sin(t + i.y),
                sin(t - i.y) + cos(t + i.x));
    
                c += 1.0/length(vec2(p.x / (sin(i.x+t)/inten),
                p.y / (cos(i.y+t)/inten))) * f2;
            }

            c /= float(MAX_ITER);
            c = 1.5 - sqrt(c);

            vec4 texColor = vec4(0.32, 0.15, 0.02, 1.);

            texColor.rgb *= (1.0 / (1.0 - (c + 0.05)));

            gl_FragColor = texColor;
   
} //endof main


