// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:highlights:
//f1:details:
//f2:posterize:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);


float time = float(itime) + ftime;
vec2 resolution = tres;
// changed by @hintz

vec2 c = vec2(0.5,0.5);
float pi = 3.14159;

vec3 hsv2rgb(float h,float s,float v) {
return mix(vec3(1.),clamp((abs(fract(h+vec3(3.,2.,1.)/3.)*6.-3.)-1.),0.,1.),s)*v;
}

vec3 shader( vec2 p ) {
// p = ( gl_FragCoord.xy / resolution.xy );

vec3 color = vec3(0.0);
vec2 uv = vec2(0.0);

float a = atan((p.x-c.x)/(p.y-c.y)) * f0;

float d = sqrt((p.x-c.x)*(p.x-c.x)+(p.y-c.y)*(p.y-c.y)) * f1;

uv = vec2(mod(a*8.0+sin(d*0.0),pi*2.0)/pi*0.5,mod(d*4.0,1.0));

float d2 = sqrt((uv.x-c.x)*(uv.x-c.x)+(uv.y-c.y)*(uv.y-c.y))*1.5 / f2;

color = mix(vec3(0.2),hsv2rgb(d+time*0.5,1.0,1.0),d2);
color = mix(color,vec3(1.0),pow(d2,4.0));

//color = vec3(d);

return vec3( color); 
}

void main( void ) {
vec2 p = ( gl_FragCoord.xy / resolution.xy );

vec3 color = vec3(0.0);
vec2 uv = vec2(0.0);

float a = atan((p.x-c.x)/(p.y-c.y));

float d = sqrt((p.x-c.x)*(p.x-c.x)+(p.y-c.y)*(p.y-c.y));
d = (sin(d)+.5 * .5)*d;

uv = vec2(mod(a*8.0+sin(d*16.0+time),pi*2.0)/pi*0.5,mod(pow(d*8.0,0.75),1.0));

d = sqrt((uv.x-c.x)*(uv.x-c.x)+(uv.y-c.y)*(uv.y-c.y));

color = shader(uv);

gl_FragColor = vec4( color, 1.0 );
}


