// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:brightness:
//f1:speed:
//f2:complexity:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.2, 0.95, fparams[2]);

vec2 mouse = vec2(fparams.x, fparams.y);
float time = float(itime) + ftime;
vec2 resolution = tres;
#define RADIANS 0.017453292519943295


const int zoom = 5;
float brightness = 0.975 * f0;
float fScale = .25;

float cosRange(float degrees, float range, float minimum) {
return (((1.0 + cos(degrees * RADIANS)) * f1) * range) + minimum;
}

void main(void) {

vec2 uv = gl_FragCoord.xy / resolution.xy;
vec2 p=(2.0*gl_FragCoord.xy-resolution.xy)/max(resolution.x,resolution.y);
float ct = cosRange(time*5.0, 3.0, 1.1)+500.0;
float xBoost = cosRange(time*0.1, 5.0, 5.0);
float yBoost = cosRange(time*0.1, 10.0, 5.0);

fScale = cosRange(time * 0.9, 0.75 , 0.75 /f2  );

for(int i=1;i<zoom;i++) {
float _i = float(i);
vec2 newp=p;
newp.x+=0.95/_i*sin(_i*p.y+time*cos(ct)*0.3/40.0+0.03*_i)*fScale+xBoost;
newp.y+=0.90/_i*sin(_i*p.x+time*ct*0.3/80.0+0.03*float(i+15))*fScale+yBoost;
p=newp;
}

vec3 col=vec3(0.5*sin(3.0*p.x)+0.5,0.5*sin(3.0*p.y)+0.5,sin(p.x+p.y));
col *= brightness;
gl_FragColor=vec4(col, 5.0);

}


