// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:horz stretch:
//f1:vert stretch:
//f2:zoom:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);


#define N 5

float time = float(itime) + ftime;
vec2 resolution = tres;
//---------------------------------------------------------------------------------------------------
//http://glslsandbox.com/e#49582.0
void main(void) {

vec2 v = (gl_FragCoord.xy - resolution/2.0) / min(resolution.y,resolution.x) * 30.0 * f2;

float x = v.x * f0 * 2.;
float y = v.y * f1 * 2.;

float t = time * 0.4;
float r;
for ( int i = 0; i < N; i++ ){
float d = 3.14159265 / float(N) * float(i) * 5.0 + f1;
r = length(vec2(x,y)) + 0.01;
float xx = x;
x = x + cos(y +cos(r) + d) + cos(t);
y = y - sin(xx+cos(r) + d) + sin(t);
}

gl_FragColor = vec4( cos(r*sin(time)), cos(r*sin(time)), cos(r*sin(time)), 1.0 );

   
} //endof main


