// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:horz stretch:
//f1:vert stretch:
//f2:zoom:

float f0 = mix(0.2, 0.95, fparams[0]);
float f1 = mix(0.2, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

// http://glslsandbox.com/e#49349.1

float time = float(itime) + ftime;

mat2 rotate(float a) {
float c = cos(a),
s = sin(a);
return mat2(c, -s, s, c);
}

//---------------------------------------------------------------------------------------------------
void main(void) {

time *= 2.;

  vec2 uv = 3.6*(2. * gl_FragCoord.xy - tres) / tres.y * vec2(f0,f1);
vec3 color = vec3(0);
if (uv.y < 0.0)   // horizontal mirroring
{ 
  uv.y *= 4.0;
  color = vec3(-0.3);  // darker
}
vec3 rd = vec3(uv, 1.);

float s = f2;
for (int i = 0; i < 5; i++) {
rd = abs(rd) / dot(rd, rd); // kali iteration!! Thanks Kali
rd -= s;
rd.xy *= rotate(0.1 + time *0.110);
rd.xz *= rotate(0.2 - time *0.123);
rd.zy *= rotate(0.3 + time *0.131);
s *= 0.8;
float b = 0.005;
color.gb += .014 / max(abs(rd.x*0.8), abs(rd.y*0.8));
color.rb += .015 / max(abs(rd.y*0.6), abs(rd.z*0.6));
color.rg += .010 / max(abs(rd.x*0.7), abs(rd.z*0.9));
}
color *= 0.4;
gl_FragColor = vec4(color, 1.);
 
} //endof main


