// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:center x:
//f1:center y:
//f2:detail frequency:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);


float time = float(itime) + ftime;
vec2 resolution = tres;
#define pi 3.1415927410125

void main() {

vec2 pos = gl_FragCoord.xy / resolution - vec2(f0, f1);
pos.x *= (resolution.x / resolution.y);

float u = length(pos);
float v = atan(pos.y, pos.x);
float t = time / 0.5 + 1.0 / u;

float intensity = abs(sin(t * 4.0 + v)+sin(v*20.0 *f2)) * .25 * u * 0.25;
vec3 col = vec3(-sin(v*4.0+v*2.0+time), sin(u*8.0+v-time), cos(u+v*90.0+time))*16.0;

gl_FragColor = vec4(col * intensity * (u * 24.0), 1.0);
}


