// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:zoom assist:
//f1:petal offset:
//f2:brightness:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
// 2013-03-30 by @hintz

#define M_PI 3.14159265359

vec3 hsvtorgb(float h, float s, float v) {
float c = v * s;
h = mod((h * 6.0), 6.0);
float x = c * (1.0 - abs(mod(h, 2.0) - 1.0));
vec3 color;
 
if (0.0 <= h && h < 1.0) {
color = vec3(c, x, 0.0);
}
else if (1.0 <= h && h < 2.0) {
color = vec3(x, c, 0.0);
}
else if (2.0 <= h && h < 3.0) {
color = vec3(0.0, c, x);
}
else if (3.0 <= h && h < 4.0) {
color = vec3(0.0, x, c);
}
else if (4.0 <= h && h < 5.0) {
color = vec3(x, 0.0, c);
}
else if (5.0 <= h && h < 6.0) {
color = vec3(c, 0.0, x);
}
else {
color = vec3(0.0);
}
 
color += v - c;
 
return color;
}

void main(void) {

vec2 position = 0.5*(gl_FragCoord.xy - 0.5 * resolution) / resolution.y;
float x = position.x;
float y = position.y;

float a = atan(x, y);
    
    float d = sqrt(x*x+y*y);
    float d0 = f0*(sin(d+time)+1.5)*d+0.02*time;
    float d1 = 5.0; 

    float u = mod(a*d1+sin(d*10.0+time), M_PI*2.0)/M_PI*0.5 - f1;
    float v = mod(pow(d0*4.0, 0.75),1.0) - 0.5;
    
    float dd = sqrt(u*u+v*v*d1);
    
    float aa = atan(u, v);
    
    float uu = mod(aa*3.0+3.0*cos(dd*16.0-time), M_PI*2.0)/M_PI*0.5 - f2;
    // float vv = mod(dd*4.0,1.0) - 0.5;
    
    float d2 = sqrt(uu*uu+v*v)*1.5;
    
gl_FragColor = vec4( hsvtorgb(dd+time*0.5/d1, dd, d2*d2*d2*2.0), 1.0 );
}


