// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:horz stretch:
//f1:vert stretch:
//f2:color pos:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
//Flower by @hintz 2011-12-20

float flower(vec2 p) {
  float r=p.x*p.x+p.y*p.y / f2;
  float a=atan(p.y,p.x);
  
  return r+sin((a-time)*5.0);
}

vec3 color(float c) {
  return vec3(sin(c-time),sin(c*2.1+1.0-time),sin(c*2.3+2.0+time));
}

void main() {
  vec2 position = (2.0*gl_FragCoord.xy-resolution.xy)/resolution.y * vec2(f0, f1);
  
  float c=flower(position);
 
  gl_FragColor = vec4(color(c),1.0);
}


