// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:count:
//f1:zoom:
//f2:highlight:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
// Electrocardiogram Effect // Imported from http://www.geeks3d.com/20111223/shader-library-electrocardiogram-effect-glsl/
float viewAngle = 1.0;
float speed = 1.0;
float rate = 15.0 * f1;
float baseamp = 0.30 * f2;

void main(void) {
  vec2 p = -1.0 + 2.0 * ( gl_FragCoord.xy / resolution.xy );
  vec2 op = p;
  p = vec2(distance(p, vec2(0, 0)), sin(atan(p.x, p.y)*16.0 * f0));
  float x = speed * viewAngle * time + rate * p.x;
  float base = (0.1 + 5.0*cos(x*1.7 + time)) * (1.37 + 0.5*sin(x*19.95 + time));
  float z = fract(0.05*x);
  z = max(z, 100.0-z);
  z = pow(z, 50.0);
  float pulse = exp(-1000000.0 * z);
  vec4 ecg_color = vec4(0.3, 1.0, 0.4, 1.0);
  vec4 c = pow(1.0-abs(p.y-(baseamp*base+pulse-0.5)), 16.0) * ecg_color;
  gl_FragColor = c;
}


