// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:speed zoom:
//f1:center pull:
//f2:shine length:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
uniform sampler2D bb;

void main( void ) {
vec3 light_color = vec3(0.2,0.1,0.1);

vec2 position = ( gl_FragCoord.xy -  resolution.xy*.5 ) / resolution.x;
float angle = fract(atan(position.y,position.x)/(2.*3.14159265359));

float angleFract = fract(angle*256.);
float angleRnd = floor(angle*256.)+1.;
float angleRnd1 = fract(angleRnd*fract(angleRnd*.7235)*45.1);
float angleRnd2 = fract(angleRnd*fract(angleRnd*.82657)*13.724);
float t = time * 16. +angleRnd1*10.;
float radDist = sqrt(angleRnd2) / f0;

float adist = radDist/length(position)*.1 /f1;
float dist = abs(fract(t*.1+adist)-.5) * f2;
float color =  (1.0 / (dist))*cos(0.7*(sin(t)))*adist/radDist/30.0;

gl_FragColor = vec4(color,color,color,1.0)*vec4(light_color,1.0)*1.5 + texture2D(bb, gl_FragCoord.xy)*0.9;
}


