// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

//f0:x stretch:
//f1:y stretch:
//f2:green strength:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float mytime = float(itime) + ftime;


//---------------------------------------------------------------------------------------------------
// source : http://glslsandbox.com/e#36035.4

void main(void) {

vec2 p = ( gl_FragCoord.xy - 0.5 / tres.xy ) / tres.y;

p.x += 0.5 * sin(p.y * 3.14 + mytime);
p.x = sin(p.x * 10.0 *f0);
p.y = sin(p.y * 10.0 *f1) ;

//float g = distance(vec2(0.0,0.0), p);
float g = distance(vec2(sin(mytime*0.1)), p);
float d = sin(g * 3.14 * 5.0) * (f2 + 0.2);

vec3 ca = vec3(0.2, 0.2, 0.2);
vec3 cb = vec3(0.5, 0.5, 0.5);
vec3 cc = vec3(0.7, 0.7, 0.7);
vec3 cd = vec3(0.0, 1.0, 0.0);

float k = d * 0.5 + 0.5;
vec3 c = vec3(0.0);

c = mix(ca, cb, smoothstep(0.0, 0.5, k));
c = mix(c, cc, smoothstep(0.5, 0.75, k));
c = mix(c, cd, smoothstep(0.75, 1.0, k));

gl_FragColor = vec4( vec3(c), 1.0);

} //endof main


