// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:horz stretch:
//f1:vert stretch:
//f2:color pos:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

#define M_PI 3.141592653589793
// modifed by @hintz 2013-06-06 at #OpenHackBER

void main(void) {
vec2 p1 = (gl_FragCoord.xy - 0.5 * resolution.xy) / resolution.x * vec2(f0,f1);

float a = 0.1*time*M_PI/3.0;
float c = cos(a);
float s = sin(a);
mat2 rotate = mat2(c,s,-s,c) * f2;

vec3 color = vec3(length(p1));
color.rg *= abs(0.2-p1.x);

vec2 p2 = p1 * rotate;
color.gb *= abs(0.2-p2.x);

vec2 p3 = p2 * rotate;
color.br *= abs(0.2-p3.x);

vec2 p4 = p3 * rotate;
color.rg *= abs(0.2-p4.x);

vec2 p5 = p4 * rotate;
color.gb *= abs(0.2-p5.x);

vec2 p6 = p5 * rotate;
color.br *= abs(0.2-p6.x);

color.g *= abs(p1.x);
color.b *= abs(p2.x);
color.r *= abs(p3.x);

gl_FragColor = vec4(sin(2.9*sqrt(1.0-(2.0+sin(time))*50000.0*color)), 1.0);
}


