// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:pixel width:
//f1:pixel height:
//f2:density:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
//http://glslsandbox.com/e#48630.0

//---------------------------------------------------------------------------------------------------
void main(void) {

    vec2 scaler = vec2(f0 * 8.0, f1 * 8.0);
    vec2 uv = scaler*( gl_FragCoord.xy / tres.xy );

    float sizer = 10.0 * f2;
    uv = floor(sizer*uv)/sizer;

    // pattern
    float f = sin(uv.x + sin(2.0*uv.y + time)) +
              sin(length(uv)-time) +
              1.5*sin(uv.x*2.5+time);
    
    // color
    vec3 col = 1.0 * cos(f + vec3(0.0, 2.0, 1.));

    gl_FragColor = vec4(col, 1.0);
   
} //endof main


