// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:horz stretch:
//f1:vert stretch:
//f2:zoom:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.2, 0.95, fparams[2]);


float time = float(itime) + ftime;
vec2 resolution = tres;
// dashxdr work in progress...  // http://www.linuxmotors.com/inkpoly

void main( void ) {

vec3 color = vec3(1.0, 0., 0.);
vec2 pos = ( 2.0 * gl_FragCoord.xy - resolution.xy) / resolution.xx * vec2(f0, f1);
float a = atan(pos.y, pos.x) + 3.1415927;

float r = length(pos) * f2;
float dn = mod(floor(4.0 + time*.02), 9.0);
if(dn>4.0) dn = 8.0-dn;
dn -= 4.0;
float n = 18.0 + dn*4.0;
float span = 6.2831853 / n;

a = fract(a/span);
float f = 1.0 - r;
float f2 = 2.0*f - 1.0;
float center = f2 * sin(time*.2172772)*6.0;
float wide = sin(time*.1)*8.3*(r+.3);
float low = center - wide;
float high = center + wide;
float count = .5 * (floor(high-a) + floor(a-low));
color.g = color.b = (fract(count)<.4) ? 0.0 : 1.0;

gl_FragColor = vec4( color, 1.0 );

}


