// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
//
//
// .default fragment shader

varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

//---------------------------------------------------------------------------------------------------
#define PI 3.1415926535897932384626
float time = float(itime) + ftime;
//f0:x pos:
//f1:y pos:
//f2:size:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);
//---------------------------------------------------------------------------------------------------


void main(void) {
         vec2 aCirclePosition = tres * vec2(f0,f1);
         

        float aRadius = 200.0 * f2; 
        vec4 aColor= vec4(1.0); 
        float threshold = 0.05 ;
        float d, dist;

        dist = distance(aCirclePosition, gl_FragCoord.xy);

        if(dist == 0.) {
            dist = 1.; 
        }

        d = aRadius / dist;
        if (d >= 1.) {
                gl_FragColor = aColor;
        } else if (d >= 1. - threshold) {
                float a = (d - (1. - threshold)) / threshold;
                gl_FragColor = vec4(aColor.r, aColor.g, aColor.b, a); 
        } else {
                gl_FragColor = vec4(0., 0., 0., 1.);
        }
} //endof main


