// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:brightness:
//f1:yellow highlight:
//f2:line density:
float f0 = mix(0.2, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.30, 0.40, fparams[2]);

vec2 mouse = vec2(fparams.x, fparams.y);
float time = float(itime) + ftime;
vec2 resolution = tres;
// by rotwang, Facade Animation from Krysler(2012) // @mod+  color function // @mod+  vignette // @mod+ camera animation over facade, needs sampling=0.5

float aspect = resolution.x / resolution.y;

float Krysler_188( vec2 p ) {
float c1 = 0.25;
    vec2 q1 = mod(p,c1)-0.5*c1;
q1 += pow(q1,vec2(1.0/2.0));

float c2 = c1+c1*2.0;
    vec2 q2 = mod(p,c2)-0.5*c2;
q2 += pow(q2,vec2(1.0/8.0, 1.0/16.0));

float c3 = c1+c1*8.0 + f2;
    vec2 q3 = mod(abs(p),c3)-0.75*c3;
q3 += pow(q3,vec2(1.0/16.0, 1.0/8.0));

//float d1 = max(q1.y * q2.x - q3.x, q1.x * q2.y * q3.y);
float d2 = max(q1.x * q2.x * q3.x, q1.y * q2.y - q3.y*0.5);
    return d2 * 2.0;
}

vec3 Krysler_188_clr( vec2 p , vec2 q ) {
float shade = Krysler_188( q );
float d = smoothstep(0.1,1.3,shade);
vec3 clra = vec3(shade*0.2, shade*0.6, shade*1.0);
vec3 clrb = vec3(1.0, 0.6, 0.2);

vec3 clr = mix(clra,clrb, d /f1);
clr += clrb*(0.25+p.y);
clr += clra*0.5-p.y;
    return clr;
}

vec3 vignette(vec2 p, vec3 clr) {
vec2 vig = p*0.43;
vig.y *= aspect;
float amount = 1.0- length(vig);
clr *= amount / f0;
return clr;
}

void main(void) {

vec2 unipos = (gl_FragCoord.xy / resolution);
vec2 pos = unipos*2.0-1.0;
pos.x *= aspect;

vec2 q = pos;
q.x += sin(time*0.1)*3.0;
q.y += time*0.1;

    vec3 clr = Krysler_188_clr( pos, q );

clr = vignette(pos, clr);


    gl_FragColor = vec4(clr,1.0);
}


