// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:horz squash:
//f1:vert squash:
//f2:shade offset:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

void main( void ) {

        vec2 center = vec2(0.5, 0.5);
vec2 pos = gl_FragCoord.xy / resolution.xy / vec2(f0,f1) + .5;
float dis = 1.0 - distance(pos, center);
dis = pow(dis, 15.0*f2);
dis += sin(dis*2.0 + time*4.0)*0.5 + 0.5;
float r = sin(time + 2.0)*f2 + 0.5;
float g = sin(time + 4.0)*0.5 + 0.5;
float b = sin(time + 6.0)*0.5 + 0.5;
float th = atan(pos.y - center.y, pos.x - center.x) + time*1.0;
th = mod(th, 3.14159*0.125);
gl_FragColor = vec4(dis*r+th, dis*g+th, dis+th, 1);

}


