// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:hue offset:
//f1:sphere count:
//f2:zoom:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.2, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

#define hue(v)  ( .5 + cos( 6.3*(v)  + vec4(0,23,21,0)  ) )
//---------------------------------------------------------------------------------------------------
void main(void) {

vec2 uv = (2. * gl_FragCoord.xy - resolution) / resolution.y;
//uv *= 2.;
vec3 col = vec3(0.);
vec2 z = vec2(uv) * (2. *f2);
vec2 c = -vec2(.5 + .5 * sin(time));
float iters = 0.;
float s = .3 * f1;
for (int i = 0; i < 5; i++) {
iters++;
z = abs(z) - s;
float m = dot(z, z);
s *= .9;
z = z / m + c;
if (m > 4.) break;
col += .01 / m * hue(iters / (15. * f0) ).rgb;

}

gl_FragColor = vec4(col, 1.);

   
} //endof main


