// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:center x:
//f1:center y:
//f2:zoom:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);


float time = float(itime) + ftime;
vec2 resolution = tres;

float hexagon(vec2 p) {
vec2 ap = abs(p);
ap.y = mod(ap.y + time + sin(time * 1.5), 1.5);
ap.x = mod(ap.x + time - sin(time * 2.0), 1.5);

if(ap.y < 0.89) if(ap.x < mix(1.0, 0.50, ap.y)) return 1.0;
return 0.0;
}

void main( void ) {

vec2 position = ( gl_FragCoord.xy / resolution.xy * 2.0) - 2. *vec2(f0,f1);
position *= pow(abs(sin(time)) + 0.2, 0.33);
position.x *= resolution.x / resolution.y;
position *= 2.0 / f2;

gl_FragColor = vec4(hexagon(position) + ((position.y < 0.005 && position.y > -0.05) ? 1.0 : 0.0) - (length(position * 0.2)));
}


