// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:mod 1:
//f1:mod 2:
//f2:mod 3:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

mat2 rotate(float a) {
float c = cos(a),
s = sin(a);
return mat2(c, -s, s, c) * f2;
}


//---------------------------------------------------------------------------------------------------
// http://glslsandbox.com/e#51918.0
void main(void) {

vec2 uv = 1.2*(2. * gl_FragCoord.xy - resolution) / resolution.y;
vec3 color = vec3(0);
uv.y+=0.0;
vec3 rd = vec3(uv, f1  *2.0);

float s = .5;
for (int i = 0; i < 3; i++) {
rd = abs(rd) / dot(rd, rd); // kali iteration!! Thanks Kali
rd -= s;
rd.xy *= rotate(0.1 + time *0.110);
rd.xz *= rotate(0.2 - time *0.123);
rd.zy *= rotate(0.3 + time *0.131);
s *= -f0;
float b = 0.005;
float ax = abs(rd.x);
float ay = abs(rd.y);
float az = abs(rd.z);
//color.gb += .014 / max(abs(rd.x*0.8), abs(rd.y*0.8));
color.gb +=  length(vec2(ax, ay))*0.08/max(ax*0.2, 6.2*ay);
//color.rb += .015 / max(abs(rd.y*0.6), abs(rd.z*0.6));
color.rb +=  length(vec2(ay, az))*0.09/max(ay*0.2, 6.2*az);
//color.rg += .010 / max(abs(rd.x*0.7), abs(rd.z*0.9));
color.rg +=  length(vec2(ax, az))*0.07/max(ax*0.2, 6.2*az);
}
color *= 0.6;
gl_FragColor = vec4(color, 1.);

   
} //endof main


