// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:thickness:
//f1:zoom:
//f2:brightness:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

float u( float x ) { return (x>0.0)?1.0:0.0; }

void main(void) {
    vec2 p = (1.0*gl_FragCoord.xy-resolution)/resolution.y;

    float a = atan(p.x,p.y) * f0;
    float r = length(p)*.75 * f1;

    float w = cos(3.1415927*time-r*2.0);
    float h = 0.5+0.5*cos(12.0*a-w*7.0+r*8.0);
    float d = 0.25+0.75*pow(h,1.0*r)*(0.7+0.3*w);

    float col = u( d-r ) * sqrt(1.0-r/d)*r*2.5 * f2;
    col *= 1.25+0.25*cos((12.0*a-w*7.0+r*8.0)/2.0);
    col *= 1.0 - 0.35*(0.5+0.5*sin(r*30.0))*(0.5+0.5*cos(12.0*a-w*7.0+r*8.0));
    gl_FragColor = vec4(
        col,
        col-h*0.5+r*.2 + 0.35*h*(1.0-r),
        col-h*r + 0.1*h*(1.0-r),
        1.0);
}


