// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:horz stretch:
//f1:vert stretch:
//f2:zoom:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

const float PI = 3.141592;

vec2 r2(vec2 p, float a) {
mat2 m = mat2 ( cos(a),-sin(a), sin(a), cos(a) );
return m*p;
}

vec2 x2(vec2 p, float a) {
mat2 m = mat2 ( 
cos(a*p.x),
-sin(a), 
sin(a), 
cos(a) );
return m*p;
}

void main( void ) {

// coords
vec2 p = -1.+2.*( gl_FragCoord.xy/resolution);
p.x*=resolution.x/resolution.y * f0 * 2.;  
p.y*=f1 * 2.;
p=p*1.2;

// dd
p=r2(p,time*0.5+PI/6.) /f2;

// coords
float r = length(p);
float a = atan(p.y,p.x);


// base color
vec3 color =  vec3(0.2,0.3,0.4);

//effect
vec3 c = vec3(0.4,0.3,0.2);
float ss = 0.5+0.5*sin(time);
color = mix( color,c,pow(r,mix(5.,100.,ss+a)) );

gl_FragColor = vec4( color , 1.0 );

}


