// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:center zoom:
//f1:sweep:
//f2:tile count:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.3, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);


float time = float(itime) + ftime;
vec2 resolution = tres;

uniform sampler2D backbuffer;
#define HalfOverPI 0.159154943091895

void main( void ) {
vec2 position = ( gl_FragCoord.xy / resolution.xy );
vec2 pixel = 1./resolution;
vec4 me = texture2D(backbuffer, position);

vec2 pos2 = vec2(gl_FragCoord) - (resolution * 0.5);
float theta = atan(pos2.y, pos2.x) * HalfOverPI + 0.5;
float dist = theta - mod(time * 0.1, 1.0);
float sweep = mod(time * 0.1, 1.0);
float lastsweep = mod(time * 0.1 - 0.4/f1, 1.0);
if (sweep < lastsweep) {
lastsweep -= 1.0;
if (theta > sweep) {theta -= 1.0;}
}
//float sweepStrength = pow(max(0.0, (theta - lastsweep) / (sweep - lastsweep)), 10.0);
//if (sweepStrength > 1.0) { sweepStrength = 0.0; }

if ((theta <= sweep) && (theta > lastsweep)) {
float wouldBeTime = time + ((theta - sweep) * 10.0) * f2;
float radius = length(pos2) / min(resolution.x, resolution.y) / f0;
vec2 place = floor(vec2((10.0 / (radius + 0.5)) + wouldBeTime, wouldBeTime * 1.5) * 3.0);
float rnd1 = mod(fract(56.0*sin(dot(place, vec2(14.9898,78.233))) * 43758.5453), 1.0);
float rnd2 = mod(fract(37.0*sin(dot(place, vec2(14.9898,78.233))) * 43758.5453), 1.0);
float rnd3 = mod(fract(42.0*sin(dot(place, vec2(14.9898,78.233))) * 43758.5453), 1.0);
me.rgb = vec3(rnd1, rnd2, rnd3);
} else {
me -= 0.04;
}

//gl_FragColor = vec4(0, sweepStrength, 0.0, 1.0);
gl_FragColor = vec4(me.rgb, 1.0);
}


