// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:x pos:
//f1:y pos:
//f2:zoom:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.2, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

vec3 hsv2rgb_smooth( in vec3 c )
{
vec3 rgb = clamp( abs(mod(c.x*6.0+vec3(0.0,4.0,2.0),6.0)-3.0)-1.0, 0.0, 1.0 );
rgb = rgb*rgb*(3.0-2.0*rgb); // cubic smoothing
return c.z * mix( vec3(1.0), rgb, c.y);
}

//---------------------------------------------------------------------------------------------------
//http://glslsandbox.com/e#50935.3

void main(void) {

vec2 aspect = resolution.xy / resolution.y  * vec2(f0,f1) * 2.;
vec2 uv = ( gl_FragCoord.xy / resolution.y ) - aspect / 2.0;

uv *= 96.0 * f2;
float v = 0.5+sin(uv.y*0.5*sin(time*0.7));
uv.x += v;

float d = length(uv)*0.06;
d = d*d;

float a = sin(time*0.61)*d;
vec3 col = hsv2rgb_smooth(vec3(time*0.4+(uv.y+uv.x*a)*((d+0.5)*0.05),1.2-d,0.9-d));
gl_FragColor = vec4(col, 1.0);
   
} //endof main


