// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:zoom:
//f1:num points:
//f2:color ring pos:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
// Supershapes!  Use 0.5 by xpansive
// @rotwang: @mod+ single centered supershape

vec3 hsv2rgb(float h,float s,float v) {
return mix(vec3(1.),clamp((abs(fract(h+vec3(3.,2.,1.)/3.)*6.-3.)-1.),0.,1.),s)*v;
}

// @rotwang: normalized version
// s is for scale, r is for rotation
float supershape(vec2 p, float m, float n1, float n2, float n3, float a, float b, float s, float r) {
float ang = atan(p.y , p.x ) + r;
float v = pow(pow(abs(cos(m * ang / 4.0) / a), n2) + pow(abs(sin(m * ang / 4.0) / b), n3), -1.0 / n1);
return 1. - step(v * s *f0 , length(p ));
}

void main( void ) {

float aspect = resolution.x / resolution.y;
vec2 unipos = gl_FragCoord.xy / resolution;
vec2 bipos = unipos * 2.0 - 1.0;
 bipos.x *=aspect;

    float radius = length(bipos);

float hue = 1.2 - radius/f2;
float lum = 1.0 - length( bipos)*0.5;
vec3 rgb = hsv2rgb(hue,1.0, lum);


rgb *= supershape(bipos, 20.0 * f1,
  0.33, 0.73, 0.73,
  1.0, 1.0, 1.0,
  sin(time*0.33)*4.0);


gl_FragColor = vec4(rgb, 1.0);
}


