// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:count:
//f1:amp speed:
//f2:offset:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.00, 1.00, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

vec3 hsv2rgb(vec3 c) {
  vec4 K = vec4(1.0, 2.0 / 3.0, 1.0 / 3.0, 3.0);
  vec3 p = abs(fract(c.xxx + K.xyz) * 6.0 - K.www);
  return c.z * mix(K.xxx, clamp(p - K.xxx, 0.0, 1.0), c.y);
}

//---------------------------------------------------------------------------------------------------
// https://github.com/hughsk/glsl-hsv2rgb/blob/master/index.glsl
// http://glslsandbox.com/e#49720.0
void main(void) {


float amp = 4. * f1;
vec2 position = ( gl_FragCoord.xy / resolution.xy ) + vec2(f0,f1) / 4.0;

float bins = 20.0 * f0 + 3.;
vec2 pos = (gl_FragCoord.xy / resolution.xy);
float bin = floor(pos.x * bins + amp *sin(3.0*time)*sin(time+pos.y*10.0));
gl_FragColor = vec4( hsv2rgb(vec3(bin/bins+f2, 0.5, 0.8)), 1.0 );

   
} //endof main


