// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:warp mod 1:
//f1:warp mod 2::
//f2:diag zoom:
float f0 = mix(0.1, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.3, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
// water turbulence effect by joltz0r 2013-07-04, improved 2013-07-07

#define MAX_ITER 5
void main( void ) {
vec2 p = tcoord * 8.0 * f2;
vec2 i = p;
float c = 2.0;
float inten = 1.0;

for (int n = 0; n < MAX_ITER; n++) {
float t = time * (1.0 - (1.0 / float(n+1)));
i = p + vec2(cos(t - i.x) *4. * f1 + sin(t + i.y), sin(t - i.y) + cos(t + i.x) /f0);
c += 1.0/length(vec2(p.x / (sin(i.x+t)/inten),p.y / (cos(i.y+t)/inten)));
}
c /= float(MAX_ITER);
float pulse = abs(sin(time*5.));
float pulse2 = pow(sin(time*3.),.25);
float pulse3 = pow(sin(time*5.),2.);
gl_FragColor = vec4(vec3(pow(c,1.5+pulse2/2.))*vec3(1.0+pulse2, 2.0-pulse2, 1.5+pulse3)*(1.+pulse2)/2., 1.0);

}


