// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:red shift:
//f1:green shift:
//f2:blue shift:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);


float time = float(itime) + ftime;
vec2 resolution = tres;
// -gman

vec3 permute(vec3 x) { 

return mod( ( (x*34.0)+1.0)*x, 289.0);
}

// Perlin simplex noise
float snoise(vec2 v) {
vec4 C = vec4(0.211324865405187 , 0.366025403784439,
-0.577350269189626  , 0.024390243902439);

vec2 i  = floor(v + dot(v, C.yy) );
  vec2 x0 = v -   i + dot(i, C.xx);
  vec2 i1;

  i1 = (x0.x > x0.y) ? vec2(1.0, 0.0) : vec2(0.0, 1.0);
  vec4 x12 = x0.xyxy + C.xxzz;
  x12.xy -= i1;
  i = mod(i, 289.0);
  vec3 p = permute( permute( i.y + vec3(0.0, i1.y, 1.0 ))
+ i.x + vec3(0.0, i1.x, 1.0 ));
 vec3 m = max(0.5 - vec3(dot(x0,x0), dot(x12.xy,x12.xy),
      dot(x12.zw,x12.zw)), 0.0);
  m = m*m ;
  m = m*m ;
  
vec3 x = 2.0 * fract(p * C.www) - 1.0;
  vec3 h = abs(x) - 0.5;
  vec3 ox = floor(x + 0.5);
  vec3 a0 = x - ox;
  m *= 1.79284291400159 - 0.85373472095314 * ( a0*a0 + h*h );
  vec3 g;
 g.x  = a0.x  * x0.x  + h.x  * x0.y;
 g.yz = a0.yz * x12.xz + h.yz * x12.yw;

 return 205.0 * dot(m, g);
}

void main( void ) {

vec2 position = abs(( gl_FragCoord.xy / resolution.xy ) * 2.0 - 1.0);
float t = time * -0.5;
        vec2 m = log(position) + vec2(t, t);
float size = 4.0;
float b = max(m.x, m.y) * size;
float n = floor(b) / (size * 0.5);
//vec3 c = vec3(snoise(vec2(n, 0.5)),
//              snoise(vec2(n, 0.0)),
//              snoise(vec2(n, 1.0))) * 0.5 + 0.5;

vec3 c = vec3(snoise(vec2(n, f0)),
              snoise(vec2(n, f1)),
              snoise(vec2(n, f2))) * 0.5 + 0.5;

float a = step(mod(b, 1.0), 0.80);
c = c * a;
gl_FragColor = vec4(c, 1);

}


