// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:red size:
//f1:green size:
//f2:blue size:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

#define RED 0.0
#define GRN 0.4//Distance of Green circles from center.
#define BLU 0.8//Distance of blue circles from center.
#define WIDTH 0.05//Width of lines.  0.0 ~ 0.2

void main( void ) {

vec2 pos=(gl_FragCoord.xy/resolution.y);
pos.x-=resolution.x/resolution.y/2.0;
pos.y-=0.5;

float dist=sqrt((pos.x-0.0)*(pos.x+BLU)+(pos.y-0.0)*(pos.y+0.0)) * f2;
if (mod(dist-time/10.0,0.2)<WIDTH) {
gl_FragColor+=vec4(0.0,0.0,1.0,1.0);
}

dist=sqrt((pos.x-BLU)*(pos.x+0.0)+(pos.y-0.0)*(pos.y+0.0))* f2;
if (mod(dist-time/10.0,0.2)<WIDTH) {
gl_FragColor+=vec4(0.0,0.0,1.0,1.0);
}

dist=sqrt((pos.x-0.0)*(pos.x+GRN)+(pos.y-0.0)*(pos.y+0.0)) * f1;
if (mod(dist-time/10.0,0.2)<WIDTH) {
gl_FragColor+=vec4(0.0,1.0,0.0,1.0);
}

dist=sqrt((pos.x-GRN)*(pos.x+0.0)+(pos.y-0.0)*(pos.y+0.0)) * f1;
if (mod(dist-time/10.0,0.2)<WIDTH) {
gl_FragColor+=vec4(0.0,1.0,0.0,1.0);
}

dist=sqrt((pos.x-0.0)*(pos.x+0.0)+(pos.y-0.0)*(pos.y+0.0)) * f0;
if (mod(dist-time/10.0,0.2)<WIDTH) {
gl_FragColor+=vec4(1.0,0.0,0.0,1.0);
}
}



