// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:red frequency:
//f1:green frequency:
//f2:blue frequency:
float f0 = mix(0.1, 0.95, fparams[0]);
float f1 = mix(0.1, 0.95, fparams[1]);
float f2 = mix(0.1, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;


/*float cubicPulse( float c, float w, float x )
{
    x = abs(x - c);
    if( x>w ) return 0.0;
    x /= w;
    return 1.0 - x*x*(3.0-2.0*x);
}*/

float drawGraph(vec2 pos, float env, float THICKNESS) {
if ((pos.y < env + THICKNESS) && (pos.y > env - THICKNESS)) {
return 1.0;
}
return 0.0;
}

void main( void ) {
float thickness = 0.1;

vec3 color = vec3(0.0);
vec2 position = ( gl_FragCoord.xy / resolution.xy );
position = position * vec2(2.0) - vec2(1.0);

color.x += drawGraph(position, sin( f0 * 16. * position.x + time * 8.0) * f0, thickness * f0); 

color.y += drawGraph(position, sin( f1 * 8. * position.x + time * 12.0) * f1, thickness * f1);

color.z += drawGraph(position, sin( f2 * 12. * position.x + time * 16.0) * f2, thickness * f2);

gl_FragColor = vec4(color,1.0);
}


