// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:red thickness:
//f1:green thickness:
//f2:blue thickness:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
// by @Flexi23
#define pi2_inv 0.159154943091895335768883763372

float border(vec2 uv, float thickness){
uv = fract(uv - vec2(0.5));
uv = min(uv, vec2(1.)-uv)*2.;
return  clamp(max(uv.x,uv.y)-1.+thickness,0.,1.)/thickness;
}

vec2 spiralzoom(vec2 domain, vec2 center, float n, float spiral_factor, float zoom_factor, vec2 pos){
vec2 uv = domain * 0.5 - center;
float d = length(uv);
return vec2( atan(uv.y, uv.x)*n*pi2_inv + log(d)*spiral_factor, -log(d)*zoom_factor) + pos;
}

void main( void ) {
vec2 uv = gl_FragCoord.xy / resolution.xy;
uv = 0.5 + (uv - 0.5)*vec2(resolution.x/resolution.y,1.);

uv = uv-0.5;

vec2 spiral_uv = spiralzoom(uv / f0,vec2(0.),8.0, -.5, 1.8,  vec2(0.5 ,0.5)*time * .5) ;
vec2 spiral_uv2 =spiralzoom(uv / f1,vec2(0.),3.0,  .9, 1.2,  vec2(-0.5,0.5)*time * .8) ;
vec2 spiral_uv3 =spiralzoom(uv / f2,vec2(0.),5.0, .75, 2.0, -vec2(0.0 ,0.5)*time * .7) ;

gl_FragColor = vec4(border(spiral_uv, f0), border(spiral_uv2,1.0-f1) ,border(spiral_uv3,f2),1.);

}


