// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:wave offset:
//f1:green height:
//f2:blue height:
float f0 = mix(0.15, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

void main( void ) {

vec2 position = ( gl_FragCoord.xy / resolution.xy ) * f0 ; 

float numberone = cos((position.x + (time*0.1) ) * 8.0 ) * 0.1 + 0.55 + sin(time) * 0.1;
float numbertwo = cos((position.x + (time*0.1) )* 6.28 ) * 0.1 + 0.3 + cos(time) * 0.2;
        float dist_one = abs(position.y - numberone) *f2;
        float dist_two = abs(position.y - numbertwo) *f1;

float red = 0.0;
float green = 0.0;
float blue = 0.0;

if ( position.y < numberone && position.y > numbertwo )
red = 1.0;

if ( dist_one < 0.1 )
blue = dist_one / 0.1;
if ( dist_two < 0.1 )
green = dist_two / 0.1;




gl_FragColor = vec4( red * 0.5, green*0.5, blue*0.5, 1.0 );

}


