// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:vert count:
//f1:vert smush:
//f2:horz count:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

#define PI 3.14159265359
#define FIFTH (2.0 * PI / 5.0)

void main( void ) {
vec2 position = gl_FragCoord.xy / resolution * 2.0 - vec2(1.0);
position.x /= resolution.y / resolution.x;

float vlat = atan(0.5);

if (abs(position.x) <= 1.0) {
float ry = sqrt(1.0 - position.y * position.y / f1);
float lon = mod(acos(position.x / ry) + time * 0.5, 2. * PI);

float rx = sqrt(1.0  - position.x * position.x );

if (abs(position.y / rx) < 1.0) {
float lat = asin(position.y / rx) / f2;
gl_FragColor = vec4(mod(vec2(lat, lon), 0.2 / f0) * 5., 5., 1.0);
}
}
else {
gl_FragColor = vec4(vec3(-3.0 + 2.*length(position))*vec3(f0-0.1, 0.3/f0, 0.5 + f0), 1.);
}
}


