// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:radar width:
//f1:ring width:
//f2:center shade:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

void main() {

vec2 orig_pos = 2.0*(( gl_FragCoord.xy / resolution.xy )-vec2(0.5,0.5));

orig_pos.x = orig_pos.x * 5.0/3.0;

float theta = 6.28 * time/10.0;

vec2 pos;
pos.x = orig_pos.x*cos(theta) - orig_pos.y*sin(theta);
pos.y = orig_pos.x*sin(theta) + orig_pos.y*cos(theta);


float c=0.0;

if(abs(pos.x) < abs(pos.y/f0)){
c = length(pos) * f2;
//c=1.0;
}
if( mod(length(pos),0.09) < 0.05 * f1){
if(c==0.0){
c = 1.0;
} else {
c = 0.0;
}
}


gl_FragColor = vec4(  c );

}



