// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;//
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:stripes:
//f1:thickness:
//f2:glow:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.1, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
float pi = 3.141592;

//---------------------------------------------------------------------------------------------------
// https://www.shadertoy.com/view/MscSDf // source : http://glslsandbox.com/e#35359.4

void main(){
    vec2 uv = (gl_FragCoord.xy / tres.xy) * 2.0 - 1.0;
    float aspect = tres.x/tres.y;
    uv.x *= aspect;
    
    
    vec2 pos = vec2(0.0, 0.0);
        
    float dist = length(uv - pos);   // * sin(3.141592 * time);
    
    float time = time;
    
    float rippleRadius = time;
    
    float diff = rippleRadius - dist;
    
    float func = sin(pi * diff);
    
    uv += uv * func * 0.1;
    
    
    
    //uv *= vec2(sin(time), cos(time));
    
    float stripes = 12.0 * f0 + 4.;
    float thickness = 10.0 + 10.*f1;
    float sharpness = 20.0;
    vec2 a = sin(stripes * 0.5 * pi * uv - pi/2.0);
    vec2 b = abs(a) * f2;
    
    vec3 color = vec3(0.0);
    color += 1.0 * exp(-thickness * b.x * (0.8 + 0.5 * sin(pi * time)));
    color += 1.0 * exp(-thickness * b.y);
    color += 0.5 * exp(-(thickness/4.0) * sin(b.x));
    color += 0.5 * exp(-(thickness/3.0) * b.y);
    
    float ddd = exp(-5.5 * clamp(pow(dist, 3.0), 0.0, 1.0));
    
    vec3 t = vec3(uv.x * 0.5+0.5*sin(time), uv.y * 0.5+0.5*cos(time), pow(cos(time), 4.0)) + 0.5;
    
    gl_FragColor = vec4(color * t * ddd, 1.0);
}




