// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:ripple 1:
//f1:ripple 2:
//f2:ripple 3:
float f0 = mix(0.3, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.5, 0.95, fparams[2]);

float time = float(itime) + ftime;
//---------------------------------------------------------------------------------------------------
void main(void) {
   vec2 p = (gl_FragCoord.xy * 2.0 - tres) / tres;
   p.x *= tres.x / tres.y;
   
   for (int i = 1; i < 3; i++) {
      vec2 c = vec2(sin(float(i) * 246.563 + 0.534 + time * .43), sin(float(i) * 127.413 + 1.353 - time * .14));
      float r = distance(c, p * f1);
      float a = sin(float(i) * 34.125 + .524 + time * .0246) * 3.14159265359 / max(r, .5);
      mat3 m = mat3(
         cos(a), -cos(a), 0.0,
         sin(a), sin(a), 0.0,
         c.x, c.y, 1.0
      );
      p =(m * vec3(p, 1.0)).xy * f2 * 3.;
   }
   float v = sin(p.x * 10.0 *f0) * sin(p.y * 20.0 *f0);
   
   vec3 c = mix(vec3(0.1, 0.5, 1.0), vec3(0.25, 0.13, 0.25), v);
   
   gl_FragColor = vec4(c, 1.0);

} //endof main


