// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:bottom mod:
//f1:top triangle:
//f2:color mod:
float f0 = mix(0.05, 0.95, fparams[0]) * .1;
float f1 = mix(0.05, 0.95, fparams[1]) * .1;
float f2 = mix(0.05, 0.95, fparams[2]);

// http://www.glslsandbox.com/e#43343.0


float time = float(itime) + ftime;

float sawTooth(float x) {
   return abs(mod(x, 1.0) - 0.5);
}

//---------------------------------------------------------------------------------------------------
void main(void) {

   vec2 position = ( gl_FragCoord.xy /tres.xy );

   float red = sin(time);;
   float green = 0.;
   float blue = 0.;
   position.x += time*0.1;

   if (position.y < 0.25 + (sin(position.x * 5.5) / f0 + cos(position.x *5.)) / 90.*sawTooth(position.x*2.)*2. ) {
      green = .1;
      red -= f1; 
      blue = 1. - sin(time * .3);

   } else if (position.y > 0.4 + (sin(position.x * 0.2) / f1 + cos(position.x * 15.)) / 8.*sawTooth(position.x*1.5)*2.3) {
      green = .4;
      red -= f1; 
   } else { 
      green -= f2 * 0.2;
      blue = f2 * sin(time)* 0.05;
      red = smoothstep(0.2,0.8,f2);
   }


   gl_FragColor = vec4(vec3(red, green, blue), 1.0 );


} //endof main


