// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:zoom:
//f1:offest:
//f2:bg brightness:

float f0 = mix(0.15, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);


float time = float(itime) + ftime;

float obliqueLine(vec2 uv){
return step(0.6, fract((uv.x + uv.y + time * 0.8) * 4.0));
}

vec2 circle(vec2 uv, float radius) {
return vec2(length(uv), radius);  // .x = distance, .y = offset
}

vec2 square(vec2 uv, float size) {
return vec2(abs(uv.x) + abs(uv.y), size);
}
//---------------------------------------------------------------------------------------------------
// http://glslsandbox.com/e#49090.4
void main(void) {

vec2 uv = (gl_FragCoord.xy * 2.0 - tres.xy) / min(tres.x, tres.y);

vec2 scaledUv = uv * 3.0 * f0;
vec2 repeatedUv = fract(scaledUv);
repeatedUv -= f1;

float t = sin(time * 6.0 + length(floor(scaledUv))) * 0.5 + 0.5;  // 0.0 ~ 1.0

vec2 distanceAndOffset = mix(circle(repeatedUv, 0.45), square(repeatedUv, 0.4), exp(t * -6.0)) ;
float changingOffset = step(distanceAndOffset.x, distanceAndOffset.y);
vec3 backgroundColor = vec3(f2);
vec3 objectColor = vec3(0.9, 0.9, 1.0);
vec3 color = mix(backgroundColor * obliqueLine(uv * 5.0), objectColor, changingOffset);

vec2 distanceAndOffset2 = mix(circle(repeatedUv, 0.2), square(repeatedUv, 0.3), exp(t * -6.0)) ;
float changingOffset2 = step(distanceAndOffset2.x, distanceAndOffset2.y);
color *= mix(backgroundColor, vec3(0.9, 0.5, 0.9) * 0.05 / length(repeatedUv), changingOffset2);

gl_FragColor = vec4(color, 1.0);

   
} //endof main


