// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:mod 1:
//f1:mod 2:
//f2:mod 3:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

vec2 mouse = vec2(fparams.x, fparams.y);
float time = float(itime) + ftime;
vec2 resolution = tres;

const float iterations = 16.0;

void main( void ) {

vec2 position = 1.3 * vec2( (gl_FragCoord.x - (resolution.x)*0.5) / resolution.y * 2.0 , (gl_FragCoord.y - resolution.y*0.5)/ resolution.y * 2.0);
float color = 0.0;

float zr = position.x;
float zi = position.y;

float tr = (f0 + sin(time/100.0)*0.05)*cos(time/10.0);
float ti = (f1 + sin(time/100.0)*0.05)*sin(time/10.0);

float cr = tr - tr*tr + ti*ti;
float ci = ti - 2.0*tr*ti;

for (float i=0.0; i < iterations; i++) {

float tempr = zr*zr - zi*zi + cr;
zi = 2.0*zr*zi - ci * f2;
zr = tempr;

if ( (zr*zr + zi*zi) > 4.0) {
color = 1.0 - (i/iterations);
break;
}

}

gl_FragColor = vec4( vec3( color, color, color ), 1.0 );

}


