// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:zoom:
//f1:amp+line bright:
//f2:color rotate:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);


float time = float(itime) + ftime;
vec2 resolution = tres;
// by @hektor41 // 21/06/12 // v.2


float f(float x, float y) {

float nx = x + acos(time*y);
float ny = y + asin(time*x);

float formula = 4.0 /( cos( x + time ) - y ) * 200. * f1;

float formula_effects = 1.0/(( cos( x*0.03 + time )- y*0.06 * f1 ))-formula;
float formula_effects_plus = formula_effects/sqrt(ny);

return formula_effects_plus;
}



void main( void ) {

// CONTROLS
 float zoom =500.0 * f0;
 float cameraX = (zoom*5.0)/10.0;
 float cameraY = (zoom*3.0)/10.0-0.5;
 
// ^ ^ ^ ^ 

zoom += 0.5;
vec2 p = ( gl_FragCoord.xy /(resolution.x * 1.0/zoom));
float x = p.x - cameraX;
float y = p.y - cameraY;

float a = f(x,y);
float b = f(x*x,x*y);

gl_FragColor = vec4(sqrt(b)/10.0 *f2,  sqrt(a)/10.0 * f2,  sqrt(a*f2)/10.0,  1.0);

}


