// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:red size:
//f1:green size:
//f2:blue size:
float f0 = mix(0.05, 0.95, fparams[0]) * 2.;
float f1 = mix(0.05, 0.95, fparams[1]) * 2.;
float f2 = mix(0.05, 0.95, fparams[2]) * 2.;

float time = float(itime) + ftime;
vec2 resolution = tres;
float PI = 3.1415926;

void main( void ) {

vec2 position = ( gl_FragCoord.xy / resolution.xy );
float rfactor = 0.0, gfactor = 0.0, bfactor = 0.0;
vec2 rcenter = vec2(0,0), gcenter = vec2(resolution.x,0), bcenter = vec2(resolution.x/2.0,resolution.y);
float rr = 5.0/4.0 * PI, gr = 7.0/4.0 * PI, br = 0.5 * PI;
float step = mod(time, 15.0) / 15.0 * 2.0 * PI;
rcenter = vec2(cos(rr + step),sin(rr + step)) * resolution.y / 3.0 + resolution.xy / 2.0;
gcenter = vec2(cos(gr + step),sin(gr + step)) * resolution.y / 3.0 + resolution.xy / 2.0;
bcenter = vec2(cos(br + step),sin(br + step)) * resolution.y / 3.0 + resolution.xy / 2.0;
rfactor = 1.0 - length(gl_FragCoord.xy - rcenter) / 200.0 * f0;//length(resolution);
gfactor = 1.0 - length(gl_FragCoord.xy - gcenter) / 200.0 * f1;//length(resolution);
bfactor = 1.0 - length(gl_FragCoord.xy - bcenter) / 200.0 * f2;//length(resolution);
gl_FragColor = vec4(rfactor,gfactor,bfactor,1.0);

}


