// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:value x1:
//f1:value y1:
//f2:value r1:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);


float time = float(itime) + ftime;
vec2 resolution = tres;

const vec4 firstColor = vec4(0,0,1,1);
const vec4 secondColor = vec4(1,0,0,1);
float r1 = 200.0 * f2;
float r2c = 100.0;

void main( void ) {
highp float r2 = (sin(2.0 * time) + 1.0) * 30.0 + 20.0;
highp float x1 = 300.0 * f0;
highp float y1 = 300.0 * f1;
highp float x2 = (cos(time) + 1.0) * 100.0 + 100.0;
highp float y2 = (cos(time) + 1.0) * 100.0 + 100.0;
highp float xP = gl_FragCoord.x;
highp float yP = gl_FragCoord.y;

highp float theSqrt = sqrt(r2 * r2 * ((x1 - xP) * (x1 - xP) + (y1 - yP) * (y1 - yP)) - 2.0 * r1 * r2 * ((x1 - xP) * (x2 - xP) + (y1 - yP) * (y2 - yP)) + r1 * r1 * ((x2 - xP) * (x2 - xP) + (y2 - yP) * (y2 - yP))
               -((x2 * y1 - xP * y1 - x1 * y2 + xP * y2 + x1 * yP - x2 * yP) * (x2 * y1 - xP * y1 - x1 * y2 + xP * y2 + x1 * yP - x2 * yP)));
highp float t;
if(distance(gl_FragCoord.xy, vec2(x2, y2)) > r2) {
t = (-r2 * (r1 - r2) + (x1 - x2) * (x2 - xP) + (y1 - y2) * (y2 - yP) + theSqrt)
 / ((r1 - r2) * (r1 - r2) - (x1 - x2) * (x1 - x2) - (y1 - y2) * (y1 - y2));
} else {
t = (-r2 * (r1 - r2) + (x1 - x2) * (x2 - xP) + (y1 - y2) * (y2 - yP) - theSqrt)
 / ((r1 - r2) * (r1 - r2) - (x1 - x2) * (x1 - x2) - (y1 - y2) * (y1 - y2));
}
if (t >= 0.0 && t <= 1.0) {
gl_FragColor = mix(firstColor, secondColor, t);
}
}


