// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:pulse:
//f1:high low:
//f2:peak height:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.5, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

vec2 mouse = vec2(fparams.x, fparams.y);
float time = float(itime) + ftime;
vec2 resolution = tres;
// Electrocardiogram Effect
// Imported from http://www.geeks3d.com/20111223/shader-library-electrocardiogram-effect-glsl/

float viewAngle = 1.00;
float speed = 3.0;
float rate = 15.0;
float baseamp = f2 * .3;

void main(void) {

  vec2 p = -1.0 + 2.0 * ( gl_FragCoord.xy / resolution.xy );
  float x = speed * viewAngle * time + rate * p.x;
  float base = (1.0 + cos(x*2.5 + time)) * (1.0 + sin(x*3.5 + time));
  float z = fract(0.05*x);
  z = max(z, 1.0-z);
  z = pow(z *f1, 20.0);
  float pulse = exp(-100000.0 * z) *f0;
  vec4 ecg_color = vec4(0.3, 1.0, 0.4, 1.0);
  vec4 c = pow(clamp(1.0-abs(p.y-(baseamp*base+pulse-0.5)), 0.0, 1.0), 99.0) * ecg_color;
  gl_FragColor = c;
}


