// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:vert bar pos x:
//f1:horz bar pos y:
//f2:amp+thick:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
// By Vincent Petry <PVince81@yahoo.fr>

void main( void ) {
float PI = 3.14159265358979323846264;
float barSize = resolution.y * 0.6 * (1. - f2 );
float offset = sin(gl_FragCoord.x / 50.0) * sin(time * 5.0) * 80.0 * f2;
float vOffset = sin(gl_FragCoord.y / 50.0) * sin(time * 3.0) * 80.0 * f2;

float barPos = f1 * resolution.y - barSize / 2.0 + offset;
float vBarPos = f0 * resolution.x - barSize / 2.0 + vOffset;

vec4 col = vec4(0.0, 0.0, 0.0, 0.0);
if (mod(gl_FragCoord.x, 1.0) == 1.0) {
col = vec4(1.0, 1.0, 0.0, 1.0);
}

float b = 1.0;
bool hasH = false;
if (gl_FragCoord.y >= barPos && gl_FragCoord.y < (barPos + barSize)){
float offset = (gl_FragCoord.y - barPos) / barSize;
offset = abs(sin(offset * PI));
float offset2 = (offset - 0.75) * 2.0;
col = mix(col, vec4(offset, offset2, 0.0, 0.0), offset);
hasH = true;
}
if (gl_FragCoord.x >= vBarPos && gl_FragCoord.x < (vBarPos + barSize)){
float offset = (gl_FragCoord.x - vBarPos) / barSize;
offset = abs(sin(offset * PI));
float offset2 = (offset - 0.75) * 2.0;
vec4 col2 = vec4(offset2, offset / 2.0,offset,offset);
//col = vec4((col.r + col2.r * col2.a) / 2.0, (col.g + col2.g* col2.a) / 2.0, (col.b + col2.b * col2.a) / 2.0, 1.0);
col = mix(col, col2, col2.a);
}
gl_FragColor = col;
}


