// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

//f0:horz speed:
//f1:gradient thick:
//f2:center positon:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.0, 1., fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;// for easier glslsandbox.com conversion

//---------------------------------------------------------------------------------------------------
// http://www.glslsandbox.com/e#41963.0
void main(void) {

vec2 p = ( gl_FragCoord.xy / resolution.xy ) - vec2(f0, 0.5+(f2 - 0.5));

float sx = 0.3 * (p.x*p.x*4.0  - 0.7) * sin( 5.0 * p.x - 15. * pow(time*0.05, 0.7)*5.);

//float dy = 9./ ( 423. * abs(p.y - sx));
float dy = f1 * 9./ ( 223. * p.y * sx);

dy += 11./ (900. * length(p - vec2(p.x * 2. , 1.0)));

gl_FragColor = vec4( (p.x + 0.2) * dy, 0.3 * dy, dy, 6.1 );


} //endof main


