// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:horz stretch:
//f1:vert stretch:
//f2:diag zoom:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.3, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

const float PI = 3.1415926535;
const float TWOPI = PI*2.0;

vec2 rotate(vec2 point, float rads) {
float cs = cos(rads);
float sn = sin(rads);
return point * mat2(cs, -sn, sn, cs);
}

float curve( float x) {
return smoothstep( 0.75, 0.0, cos(x*PI /f2) );
}

float thing(vec2 pos) {
float offset = 0.;
float row = floor((pos.y)/2.0);
if (mod(row, 2.0) < sin(time)+1.0)
offset = sin(time) * 2.;

float a = curve(pos.x + offset);
float b = curve(pos.y);
float c = (a + b) * (sqrt(a+b));

float d = curve(pos.x + offset);
float e = curve(pos.y);
float f = (d - e) * (sqrt(d*e));
return smoothstep(2.+sin(time), -c, f);
}

void main(void) {
vec2 position = ( gl_FragCoord.xy / resolution );
vec2 world = position * 20.-14.;
world.x *= resolution.x / resolution.y * f0;
world.y *= f1;
float dist = 1.0-thing(world);

gl_FragColor = vec4( dist, dist, dist, 1.0 );
}


