// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
//
//
// .default fragment shader

varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

//---------------------------------------------------------------------------------------------------
// metadata
//f0:thickness:
//f1:density:
//f2:vert stretch:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.2, 0.95, fparams[1]);
float f2 = mix(0.2, 0.5, fparams[2]);

const float PI = atan(0.0,-1.0);

float hexagonalTiles(vec2 pos, float hexaGridSize)
{
  pos *= (0.283 / hexaGridSize);
  pos.x *= sqrt(3.0) / 3.0;
  float k = 44.*(cos(pos.y)*cos(pos.x) + cos(pos.x)*cos(pos.x) - sin(PI*(max(0.1,f0) +.5)) - 1.0); 
  k = clamp (k, 0.0, 1.0);
  return k;
}

//---------------------------------------------------------------------------------------------------
void main(void) {
float mytime = float(itime) + ftime;

vec2 pos = vec2(10.0, f2 * 20.) *(gl_FragCoord.xy / tres.xy);
pos.x *= tres.x/tres.y + min(0.3, f0);
pos = (pos*vec2(cos(pos.x+mytime*1.1),sin(pos.y+mytime*0.99)))*sin(pos+cos(mytime));
float k = hexagonalTiles(6.0*pos, f1);
vec3 color = vec3(1.0, 1.0, 1.0);
gl_FragColor = vec4(k*color, 1.0 );

} //endof main


