// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:squares 0:
//f1:squares 1:
//f2:squares 2:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
// just some squares by @hintz 2013-04-20

float squares(float modifier, float uniformity) {
float x = 0.03 * gl_FragCoord.x + time * modifier;
float y = 0.03 * gl_FragCoord.y + time * 0.99 * modifier;
float r = sin((f0 /sin(x) + f0/sin(y)));
return pow(r, uniformity);
}

float squares2(float modifier, float uniformity) {
float x = 0.03 * gl_FragCoord.x - time * modifier;
float y = 0.03 * gl_FragCoord.y + time * 0.99 * modifier;
float r = cos((f1 /cos(y) + f1/cos(x)));
return pow(r, uniformity+ sin(time));
}
float squares3(float modifier, float uniformity) {
float x = 0.02 * gl_FragCoord.x - time * modifier;
float y = 0.02 * gl_FragCoord.y - time * 0.99 * modifier;
float r = cos((f2 /cos(y) + f2/tan(x)));
return pow(r, uniformity);
}
void main(void) {
gl_FragColor = vec4(squares(2.0, f0), squares2(4.0,0.2 ), squares3(3.0, 0.3), 1.0);
}


