// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;//
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:mod x:
//f1:mod y:
//f2:zoom:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.1, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
//---------------------------------------------------------------------------------------------------

const int   complexity      = 15;    // More points of color.
const float mouse_factor    = 5.0;  // Makes it more/less jumpy.
const float mouse_offset    = 10.0;   // Drives complexity in the amount of curls/cuves.  Zero is a single whirlpool.
const float fluid_speed     = 100.0;  // Drives speed, higher number will make it slower.
const float color_intensity = 0.4;

//---------------------------------------------------------------------------------------------------
void main(void) {

  vec2 mouse = vec2(f0,f1);
  vec2 p=(2.0*gl_FragCoord.xy-resolution)/max(resolution.x,resolution.y) *  2. *f2;
  for(int i=1;i<complexity;i++) {
    vec2 newp=p + time*0.01;
    newp.x+=1.0/float(i)*sin(float(i)*p.y+time/fluid_speed+0.3*float(i)) + 0.5 + mouse.y/mouse_factor+mouse_offset;
    newp.y+=0.6/float(i)*sin(float(i)*p.x+time/fluid_speed+0.3*float(i+100)) - 21.5 - mouse.x/mouse_factor+mouse_offset;
    p=newp;
  }
  vec3 col=vec3(color_intensity*tan(0.901*p.x)+color_intensity,
color_intensity*tan(0.4*p.y)+color_intensity,
color_intensity*tan(p.x*0.8+p.y)+color_intensity);
  gl_FragColor=vec4(col, 1.0);

} //endof main


