// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:brigthness:
//f1:ripple speed:
//f2:num ripples:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
// water turbulence effect by joltz0r 2013-07-04, improved 2013-07-07

#define MAX_ITER 3
void main( void ) {
vec2 p = tcoord * 8.0- vec2(20.0);
vec2 i = p;
float c = 1.0 * f0;
float inten = .05;

for (int n = 0; n < MAX_ITER; n++) {
float t = time * (f1*0.025 - (3.0 / float(n+1)));
i = p + vec2(cos(t - i.x) + sin(t + i.y), sin(t - i.y) + f2 * 20.0 * cos(t + i.x));
c += 1.0/length(vec2(p.x / (sin(i.x+t)/inten),p.y / (cos(i.y+t)/inten)));
}
c /= float(MAX_ITER);
c = 1.5-sqrt(c);
gl_FragColor = vec4(vec3(c*c*c*c), 1.0);

}


