// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
//
//
// .default fragment shader

varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

//---------------------------------------------------------------------------------------------------
// metadata
// http://www.glslsandbox.com/e#42270.0
//f0:offset 1:
//f1:offset 2:
//f2:offset 3:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

//---------------------------------------------------------------------------------------------------
// other functions
#define PI 3.1415926535897932384626
vec2 mouse = vec2(fparams.x, fparams.y);
float time = float(itime) + ftime;

const int TEXTURE_TO_USE = 2;

vec3 sampleTexture(int textureNumber, vec2 uv) {
if(textureNumber == 0) {
return vec3(sin(mod(uv*8.0,3.1415926))*0.5+vec2(0.5),0.0);
} else if(textureNumber == 1) {
vec2 lines = sin(uv*50.0)*0.5+vec2(0.5);
vec3 color1 = vec3(0.,1.0,1.0);
vec3 color2 = vec3(0.5,0.5,0.7);
return max(color1*lines.x,color2*lines.y);
} else if(textureNumber == 2) {
float radius = 1.0;
float len2 = dot(uv-vec2(0.7*f2) ,uv-vec2(0.7));
float z = sqrt(radius*radius-len2);
return vec3((len2 < radius*radius) ? z : 0.0);
} else {
return vec3(0.0);
}
}

//---------------------------------------------------------------------------------------------------
void main(void) {

vec2 pos = ( gl_FragCoord.xy / tres.y );
pos = pos*2.0-vec2(tres.x/tres.y,1.0);

float angle = time+((0.5+f0 * 0.5)*sin(length(pos)*8.0+time)+0.5)*(length(pos)+2.0);
float c = cos(angle);
float s = sin(angle) * f1;
pos = vec2(c*pos.x+s*pos.y, c*pos.y-s*pos.x);

gl_FragColor = vec4( sampleTexture(TEXTURE_TO_USE, pos), 1.0 );


} //endof main


