// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:horz stretch:
//f1:vert stretch:
//f2:diag movement:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

//quasicrystals
const float pi = 3.1415926;

void main(void) {
vec2 p = -1.0 + .05 * gl_FragCoord.xy / resolution.xy *vec2(f0,f1);
p.y *= resolution.y/resolution.x;
p *= 900. + 50. * f2;
const float tot = pi*4.0;
const float n = 6.0;
const float df = tot/n;

float c = 0.0;
float t = time*0.5;

for (float phi =0.0; phi < tot; phi+=df){
c+=cos(cos(phi)*p.x+sin(phi)*p.y +t * 0.005) + sin(time) *0.25;
}

gl_FragColor = vec4(c,c,c,1.0);
}


