// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:wave vertical:
//f1:wave offset:
//f2:wave brightness:
float f0 = mix(0.2, 0.95, fparams[0]) * 0.2;
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
void main( void ) {

vec2 uPos = ( gl_FragCoord.xy / resolution.xy );//normalize wrt y axis
//suPos -= vec2((resolution.x/resolution.y)/2.0, 0.0);//shift origin to center

uPos.x -= 0.5;
uPos.y -= 0.5;

vec3 color = vec3(0.0);
float vertColor = 0.0;
for( float i = 0.0; i < 8.0; ++i ) {
float t = time * 2.5;

uPos.y += (4.* f0 -.5) +sin( uPos.x*(i+1.0) + t+i/5.0 ) * 0.4 *f1;
float fTemp = abs(f2 *2.0 / uPos.y / 990.0);
vertColor += fTemp;
color += vec3(fTemp*i/14.0, pow(fTemp,0.99)*4.5, fTemp*(11.0-i)/2.0);
}

vec4 color_final = vec4(color, 2.0);
gl_FragColor = color_final;

}


