// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:brightness:
//f1:band width:
//f2:bg darkness:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

// exploring the sweetspot of the julia with a twist every other iteration

#define MAX_ITER 2

void main( void ) {

vec2 p,i = tcoord * 4.0;
float c = 0.0;
bool f = true;
int ni = 0;
for (int n = 0; n < MAX_ITER; n++) {
float t = time*0.666;
if (!f) {
i = vec2(
dot(i, vec2(i.x, -i.y)) - (0.666 + (sin(t)*0.333)),
2.0*i.x*i.y             - (0.666 + (cos(t)*0.333))
);
c += sqrt(dot(
vec2(p.x-(cos(p.y-t)*5.0), -p.y-(sin(p.x-t)*5.0)),
vec2(i.x-(sin(i.x)*5.0),  i.y-(cos(i.y)*5.0))

)) * f2 * -20.;
} else {
i = vec2(
dot(i, vec2(i.x, -i.y)) + (0.666 + (cos(t)*0.333)),
2.0*i.x*i.y             + (0.666 + (sin(t)*0.333))

);
c += sqrt(dot(
vec2(p.x+(cos(p.y-t)*5.0), -p.y+(sin(p.x)*5.0)),
vec2(i.x+(sin(i.x)*5.0),  i.y+(cos(i.y)*5.0))

)) * f1;
}
ni++;
if (c > float(MAX_ITER-ni))
break;
f = !f;
}
c = pow(float(ni*ni)/c, 1.5 * f0);

gl_FragColor = vec4( vec3(c), 1.0 );

}


