// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:top mod:
//f1:bottom mod:
//f2:modifier:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

float calc(float f, vec2 uPos) {
float t = time / 5.0;
uPos.y += sin( t + uPos.x * 5.0) * 0.1;
uPos.x += cos( t + uPos.y * 6.0) + 0.2;
float value = sin((uPos.x) * 5.0) + sin(uPos.y * 4.0) / f2;
return 1.0/sqrt(abs(value))/1.0 * pow(f, 10.);
}

void main( void ) {
vec2 p = ( gl_FragCoord.xy / resolution.xy );
float f;
if (p.y > 0.5) {
  f = (0.5 - (p.y - 0.5)) * 4. * f1;
} else {
  f = p.y * 4. * f0;
}

float vertColor = calc(f, p) + 0.1234;
gl_FragColor = vec4(vertColor, vertColor*sin(time / 4.0), vertColor*cos(time / 4.2), 1.);
}


