// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:gradient smooth:
//f1:center black amp:
//f2:oval xy:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);


float time = float(itime) + ftime;
vec2 resolution = tres;
// @rotwang: @mod* scale with aspect, unipolar hue, radius change


vec3 hsv(float h,float s,float v) {
return mix(vec3(1.),clamp((abs(fract(h+vec3(3.,2.,1.)/3.)*6.*f0-3.)-1.),0.,1.),s)*v;
}
void main( void ) {

float ta = time/4.0;
float usint = sin(time)*0.5+0.5;

float aspect = resolution.x / 100. *f2;
vec2 unipos = gl_FragCoord.xy / resolution;
vec2 p = unipos * 2. - 1.;

float scale = 2.0; 

float x = unipos.x;
p.x = fract(p.x*scale*aspect) - 0.5;

p.y *= scale;

float radius = 0.05 + 2.75*usint;
radius *= f1;
float s = length(p) - radius;
s = smoothstep(0.,f1,s);

gl_FragColor = s*vec4(hsv(x, 1.0, 1.0),1.);

}


