// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:color split:
//f1:color pos:
//f2:color brightness:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);


float time = float(itime) + ftime;
vec2 resolution = tres;

const float PI = 3.14159265358979323846264;
const float hbar = 1.05457172647e-34;
float MASS = 1.;

vec3 hsv(float h,float s,float v) { return mix(vec3(1.),clamp((abs(fract(h+vec3(3.,2.,1.)/3.)*6.-3.)-1.),0.,1.),s)*v; }

float wavefn(float n, float m, vec2 pos) { 
return 2. * sin(n * PI * pos.x) * sin(m * PI * pos.y); 
}
float omega(int n, int m) {
float fn = float(n);
float fm = float(m);

return .5/**hbar*/*PI*PI*(fn*fn+fm*fm)/MASS;
}
vec2 phasor(float magnitude, float omega, float time) {
float phase = omega*time;
return magnitude*vec2(cos(phase), sin(phase));
}
vec2 cpxmult(vec2 a, vec2 b) {
return vec2(a.x * b.x - a.y * b.y, a.x * b.y + a.y * b.x);
}

void main( void ) {
vec2 pos = gl_FragCoord.xy / resolution.xy;

vec2 ret = phasor(wavefn(1.0, 3.0 * f0, pos), omega(1,3), time/20.);
ret += phasor(wavefn(2.0, 1.0, pos), omega(2,1), time/20.);

float hue = (atan(ret.x, ret.y / f1) / PI + 1. * f1);
float value = sqrt(ret.x * ret.x * f2 + ret.y * ret.y) / 5.;
gl_FragColor = vec4(hsv(hue, 1.-value, value), 1.);
}


