// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:mod 1:
//f1:mod 2:
//f2:mod 3:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);


float time = float(itime) + ftime;
vec2 resolution = tres;
float time1 = time*0.0;
float time2 = time*0.0;

#define MUL_X 8.0
#define MUL_Y 10.0
#define PI 3.14159265359
#define TWO_PI PI * 2.0

vec3 getNormal(vec2 position)
{
return vec3(cos ( MUL_X * PI * position.x + time1 ), sin (MUL_X * PI * position.y + time1 ), cos(MUL_Y * PI*position.x + time) * sin (MUL_X * PI*position.y + time ));
}

void main( void ) 
{
vec2 position = ( gl_FragCoord.xy / resolution.xy );

vec3 normal = getNormal(position);

vec3 lightVec = normalize(vec3(f0, f1, f2));

float nDotl = dot(normal, lightVec);

gl_FragColor = vec4( vec3(nDotl, nDotl, nDotl), 1.0);
}


