// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
	precision mediump float;
varying vec2 tcoord; // location
uniform sampler2D tex;  // texture one
uniform sampler2D tex2; // texture two
uniform vec2 tres;   // size of texture (screen)
uniform vec4 fparams;   // 4 floats coming in
uniform ivec4 iparams;  // 4 ints coming in
uniform float ftime; // 0.0 to 1.0
uniform int itime;   // increases when ftime hits 1.0
//f0:soft small:
//f1:radius med:
//f2:soft big:
   float f0 = mix(0.05, 0.95, fparams[0]);
   float f1 = mix(0.05, 0.95, fparams[1]);
   float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

vec2 rotate(vec2 point, float rads) {
   float cs = cos(rads);
   float sn = sin(rads);
   return point * mat2(cs, -sn, sn, cs);
}

float circle(float x, float y, float radius, float softness) {
   vec2 p = vec2(x, y);
   float r = length( p );
   float a = atan( p.y, p.x );
   r *= 1.0 + clamp(1.0-r,0.0,1.0);
   return 1.0-smoothstep( radius, radius + softness, r );
}

//@rotate from http://glsl.heroku.com/e#3036.0; by @neoneye; @scratchisthebes; @psonice
void main( void ) {
   vec2 q = gl_FragCoord.xy / resolution.xy;
   vec2 p = -1.0 + 2.0 * q;
   p.x *= resolution.x/resolution.y;
   float rads = radians(time*10.0);
   p = rotate(p, rads);
   vec3 col = vec3( 0.0, 0.0, 0.0 );
   vec3 white = vec3(1.0);
   col += circle(p.x+0.2, p.y+0.2, 0.25, f0);
   col += circle(p.x-0.2, p.y-0.2, 0.25, f0);

   col += circle(p.x+0.2, p.y-0.2,  f1, 0.0);
   col += circle(p.x-0.2, p.y+0.2,  f1 , 0.0);

   //col += circle(p.x-0.4, p.y+0.4, 0.15, 0.0);
   //col += circle(p.x+0.4, p.y-0.4, 0.15, 0.0);

   //col += circle(p.x+0.2 + cos(p.x + time) * 0.25, p.y+0.2 + sin(p.y + time) * 0.25, 0.75, 0.0);
   //col += circle(p.x-0.2 - cos(p.x + time) * 0.25, p.y-0.2 - sin(p.y + time) * 0.25, 0.75, 0.0);
   col += circle(p.x+0.2 + sin(p.x + time) * 0.25, p.y-0.2 + cos(p.y + time) * 0.25, 0.85, f2 * .5);
   col += circle(p.x-0.2 - sin(p.x + time) * 0.25, p.y+0.2 - cos(p.y + time) * 0.25, 0.85, f2 * .5);
   //col += circle(p.x-0.4 + sin(p.y + time) * 0.25, p.y+0.4 + cos(p.x + time) * 0.25, 0.65, 0.0);
   //col += circle(p.x+0.4 + sin(p.y + time) * 0.25, p.y-0.4 + cos(p.x + time) * 0.25, 0.65, 0.0);
   col += floor((length((q - 0.5)) * 10.) - time);
   col = mod(col, 2.);
   //col = col.x > 0.5 ? 1. - col : col;
   gl_FragColor = vec4(col,1.0);

}


