// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

//f0:mod 1:
//f1:mod 2:
//f2:mod 3:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

//---------------------------------------------------------------------------------------------------
void main( void ) {

vec2 p = ( gl_FragCoord.xy / resolution.xy );

p = -1.0 + 2.0 * p;

vec2 psource = p * f0;

float alpha = time * 0.13;
float sinA = sin(alpha), cosA = cos(alpha);
mat2 rotA = mat2( cosA, sinA, -sinA, cosA );
p = p * rotA * 2.* f2;

p = (2.0 + sin(time * 0.41)) * p;
p = cos(p * 3.1416) * f0;

float color = 0.0;

vec2 a1 = vec2( sin( time * 1.17 ), sin( time * 1.47 ) );
vec2 a2 = vec2( sin( time * 1.41 ), sin( time * 1.07 ) );
vec2 a3 = vec2( sin( time * 1.31 ), sin( time * 1.21 ) );
vec2 a4 = vec2( sin( time * 1.19 ), sin( time * 1.36 ) );
vec2 a5 = vec2( sin( time * 1.91 ), sin( time * 1.74 ) );
vec2 a6 = vec2( sin( time * 1.37 ), sin( time * 1.34 ) );
vec2 a7 = vec2( sin( time * 1.43 ), sin( time * 1.65 ) );
vec2 a8 = vec2( sin( time * 1.29 ), sin( time * 1.11 ) );

color += 1.0 / dot(p-a1, p-a1);
color += 1.0 / dot(p-a2, p-a2);
color += 1.0 / dot(p-a3, p-a3);
color += 1.0 / dot(p-a4, p-a4);
color += 1.0 / dot(p-a5, p-a5);
color += 1.0 / dot(p-a6, p-a6);
color += 1.0 / dot(p-a7, p-a7);
color += 1.0 / dot(p-a8, p-a8);

color = sin ( pow(0.8, color) * 50.0 * f1 - time * 0.333 );
color = 1.0 + color / 2.0;
color = pow(color, 3.0);
color = atan(color);

gl_FragColor = vec4( vec3( 1.0, 0.5, 0.2) * color + sin( color * 3.1416 * 3.0) * vec3(0.2, 0.8, 0.9), 1.0 );

}


