// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:length mod:
//f1:green color:
//f2:atan mod:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

float f(vec2 x) {
float r = length(x) + f0; 
float a = atan(x.y, x.x) * f2;
return r-1. + 0.5*sin(6.*a+2.*r*r*sin(time));
}

vec2 grad(vec2 p) {
vec2 h = vec2(0.1,1. );
return vec2(f(p+h.xy) - f(p-h.xy), f(p+h.yx) - f(p-h.yx))/(2.0*h.x);
}

float color(vec2 x) {
float v = f(x)/x.x;
vec2 g = grad(x) * f1;
float de = abs(v);
float blah = abs(sin(time));
return smoothstep(blah*0.9, blah, de);
}

void main( void ) {

vec2 position = gl_FragCoord.xy / resolution.xy * 2. - 1.;
position *= 2.0;

float v = color(position);

//float on = sin(time) > 0. ? 1. : 0.;
float on = 1.;

float r = sin(v*time) ;
float g = cos(v*time) - f1 ;
float b = sin(position.x*position.y) ;

gl_FragColor = vec4(r, g, b, 1. );

}


