// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
	varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:ray twitch:
//f1:sun size:
//f2:glow size color:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

// sun based on 'Shapes' by iq (2011) // by rotwang @mod- face removed // @mod+ sun function with parameters

const float PI = 3.1415926535;
const float TWOPI = PI*2.0;


float usin(float t) {
return sin(t)*0.5+0.5;
}


vec3 sun( vec2 p, float jags, float smooth ) {
    float a = atan(p.x,p.y);
    float r = length(p); 

    float s = usin(a*jags);
    float d =  .5 +  f1 + 0.2*pow(s,2.0);
    float h = r/d;
float w = 0.66; 
    float shade = 1.0-smoothstep(w-smooth,w+smooth,h) * f2;


    vec3 clr = mix(vec3(0.0,0.0,0.5),vec3(0.9,0.6,0.0),shade);
clr += 1.2-length(p) /f2;
return clr;
}

void main( void ) {

float speed = time *0.5;
float aspect = resolution.x / resolution.y;
vec2 unipos = ( gl_FragCoord.xy / resolution );
vec2 pos = vec2( (unipos.x*2.0-1.0)*aspect, unipos.y*2.0-1.0);
		
float jags = mod(usin(time* f0), 6.0) * 120.0;
vec3 clr = sun(pos,jags, 0.025);

gl_FragColor = vec4( clr, 1.0 );

}


