// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:x offset:
//f1:y offset:
//f2:color offset:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);


float time = float(itime) + ftime;
vec2 resolution = tres;

#define M_PI 3.1415926535897932384626433832795
float CAM_DIST = 3.0;
float TUNNEL_RADIUS = 8.0 * f2;

void main( void ) {

vec2 pos = (( gl_FragCoord.xy / resolution.xy )) - 0.5;
pos -= (vec2(f0, f1) - 0.5) * 0.3;

float alpha = atan(pos.y, pos.x) + time;
float sx = alpha;

float d = sqrt(dot(pos, pos));
float beta = atan(d / CAM_DIST);
float sy = TUNNEL_RADIUS * (d/CAM_DIST) - (time * 0.3);

float color;
//color = mod(sx, 0.25) * 4.0 + cos(sy * 512.0);
color = sin(20.0 * sx) * cos(sy*3.0) + sin(atan(sx + sy));
color *= (sx / (sin(1.0 / sy * 2.0) + sin(sy*8.0) * 300.0) * 0.4);
color = abs(color);
//color = tan(color);

color *= (beta * 4.0);
color *= 16.0;
gl_FragColor = vec4( vec3( color, color * (sin(time) + 0.5) * 0.5, sin( color  ) * tan(time) ), 1.0 );
}


