// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;//
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:x pos:
//f1:y pos:
//f2:zoom:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
//---------------------------------------------------------------------------------------------------

vec3 image(vec2 p) {
float c = 1. - length(mod(abs(p), 0.7));
return vec3(1. - c, c, c * 23.);
}

vec2 distort(vec2 p)
{
float d = length(p)* f2 * 4.+ sin(time * 0.05)+0.05; 
float a = atan(p.y,p.x);

vec2 uv;

uv.x = cos(a + time) / d;
uv.y = sin(a + time) / d;

return p + uv + vec2(time * 0.5);
}

vec3 effect() {
vec3 color;
 vec3 uv;
////vec2 pos = gl_FragCoord.xy / resolution - 0.5;
vec2 pos = 2.0 * gl_FragCoord.xy / tres.xy - 1.0 * vec2(f0,f1) * 2.;

color = image(distort(pos));

return color;
}


void main() {
gl_FragColor = vec4(effect(), 1.);
}


