// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:zoom:
//f1:twist:
//f2:balloon size:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.2, 0.95, fparams[2]);


float time = float(itime) + ftime;
vec2 resolution = tres;

void main( void ) {
 
vec2 position = ( 2.0*gl_FragCoord.xy - resolution) / resolution.xx;
 
float adjust1 = f0 * 100.0;

position *= adjust1;
float r = length(position);
float fix = -time*1.3;
#define PI 3.1415927
#define PI2 (PI*2.0)

float a = atan(position.y, position.x) + PI *f1;
float d = r - a + PI2;
int n = int(d/PI2);
d = d - float(n)*PI2;
float dd = (d < PI*2.9) ? 1.0 : 0.0;
float da = a+float(n)*PI2;
vec3 norm;
float pos = da*da*.07+fix;
#define IBALLRAD (1.0/f2)
norm.xy = vec2(fract(pos) - .5, d / PI2 - .5)*IBALLRAD;
float len = length(norm.xy);
vec3 color = vec3(0.0, 0.0, 0.0);
if(len <= 1.0) {
norm.z = sqrt(1.0 -  len*len);
vec3 lightdir = normalize(vec3(-0.0, -1.0, 1.0));
dd = dot(lightdir, norm);
dd = max(dd, 0.1);
float rand = sin(floor(pos));
color.rgb = dd*fract(rand*vec3(10.0, 1000.0, 100000.0));
vec3 halfv = normalize(lightdir + vec3(0.0, 0.0, 1.0));
float spec = dot(halfv, norm);
spec = max(spec, 0.0);
spec = pow(spec, 40.0);
color += spec*vec3(3.0, 1.0, 1.0);
}
gl_FragColor.rgba = vec4(color, 1.0);
 
}


