// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:horz stretch:
//f1:vert stretch:
//f2:zoom+lines:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

#define PI 3.14159265359

void main (void) {
vec2 p=gl_FragCoord.xy * vec2(f0,f1) * 2.;
float x=(p.x-resolution.x/2.)/80.;
float y=(p.y-resolution.y/2.)/80.;
float r=1./sqrt(x*x+y*y)*f2+time;
float a=atan(x,y)/PI/1.+sin(time)/6.+sqrt(sin(r));
r=r+mod(a,.2 / f2);
float V=abs(mod(a,.1))<.01||abs(mod(r,1.))<.1?1.:0.;
gl_FragColor=vec4(V,V,V,1.);
}


