// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
//
//
// .default fragment shader

varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

//---------------------------------------------------------------------------------------------------
// metadata
// source : http://glslsandbox.com/e#36189.0
//f0:diagonal zoom:
//f1:green:
//f2:vert blue scroll:
float f0 = mix(0.0, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);
#define PI 3.1415926535897932384626
vec2 mouse = vec2(fparams.x, fparams.y);


//---------------------------------------------------------------------------------------------------
void main(void) {

float mytime = float(itime) + ftime;

//float sizeOfDot = 1.0/11.0;
float sizeOfDot = f0/15.0 + 0.005;

vec2 position = ( gl_FragCoord.xy / tres.xy ) + mouse / 4.0;
float r = 0.0; // Red component
float g = f1 * 0.5;// Green Component
float b = 0.0;
r += sin(mytime) * sin(gl_FragCoord.y * sizeOfDot) * sin (gl_FragCoord.x * sizeOfDot );
g -= sin(mytime * 1.3) * sin(gl_FragCoord.y * sizeOfDot) * sin (gl_FragCoord.x * sizeOfDot );
b += sin(mytime * .3) * sin(gl_FragCoord.y * sizeOfDot * f2) * sin (gl_FragCoord.x * sizeOfDot );

vec4 color = vec4(r,g,b,1.0);
float gamma = mouse.x/2.;
color = mix(color, sign(color), gamma);
gl_FragColor = color;


} //endof main


