// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
//
//
// .default fragment shader

varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

//---------------------------------------------------------------------------------------------------
// metadata
// http://www.glslsandbox.com/e#40357.0
//f0:horz pos:
//f1:vert pos:
//f2:hstretch+vsqueeze:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.1, 1.5, fparams[2]);
#define PI 3.1415926535897932384626
float time = float(itime) + ftime;
vec2 resolution = tres;// for easier glslsandbox.com conversion

#define HorizontalAmplitude4.00
#define VerticleAmplitude0.80
#define HorizontalSpeed0.90
#define VerticleSpeed3.10


vec3 checkerBoard( vec2 uv, vec2 pp )
{
    vec2 p = floor( uv * 1.6 );
    float t = mod( p.x + p.y, 2.0);
    vec3 c = vec3(t+pp.x, t+pp.y, t+(pp.x*pp.y));

    return c;
}

vec3 tunnel( vec2 p, float scrollPos, float rotateSpeed )
{    
p.x *= f2 * 2.;
    float a = 0.9 * atan( p.x, p.y  );
    float po = 2.0;
    float px = pow( p.x*p.x, po );
    float py = pow( p.y*p.y, po );
    float r = pow( px + py, 0.5/po );    
    vec2 uvp = vec2( 0.5/r + scrollPos, a + (time*rotateSpeed));
    vec3 finalColor = checkerBoard( uvp, p ).xyz;
    finalColor *= r;

    return finalColor;
}


//---------------------------------------------------------------------------------------------------
void main(void) {

    vec2 uv = gl_FragCoord.xy / resolution.xy*1.0;
    //vec2 p = uv + vec2(-1.0, 1.0 );
    vec2 p = uv + vec2(-f0, -f1 );
    float scrollPos=2.0;
    vec3 finalColor = tunnel( p ,time*1.0,0.5);
    

    gl_FragColor = vec4( finalColor, 1.0 );


} //endof main


