// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
//
//
// .default fragment shader

varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

//---------------------------------------------------------------------------------------------------
// metadata
// http://www.glslsandbox.com/e#39896.0
//f0:horz pos:
//f1:vert pos:
//f2:twist:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);
#define PI 3.1415926535897932384626
vec2 mouse = vec2(f0, f1);
float time = (float(itime) + ftime);
vec2 resolution = tres;

const float Tau= 6.2832;
const float speed= .02;
const float density= .04;
const float shape= .06;

float random( vec2 seed ) {
return fract(sin(seed.x+seed.y*1e3)*1e5);
}

float Cell(vec2 coord) {
vec2 cell = fract(coord) * vec2(.5,2.) - vec2(.0,.5);
return (1.-length(cell*2.-1.))*step(random(floor(coord)),density)*2.;
}


//---------------------------------------------------------------------------------------------------
void main(void) {

vec2 p = gl_FragCoord.xy / resolution  - mouse;

float a = fract(atan(p.x, p.y) / Tau);
float d = length(p);

vec2 coord = vec2(pow(d, shape), a)*256.;
vec2 delta = vec2(-time*speed*256., f2 * 50.);

float c = 0.;
for(int i=0; i<3; i++) {
coord += delta;
c = max(c, Cell(coord));
}

float dc  = c*d;
gl_FragColor = vec4(dc, dc, dc, 1.0);

} //endof main


