// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:order:
//f1:speed:
//f2:length:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

#define PI 3.1415926535897932384626
float random(float n) {
   return fract(abs(sin(n * 55.753) * 367.34));
}

mat2 rotate2d(float angle){
   return mat2(cos(angle), -sin(angle),  sin(angle), cos(angle));
}

//---------------------------------------------------------------------------------------------------
void main(void) {

   vec2 uv = (gl_FragCoord.xy * 2.0 -  resolution.xy) / resolution.x;

   uv *= rotate2d(time * 0.2); //time * 0.2

   float direction = 1.0;
   float speed = time * direction * 1.6;
   float distanceFromCenter = length(uv);

   float meteorAngle = atan(uv.y, uv.x) * (180.0 / PI);

   float flooredAngle = floor(meteorAngle);
   float randomAngle = pow(random(flooredAngle), f0);
   float t = speed + randomAngle;

   float lightsCountOffset = .8 * f1;
   float adist = randomAngle / distanceFromCenter * lightsCountOffset;
   float dist = t + adist;
   float meteorDirection = (direction < 0.0) ? -1.0 : 0.0;
   dist = abs(fract(dist) + meteorDirection);

   float lightLength = 100.0;
   float meteor = (5.0 / dist) * cos(sin(speed)) / lightLength;
   meteor *= distanceFromCenter * 2.0 / f2;

   vec3 color = vec3(0.);
   color += meteor;

   gl_FragColor = vec4(color, 1.0);
   
} //endof main


