// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:zoom:
//f1:offset 1:
//f2:offset 2:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

float random(in vec2 uv){
   return fract(sin(dot(uv, vec2(12.9898,78.233))) * 43758.5453);
}

float map(float value, float beforeMin, float beforeMax, float afterMin, float afterMax) {
   return afterMin + (afterMax - afterMin) * ((value - beforeMin) / (beforeMax - beforeMin));
}

float particle(vec2 uv, float size) {
    return step(size, length(uv));
}

float obliqueLline(vec2 uv){
   return step(0.6, fract((uv.x + uv.y + time * 0.8) * 4.0));
}
//---------------------------------------------------------------------------------------------------
void main(void) {

      vec2 uv = (gl_FragCoord.xy * 2.0 - resolution.xy) / min(resolution.x, resolution.y);

   vec2 scaledUv = uv * 4. * f0; 
   vec2 repeatedUv = fract(scaledUv);
   repeatedUv -= 0.5;

   float offset1 = random(floor(scaledUv)) * random(floor(scaledUv)) * f1;
   float p = particle(repeatedUv,  map(cos(time * 3.0 + offset1 * 10.0), -1.0, 1.0, 0.2, 0.6));

   float offset2 = random(floor(scaledUv)) /f2;
   vec3 color = vec3(p);
   color.r += obliqueLline(repeatedUv);
   color.g += particle(repeatedUv, map(sin(time * 6.0 + offset2 * 20.0), -1.0, 1.0, 0.1, 0.8));
   color.rb += max(offset1, offset2);

if ( (color.r + color.g + color.b)  >= 3.0 ) {
color =vec3(0.0);
} 

   gl_FragColor = vec4(color, 1.0);
   
} //endof main


