// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:ray thickness:
//f1:dark rings:
//f2:blue yellow mix:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
// rotwang: @mod* shader // @mod+ blink


vec2 c = vec2(0.5,0.5);

float pi = 3.14159;

vec3 shader( vec2 pos , vec2 res) {
vec2 p = pos - c;

float a = atan((p.x)/(p.y)); //+time*0.25;
float d = length(p) - f2;
float blink = step(fract(0.5),0.15);
blink = sin(time)*0.5+0.5;
float dx = 0.25 / f0 *0.5;
float sx = 0.1 ;
float mx = smoothstep( dx-sx, dx+sx, pos.x) ;

float dy = 0.5 / f1;
float sy = 0.1;
float my = smoothstep( dy-sy, dy+sy, pos.y);

vec3 clr_blink = vec3(0.99, 0.66, 0.2) * blink;
vec3 color = mix(vec3(0.0,0.0,d), vec3(0.33), mx) * mix(vec3(0.3, 0.2, d+d), clr_blink, my) * 3.0-d;

return  vec3( color ); 
}

void main( void ) {

c.x = 0.5+(sin(time*0.5)/4.0);
vec2 p = ( gl_FragCoord.xy / resolution.xy );

vec3 color = vec3(0.0);
vec2 uv = vec2(0.0);

//float a = atan((p.x-c.x)/(p.y-c.y))+time*0.125;
float a = atan((p.x-c.x)/(p.y-c.y));

float d = 20. * ((p.x-c.x)*(p.x-c.x)+(p.y-c.y)*(p.y-c.y));


uv = vec2(mod(a*8.0,pi*2.0)/pi*0.5,mod(pow(d,-0.75)+time,1.0));

color = shader(uv,vec2(pi*0.5,1.0))*(d*2.0);

gl_FragColor = vec4( color, 1.0 ); 

}


