// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

//f0:float gravity:
//f1:orb brightness:
//f2:orb spread:
float f0 = mix(0.3, 0.95, fparams[0]);
float f1 = mix(0.5, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
// Starfield effect, extracted from: http://glsl.heroku.com/e#883.0

float rand (float x) {
return fract(sin(x * 24614.63) * 36817.342);
}

void main(void) {
float scale = sin(0.1 * 1.0) * 0.5 + 5.0;
float distortion = resolution.y / resolution.x;

vec2 position = (((gl_FragCoord.xy * 0.8 / resolution) ) * scale) + scale*0.1;
position.y *= distortion * f0;

float gradient = 0.0;
vec3 color = vec3(0.0);
 
float fade = 0.0;
float z;
 
vec2 centered_coord = position - vec2(2.0);

for (float i=1.0; i<=16.0; i++) {
vec2 star_pos = vec2(sin(i) * 300.0 *f2, sin(i*i*i) * 300.0);
float z = mod(i*i - 200.0*time, 512.0);
float fade = (256.0 - z) /200.0 * f1;
vec2 blob_coord = star_pos / z;
gradient += ((fade / 300.0) / pow(length(centered_coord - blob_coord ), 1.5)) * ( fade);
}

//color = vec3( gradient * 3.0 , max( rand (gradient*1.0)*0.2 , 4.0*gradient) , gradient / 2.0 );
color = vec3( gradient * 3.0 , gradient*3.0 , gradient / 2.0 );

gl_FragColor = vec4(color, 1.0 );
}



