// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;//
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:x pos:
//f1:y pos:
//f2:rings:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

vec2 tunnel(vec2 uv) {
    return vec2(
        max(0.0, 1.0 / length(uv)),
        3.1415 + atan(uv.x, uv.y)
        );
}

vec3 map(vec2 uv, float t) {
    vec2 d = texture2D(tex, uv + vec2( 0.0, t)).xy;
    uv.y += 0.25 * d.y;
return vec3(
        sin(3.1415 * fract(2.0 * uv.x)),
    abs(cos(2.0 * (uv.y + uv.x))),
    abs(sin(2.0 * (uv.y + uv.x)))
        );
}

//---------------------------------------------------------------------------------------------------
// https://www.shadertoy.com/view/XtVSzd
void main(void) {


    float t = 2.0 * time;
    vec2 uv = 2.0 * gl_FragCoord.xy / tres.xy - 1.0 * vec2(f0,f1) * 2.;
    uv.x *= tres.x / tres.y;
    uv += .1 * vec2(sin(1.37 * t), cos(1.11 * t));
    vec2 b = tunnel(uv) * f2 * 2.;
    vec3 color = map(b + vec2(t + .25 * sin(t), sin(b.x + t)), t) / b.x;
    gl_FragColor = vec4(color,1.0);

} //endof main



