// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
//
//
// .default fragment shader

varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

//---------------------------------------------------------------------------------------------------
// metadata
// source : http://glslsandbox.com/e#36234.0
//f0:black grid horz:
//f1:stretch zoom:
//f2:hstretch+vsqueeze:
float f0 = mix(0.0, 0.5, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);
#define PI 3.1415926535897932384626
vec2 mouse = vec2(fparams.x, fparams.y);

float cdist(vec2 v0, vec2 v1){
v0 = abs(v0-v1);
return min(v0.x,v0.y);
}


//---------------------------------------------------------------------------------------------------
void main(void) {

float mytime = float(itime) + ftime;

vec2 p = (gl_FragCoord.xy * 2.0 - tres) / min(tres.x, tres.y * f1); //floor lines
vec2 q = vec2(p.x / p.y * f2 * 2., abs(1.0 / p.y) + mod(mytime, 1.0));

float grid = 2.0 * cdist(vec2(min(1.0,2.*f0)), mod(q, 1.0));

float grid_Color = smoothstep(0.0, 0.1, grid) * abs(p.y);

float modifier_A = abs(floor(q.x + 0.5) + floor(q.y + 0.5)) * abs(p.y);
float modifier_B = abs(floor(-q.x + 0.5) + floor(q.y + 0.5)) * abs(p.y);
float modifier_C = mod(abs(floor(q.x + 0.5) + floor(q.y + 0.5)), 3.0) * abs(p.y);

vec3 color = vec3 (grid_Color * modifier_A, grid_Color * modifier_B, grid_Color * modifier_C);

gl_FragColor += vec4(color, 1.0);


} //endof main


