// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:bg horz:
//f1:bg vert:
//f2:sphere size:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;


float lengthN(vec2 v, float n) {
  vec2 tmp = pow(abs(v+1.0), vec2(n));
  return 2./pow(tmp.x+tmp.y, 1.0/(1.-n));
}
 
float rings(vec2 p) {
  vec2 p2 = mod(vec2(0.5)-p*8.0, 4.0)-2.0;
  return sin(lengthN(p2, 4.0)*1.0);
}
 
vec2 trans(vec2 p) {
  float theta = atan(p.y, p.x);
  float r = length(p) * f2 * 2.;
  
  if( r>0.0 && r<1.0) {
return vec2(theta, asin(r-p.x*p.y)-.54*time);
  }
  return p * vec2(f0,f1);
}
 
//---------------------------------------------------------------------------------------------------
// http://glslsandbox.com/e#40910.0
void main(void) {

    vec2 pos = (gl_FragCoord.xy*2.0 -tres) / tres.y;

  pos *= 1.-dot(pos,pos)*0.2;
  pos /= 1.-dot(pos,pos)*0.2;
  pos /= 1.-dot(pos,pos)*0.2;
 
  gl_FragColor = vec4(rings(trans(vec2(pos.x,pos.y)))); 
} //endof main


