// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
	precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:zoom:
//f1:thickness:
//f2:ring depth:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

// by @neave and weyland yutani
// Inspired by http://www.everyday3d.com/j3d/demo/011_Plasma.html


const vec3 col1 = vec3(.964705882, .990196078, .990196078);
const vec3 col2 = vec3(.266666667, .333333333, .231372549);
const vec3 col3 = vec3(.839215686, .880392157, .849019608);
const vec3 col4 = vec3(.776470588, .772549020, .729411765);
const vec3 col5 = vec3(.509803922, .592156863, .503921569);

void main( void ) {

vec2 position = gl_FragCoord.xy / resolution.xy * f0 * 2.;
vec2 ca = vec2(0.1, 0.2);
vec2 cb = vec2(0.7, 0.9);
float da = distance(position, ca);
  float db = distance(position, cb) * f1;
  float t = time * 0.1;
float c1 = sin(da * cos(t) * 18.0 + t * 10.0) * f2;
float c2 = cos(position.y * 1.0 + t);
float c3 = cos(db * 19.0) + sin(t);

float p = (c1 + c2 + c3) / 3.0;
  vec4 col = vec4(0, 0, 0, 2);

  if (p <= 0.0) col.rgb = col1;
  else if (p < 0.2) col.rgb = col2;
  else if (p < 0.3) col.rgb = col3;
  else if (p < 0.4) col.rgb = col4;
  else col.rgb = col5;

gl_FragColor = col;
}



