// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
	precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:h offset:
//f1:v offset:
//f2:detail:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

mat2 m = mat2( 0.80,  0.60, -0.60,  0.9 );

float hash( float n ){
    return fract(sin(n)*43758.5453);
}

float noise( in vec2 x ) {
    vec2 p = floor(x);
    vec2 f = fract(x);
    f = f*f*(3.0-2.0*f);
    float n = p.x + p.y*57.0;
    float res = mix(mix( hash(n+  0.0), hash(n+  1.0),f.x), mix( hash(n+ 57.0), hash(n+ 58.0),f.x),f.y);
    return res;
}

float fbm( vec2 p )
{
    float f = 0.0;
    f += 0.50000*noise( p ); p = m*p*2.02;
    f += 0.25000*noise( p ); p = m*p*2.03;
    f += 0.12500*noise( p ); p = m*p*2.01;
    f += 0.06250*noise( p ) * 4. * f2; p = m*p*2.04;
    f += 0.03125*noise( p );
    return f/0.984375;
}


void main( void ) {


vec2 p = ( gl_FragCoord.xy / resolution.xy );

float color = 0.0;

float to = 10.; // time /10.0;

float n = fbm(vec2(p.x+ f0, p.y+ f1));
//float n2 = fbm(vec2(time/10.0, 0.0));

color = (sin(n*250.0 + time/1.0) + 1.0) /2.0;
color = smoothstep(0.0, 0.1, color);
gl_FragColor = vec4( vec3( color, color, color), 1.0 );

}



