// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;//
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:length:
//f1:brightness:
//f2:contrast:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

float Random(vec2 uv){
vec2 seed = vec2(15.315531,65.2354);
return fract(sin(dot(uv,seed))*315351.351351)*3.0-1.5;
}

float Noise(vec2 uv){
vec2 uv_i = floor(uv);
vec2 uv_f = fract(uv);

float a = Random(uv_i);
float b = Random(uv_i+vec2(1.0,0.0));
float c = Random(uv_i+vec2(0.0,1.0));
float d = Random(uv_i+vec2(1.0,1.0));
vec2 u = uv_f*uv_f*(3.0-2.0*uv_f);
return mix(a,b,u.x)+(c-a)*u.y*(1.0-u.x)+(d-b)*u.x*u.y;
}

vec3 hsv2rgb(vec3 c) {
    vec4 K = vec4(1.0, 2.0 / 3.0, 1.0 / 3.0, 3.0);
    vec3 p = abs(fract(c.xxx + K.xyz) * 6.0 - K.www);
    return c.z * mix(K.xxx, clamp(p - K.xxx, 0.0, 1.0), c.y);
}

//Thanks to Patricio Gonzalez
float FBM(vec2 uv){
float val = 0.0;
float freq = 2.50;
float amp = 0.5;
for(int i=0;i<3;i++){
val+=abs(Noise(uv))*amp;
uv*=freq;
amp *=0.5;
}
val= clamp(val,0.0,1.0);
return val;
}

//---------------------------------------------------------------------------------------------------
// Original code: http://glslsandbox.com/e#43174.0 // source : http://glslsandbox.com/e#35359.4
void main( void ) {
vec2 pos = ( gl_FragCoord.xy / tres.xy );
//fbm
float f = FBM(pos*10.0+vec2(time*5.,0.0));
f = FBM(pos*2.0+f-time*0.5);
float mixerVal = 0.55 * f0 * 2. ;
float valSoft = 0.6 * f1 * 2.;
float mixer = smoothstep(mixerVal-valSoft,mixerVal+valSoft,1.0-pos.x)*2.0-1.0;
//f*=mixer;
f+=mixer *f2;//1.0-(pos.x+.42);
float maskVal = 0.5;
float maskSoft = 0.3;
float mask = smoothstep(maskVal-maskSoft,maskVal+maskSoft,1.0-abs(pos.y*2.0-1.0));
float fx = mask * f;
vec3 colo = hsv2rgb(vec3(sin(fx * 3.0) * 0.5 + 0.5, 1.0, fx));
gl_FragColor = vec4(colo, 1.0);
}


