// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:atan x offset:
//f1:atan y offset:
//f2:color pos:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

vec3 image(vec2 p) {
float c = 1. - length(mod(abs(p), 0.7));
return vec3(1. - c, c * f2, c * 23.);
}

vec2 distort(vec2 p) {
float d = length(p) + sin(time * 0.05);
float a = atan(p.y*f1,p.x*f0);

vec2 uv;

uv.x = cos(a + time) / d + 1. -f2;
uv.y = sin(a + time) / d + f2;

return p + uv + vec2(time * 0.5);
}

vec3 effect() {
vec3 color;
 vec3 uv;
vec2 pos = gl_FragCoord.xy / resolution - 0.5;

color = image(distort(pos));

return color;
}


void main() {
gl_FragColor = vec4(effect(), 1.);
}


