// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;//
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:side 1 mod:
//f1:side 2 mod:
//f2:side 3 mod:

float f0 = mix(0.05, 0.95, fparams[0]) * 4.;
float f1 = mix(0.05, 0.95, fparams[1]) * 4.;
float f2 = mix(0.05, 0.95, fparams[2]) * 4.;

float time = float(itime) + ftime;
vec2 resolution = tres;
//---------------------------------------------------------------------------------------------------

float DEG2RAG = .0174532925199;


float tri2(vec2 pos) {
float a = dot(pos, vec2(sin( 60.0*DEG2RAG), cos( 60.0*DEG2RAG)));
float b = dot(pos, vec2(sin(-60.0*DEG2RAG), cos(-60.0*DEG2RAG)));
float c = -pos.y;
float d = 0.2*cos(60.0*DEG2RAG);

float u1 = a - d*0.25;
float v1 = b - d*0.25;
float w1 = c - d*0.25;

float u2 = c + d*1.25;
float v2 = b + d*1.25;
float w2 = a + d*1.25;

float t1 = min(u2, min(u1, v1));
float t2 = min(v2, min(w1, u1));
float t3 = min(w2, min(v1, w1));

float res = max(max(t1, t2), t3);
return 0.0002/abs(res);
}


float tri(vec2 pos) {
float a = dot(pos, vec2(sin( 90.0*DEG2RAG), cos( 60.0*DEG2RAG))) * f0;
float b = dot(pos, vec2(sin(-60.0*DEG2RAG), cos(-60.0*DEG2RAG))) * f1;
float c = -pos.y * f2;

float result = 0.002/abs(min(min(0.01511-a,0.105-b), 0.1505-c));
return result;
}


//---------------------------------------------------------------------------------------------------
// http://glslsandbox.com/e#48541.0
void main(void) {

vec2 pos = (2.0*gl_FragCoord.xy - tres.xy)/max(tres.x, tres.y) / 32.0;

//rotate & zoom
mat2 rot = mat2(cos(time),-sin(time), 
sin(time), cos(time));
        //pos *= rot;

float zoom = 1.0/(mod(time, 1.0)+1.0)*3.0-1.0;
pos *= zoom;

//effect
vec3 result = vec3(0.0);
for(int i = 0 ; i < 4 ; i++) {
result += vec3(tri(pos), tri(-pos*0.5), tri2(pos));
pos /= 0.25;
}
gl_FragColor = vec4( mix(vec3(0.0, 0.0, 0.0), vec3(0.5, 0.0,1.0), result.x)
    +mix(vec3(0.0, 0.0, 0.0), vec3(0.5,0.25,0.0), result.y)
    +mix(vec3(0.0, 0.0, 0.0), vec3(0.0,0.5,0.1), result.z), 1.0 );
   
} //endof main


