// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:control 1:
//f1:control 2:
//f2:control 3:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.3, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);


float time = float(itime) + ftime;
vec2 resolution = tres;
// MISTY LIGHTS by WEYLAND YUTANI

float size=f0;

void main(void) {

    vec2 move1,move2,move3,move4;

    move1.x = cos(time*0.5)*size;
    move1.y = sin(time*0.2)*size;

   size += f1 / 4.;

    move2.x = cos(time*0.3)*size;
    move2.y = sin(time*0.4)*size;
  size -= f0;

    move3.x = sin(time*0.7)*size;
    move3.y = cos(time*0.9)*size;

    move4.x = sin(time*0.8)*size;
    move4.y = cos(time*0.1)*size;

    vec2 p = -1.0 + 2.0 * gl_FragCoord.xy / resolution.xy;
    float r1 =(dot(p-move1,p-move1))*18.0 -f0;
    float r2 =(dot(p+move2,p+move2))*12.0 *f1 + f1;
    float r3 =(dot(p+move3,p+move3))*14.0 * f1;
    float r4 =(dot(p+move4,p+move4))*16.0 -f0 * f2;
    float metaball =(1.0/r1+1.0/r2-1.0/r3-1.0/r4);
    gl_FragColor = vec4(
pow(metaball,f0+move1.x),
pow(metaball * f2,1.0),
pow(metaball - .2 * f1,1.0),
1.0
);

    //-mix(vec3(0.2+cos(time/2.5)/5.0, 0.2+sin(time/3.5)/5.0, 0.2+sin(time/3.0)/5.0),vec3(0.0), p.y),1.0); //?

  }


