// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0

vec2 mouse = vec2(fparams.x, fparams.y);
float time = float(itime) + ftime;
vec2 resolution = tres;
//f0:diag move:
//f1:thickness:
//f2:brightness:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]) * 2.;

float wave(vec2 p, float angle) {
  vec2 direction = vec2(sin(angle), cos(angle));
  return atan(dot(p, direction));
}

float wrap(float x) {
  return abs(mod(x, 2.) - 1.) * f2;
}

void main() {
  vec2 position = (gl_FragCoord.xy / resolution.xy);
  vec2 p = (position - f0) * 100.0;

  float brightness = 0.;
  for (float i = 1.; i <= 2.; i++) {
    brightness += wave(p * f1 + 0.3, time / i);
  }

  brightness = wrap(brightness);

  gl_FragColor = vec4(brightness, brightness, brightness, 1.0);
}


