// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:pov:
//f1:horizon:
//f2:brightness:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);


float time = float(itime) + ftime;
vec2 resolution = tres;
//tigrou 2013.02.28 (for gamedevdtack exchange)

float get2DTexture(float x, float y) {
   return sin(x)+sin(y);
}

vec2 rotate(vec2 v, float angle) {
    float x = v.x * cos(angle) - v.y * sin(angle);
    float y = v.x * sin(angle) + v.y * cos(angle);
    return vec2(x, y);
}

void main( void ) {
  
      vec2 position = ( gl_FragCoord.xy / resolution.xy ) - vec2(0.5,f1);
      
     float x = position.x;
     float y = position.y;

     float horizon = 0.1; //adjust if needed
     float fov = 0.1 + f0; 

     float px = x;
     float py = y - horizon - fov; 
     float pz = y - horizon;  

     //projection 
     float sx = px / pz;
     float sy = py / pz; 

     float scaling = 10.0; //adjust if needed, depends of texture size

     //rotate  
     vec2 r = rotate(vec2(sx, sy), time/10.0);
     sx = r.x;
     sy = r.y;
   
     //move
     sx += time / 1.0 * sign(pz);

     float color = get2DTexture(sx * scaling, sy * scaling);  

     //shading
     color *= pow(pz,1.5)*10.0 *f2 ;

     gl_FragColor = vec4( -color,color,color,  1.0);

}


