// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;       //
uniform sampler2D tex;     // texture one
uniform sampler2D tex2;    // texture two
uniform vec2 tres;         // size of texture (screen)
uniform vec4 fparams;      // 4 floats coming in
uniform ivec4 iparams;     // 4 ints coming in
uniform float ftime;       // 0.0 to 1.0
uniform int itime;         // increases when ftime hits 1.0

//f0:horz sine start:
//f1:drop length:
//f2:vert stretch:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
uniform sampler2D bb;

float noise(vec2 p) {
p=(p);
return abs(fract(sin(p.x*45.11+p.y*.23)*878.73+733.17)*2.0-1.0);
}

float wave(vec2 uv) {
float p1 = .90;
float p2 = 10.0 / f1;
float sine = sin(uv.y + time) + noise(vec2(uv.x)) *2.0 /f2;
sine *= f0; 

return (1.0 - abs(sine - uv.x) - p1) * p2;
}

void main( void ) {

vec2 position = ( gl_FragCoord.xy / resolution.xy );

vec3 color = vec3(0.0);

color += vec3(1.0) * max(0.0,wave(position));

//color of streams
color = pow(color, vec3(10,50, 100));

color += texture2D(bb, vec2(position.x, position.y)).xyz * 0.9 * vec3(0.5, 1.0, 0.75);

gl_FragColor = vec4( color, 1.0 );

}


