// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:horz stretch:
//f1:gray 1:
//f2:gray 2l:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;// for easier glslsandbox.com conversion
//---------------------------------------------------------------------------------------------------
void main(void) {

   vec2 uv = ( gl_FragCoord.xx / resolution.xy );
   
   float divisor = 3.0 + (f0 * 40. );
   
   divisor += mod(divisor, resolution.y);

   float lum = (tan((floor(uv.y * divisor))  + 1.) )/ 2.;

   //gl_FragColor = vec4(mix(0.0, 1.0, lum));

   float c1 = sin(time) * f2;
   float c2 = cos(f1);
   gl_FragColor = vec4(mix(c1, c2, lum));

} //endof main


