// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:gray level:
//f1:horz stretch:
//f2:amplitude:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

float distance(vec2 pos){
float x = pos.x * (3.0+ 10.*f1) + time*2.5;
float height = sin(x) / 20.0 /f2;

float angle;
angle = atan(1.0 / cos(x));

return abs(height - pos.y) - 0.001 - abs(0.05*(cos(time*0.3)/2.0 + 0.0) / sin(angle*47.0));
}

void main( void ) {
vec2 pos = gl_FragCoord.xy / resolution - vec2(0.5, 0.5);
float dist = distance(pos);

vec3 color = vec3(0.7,0.4 ,0.2);

if(dist < 0.0){
color *= log(-dist * ( abs(cos(time*0.3))*100.0 *f1 ));
}else{
color = vec3(f0) * .5;
}

gl_FragColor = vec4(color, 1.3 );
}


