// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:vert offset:
//f1:vert pos:
//f2:color pos:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);


float time = float(itime) + ftime;
vec2 resolution = tres;

void main( void ) {

vec2 position = ( gl_FragCoord.xy / resolution.xy ) + vec2(f0, f1) / 2.0;

float color = 0.0;
color += cos( position.x * (f2 - f1) * cos( time / 15.0 ) * 80.0 ) + cos( position.y * tan( time / 15.0 ) * 10.0 );
color += sin( position.y * (f0 * f0) * tan( time / 10.0 ) * 40.0 ) + tan( position.x * sin( time / 25.0 ) * 40.0 );
color += sin( position.y * (f1 + f2) * sin( time / 55.0 ) * 10.0 ) + sin( position.x * cos( time / 35.0 ) * 80.0 );
color *= tan( time / 10.0 ) * 0.5;

gl_FragColor = vec4( vec3( color, color * 0.5, tan( color + time / 5.0 ) * 0.75 ), 1.0 );

}


