// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:mod1:
//f1:width:
//f2:mod2:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

#define LINES 2.0
#define BRIGHTNESS 0.3

const vec3 ORANGE = vec3(10.4, 0.8, 0.4);
const vec3 BLUE = vec3(0.5, 0.9, 1.3);
const vec3 GREEN = vec3(0.9, 1.4, 0.4);
const vec3 RED = vec3(1.8, 0.4, 0.3);

//---------------------------------------------------------------------------------------------------
void main(void) {


  float y, x, ypos, xpos;
  float t = time * 10.0;
  vec3 c = vec3(0.0);

  xpos = (gl_FragCoord.y / resolution.y);
  ypos = (gl_FragCoord.x / resolution.x);

  x = xpos;
  for (float i = -5.0; i < LINES; i += 1.0) {
    y = ypos + (
        0.550 * sin(x * 1.000 + i * 0.4 + t * 0.050) * f0
      + 0.400 *f1 * cos(x * 6.350 + i * 0.7 + t * 0.250) 
      + 0.24 * sin(x * 12.35 + i * 0.8 + t * 0.234) * f2
      + 0.600
    );

    c += vec3(1.0 - pow( clamp(abs(1.0 - y) * 120.0, 0.0, 1.0) , 0.5));
  }

 c *= mix(
     mix(ORANGE, BLUE, xpos)
   , mix(GREEN, RED, xpos)
   ,(sin(t * 0.02) + 1.0) / LINES
  ) ;

  gl_FragColor = vec4(c, 1.0);
   
} //endof main


