// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;       //
uniform sampler2D tex;     // texture one
uniform sampler2D tex2;    // texture two
uniform vec2 tres;         // size of texture (screen)
uniform vec4 fparams;      // 4 floats coming in
uniform ivec4 iparams;     // 4 ints coming in
uniform float ftime;       // 0.0 to 1.0
uniform int itime;         // increases when ftime hits 1.0

//f0:shape:
//f1:blur:
//f2:diag zoom:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.15, 0.95, fparams[2]);

vec3 hash3( vec2 p ) {

    vec3 q = vec3( dot(p,vec2(127.1,311.7)), 
   dot(p,vec2(269.5,183.3)), 
   dot(p,vec2(419.2,371.9)) );
    return fract(sin(q)*43758.5453);
}

float iqnoise( in vec2 x, float u, float v ) {
    vec2 p = floor(x);
    vec2 f = fract(x);

    float k = 1.0+63.0*pow(1.0-v,4.0);

    float va = 0.0;
    float wt = 0.0;
    for( int j=-1; j<=1; j++ )
    for( int i=-1; i<=1; i++ ) {
        vec2 g = vec2( float(i),float(j) );
vec3 o = hash3( p + g )*vec3(u,u,1.0);
vec2 r = g - f + o.xy;
float d = dot(r,r);
float ww = pow( 1.0-smoothstep(0.0,1.414,sqrt(d)), k );
va += o.z*ww;
wt += ww;
    }
    return va/wt;
}

float time = float(itime) + ftime;

//---------------------------------------------------------------------------------------------------
//https://www.shadertoy.com/view/Xd23Dh

void main(void) {
vec2 uv = gl_FragCoord.xy / tres.xx;

    vec2 p = 0.5 - 0.5*sin(vec2(1.01,1.71) );

//if( f2 >0.5 ) p = vec2(0.0,1.0) + vec2(1.0,-1.0)*vec2(f0,f1)/tres.xy;
p += vec2(0.0,1.0) + vec2(1.0,-1.0)*vec2(f0,f1);   ///tres.xy;

p = p*p*(3.0-2.0*p);
//p = p*p*(3.0-2.0*p);
//p = p*p*(3.0-2.0*p);

float f = iqnoise( 24.0*uv * f2, p.x, p.y );

gl_FragColor = vec4( f, f, f, 1.0 );
   
} //endof main


