// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:glow size:
//f1:frequency:
//f2:zoom:
float f0 = mix(0.1, 0.75, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);
// source : http://glslsandbox.com/e#35712.0


//---------------------------------------------------------------------------------------------------
void main(void) {

float mytime = float(itime) + ftime;

vec2 uv = (2.0 * gl_FragCoord.xy / tres.xy - 1.0) * vec2(tres.x / tres.y, 1.0);

float a = 4.0 * f1 * atan(uv.y / uv.x);
uv /= 0.5 + 0.02 * sin(15.0 * a - mytime * 16.0);

float f = 1.40 + f2 * cos(mytime);
float d = (abs(length(uv) - f) * 10.0 )*f0 +0.0001;

gl_FragColor += vec4(0.8/d, 0.2/d, 2.22/d, 1);

} //endof main


