// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
	precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:amplitude:
//f1:brightness:
//f2:frequency:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.5, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

// wave dance - bonniemathew@gmail.com
void main( void ) {

float FREQUENCY_FACTOR = 30.0 * f2;
float AMPLITUDE_FACTOR = 0.2 + f0;
float LINE_WIDTH = 10.0;
float WAVE_OFFSET = 0.1 ;

vec4 color_final;
vec3 color = vec3(0.0, 0.0, 0.);
float wX1, wY1;
float wX2, wY2;

vec2 position = ( gl_FragCoord.xy / resolution.xy ) - vec2(0.5);

wX1 = position.x;
wY1 = sin(wX1 * FREQUENCY_FACTOR + time * 2.0) * AMPLITUDE_FACTOR;

wX2 = position.x + WAVE_OFFSET;
wY2 = cos(wX2 * FREQUENCY_FACTOR  - time * 2.0) * AMPLITUDE_FACTOR;

float distFromWave1 = abs(1.0 - length(position - vec2(wX1, wY1)));
position.x += WAVE_OFFSET;
float distFromWave2 = abs(1.0 - length(position - vec2(wX2, wY2)));
LINE_WIDTH = f1 * 200.0;

color += ((distFromWave1/LINE_WIDTH) * 100.0);
color *= ((distFromWave2/LINE_WIDTH) * 100.0);

color_final = vec4(color.x * 0.5,  color.y * 0.3 , color.z * 0.0, 1.0);
gl_FragColor = color_final;
}


