// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:checker size:
//f1:wave intensity:
//f2:color pos:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
//http://glsl.heroku.com/e

vec3 hsv(float h,float s,float v) {
return mix(vec3(1.),clamp((abs(fract(h+vec3(3.,2.,1.)/3.)*6.-3.)-1.),0.,1.),s)*v;
}

float checkers(vec2 p, vec2 pos) {
float size = 8.0 / f0 + sin(pos.x+time*7.0)*2.0 /f1 ;
return floor(sin(p.x*size) * sin(p.y*size)*100000.0);
}

void main( void ) {

vec2 pos= ( gl_FragCoord.xy / resolution.xy );
vec2 move = vec2(cos(time) , sin(time*2.0)) * 0.2;
float val = checkers(pos+move, pos);
vec3 col = hsv(0.5 + f2, 1.0, val);

gl_FragColor = vec4(col, 1.0);

}



