// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:horz mod:
//f1:vert mod:
//f2:diag zoom:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);
//http://glslsandbox.com/e#48327.0

float time = float(itime) + ftime;
//---------------------------------------------------------------------------------------------------
float rand(vec2 co){
  return fract(sin(dot(co.xy, vec2(sqrt(13.), sqrt(7.)))) * sqrt(77.) - sin(time));
}
void main(void) {

// Divide the coordinates into a grid of squares
vec2 v = gl_FragCoord.xy  / (20. + 20.0 * f2);
v -= time + vec2(sin(v.y), cos(v.x));

// Calculate a pseudo-random brightness value for each square
float brightness = fract(rand(floor(v)) + time);
float hue = fract(rand(floor(v) + 1.) + time);

// Reduce brightness in pixels away from the square center
brightness *= 0.45 - length(fract(v) - vec2(f0,f1)) + sin(time)  * cos(sqrt(time));
gl_FragColor = vec4(hue*5., hue*2., hue*brightness*20.0, 1.0);
   
} //endof main


