// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// 
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:zoom:
//f1:side shade:
//f2:circle size:

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);
//http://glslsandbox.com/e#48299.0

#define _ vec2((gl_FragCoord.xy*2.-tres.xy )/tres.y)

#define pi 3.14159265359
#define pi2 6.28318530718

float time = float(itime) + ftime;
//---------------------------------------------------------------------------------------------------
void main(void) {

    float a = (.5+atan( length(  _), f0 ) * pi2);
    float r = clamp( a - acos( _.y * 1.18 ) / pi2, 0., 1.);
    
    vec2 uv =  vec2( 1./r + 0.2* time, a );

    float f = sin(uv.x) * cos ( time  - uv.y) /f1;

    highp float c = abs(0.01/sin( f + _.x * 12.) - f * cos( _.y ) ) - uv.y * abs(0.0035 / sin( f - _.y * 12.) - .081 /cos( f * _.x )  ) /f2;
    
    vec3 col =     (c * 0.25) + ( 0.5 * cos( 0.25 + (pi2 * c) + vec3( -pi/2., pi/2.6, pi )));
    
    gl_FragColor.rgb =  c + pow(col + 0.2 , 2.2 / vec3( uv.x, uv.y , 1.-(uv.x+uv.y) ) );
    gl_FragColor.a = 1.;
   
} //endof main


