// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:center x:
//f1:center y:
//f2:zoom:
        float f0 = mix(0.05, 0.95, fparams[0]);
        float f1 = mix(0.05, 0.95, fparams[1]);
        float f2 = mix(0.05, 0.95, fparams[2]);

//http://www.glslsandbox.com/e#43419.0
#define PI 3.1415926535897932384626
float time = float(itime) + ftime;
vec2 resolution = tres;// for easier glslsandbox.com conversion

//---------------------------------------------------------------------------------------------------
void main(void) {

   //vec2 position = ( gl_FragCoord.xy / resolution.yy ) - vec2(0.5 * resolution.x/resolution.y, 0.5);
   vec2 position = ( gl_FragCoord.xy / resolution.xy ) - vec2(f0 , f1);
   vec3 col;
      
   float angle = mod((atan(position.y, position.x) + time * 0.2) / (2.0 * PI), 1.0);
   float dist = length(position) * f2;
   
   float f = angle * 4.0 + 0.1 * sin(dist * 32.0 - time * 2.0);
   f = mod(f, 1.0);
   float edge = smoothstep(0.49, 0.51, f);
   col = mix(vec3(0.2,0.4,0.5), vec3(0.7,0.4,0.2), edge);
   col *= 1.0 - dist * 0.3;
   float light = (1.0 - dist);
   col += edge * light * light * 10.0;
   
   gl_FragColor = vec4(col, 1.0 );


} //endof main


