// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:cloud offset:
//f1:sharpness:
//f2:diag zoom:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
//created by nikoclass


float rand (float x) {
return fract(sin(x * 24614.63) * 36817.342);
}

float wave (in vec2 p, in vec2 dir, in float size) {
dir += vec2(rand(size)) - vec2(f0);
return sin(dot(p, dir) / (size + rand(size)) + time) * (size + rand(size));
}

float f(in vec2 p){
p *= 80.0 + (f2 * 80.);

float res = 0.0;
res += wave (p, vec2(0.0, 1.0), 8.0);
res += wave (p, vec2(-1.0, -1.0), 9.0);
res += wave (p, vec2(0.0, -1.0), 8.0);
res += wave (p, vec2(0.0, 1.0), 9.0);
res += wave (p, vec2(1.0, 0.0), 9.0);
res += wave (p, vec2(-1.0, 0.0), 3.0);
res += wave (p, vec2(-1.0, 1.0), 9.0);
res += wave (p, vec2(1.0, 1.0), 9.0);

return res * 0.1 / f1;
}

void main( void ) {
vec2 p = (gl_FragCoord.xy / resolution.xy );
float c = f(p);
gl_FragColor = vec4(c, c, 1.0, 1.0);

}


