// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:zoom:
//f1:rotations:
//f2:hightlights:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
///@ME // rotwang @mod* very nice!  // ME @mod* 

const float PI = 3.1415926535;
const float TWOPI = PI*2.0;

vec2 rotate(vec2 point, float rads) {
float cs = cos(rads);
float sn = sin(rads);
return point * mat2(cs, -sn, sn, cs);
}

float curve( float x) {
return smoothstep( 1.0, 0.0, cos(x*PI) ) - cos(x*PI);
}

float thing(vec2 pos) {
float offset = 0.;
float row = floor((pos.y)/2.);
if (mod(row, 2.0) < 1.0) {
offset = 1.0;
pos = rotate(pos, radians(90.*sin(time * 0.5)));
}
float a = curve(pos.x) - offset + abs(sin(time));
float b = curve(pos.y - offset * 1.0) - offset * 0.25;
float c = max(distance(b,a/b), tan(a) - tan(b)) /f2;
float d = pow(a,c) * abs(sin(-time)) + sqrt(c*a) * abs(sin(time));
float e = inversesqrt(d);
return (a * b + d) *(sqrt(a/b))+ c / e;
}

void main(void) {
vec2 position = ( gl_FragCoord.xy / resolution );
vec2 world = position * 2. - 1.;
world *= 5. * f0;
world.x *= resolution.x / resolution.y;
world = rotate(world, radians(360.  * f1));
float dist = 1.0/thing(world);

gl_FragColor = vec4( dist, dist, dist, 1.0 );
}


