// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:x pos:
//f1:y pos:
//f2:glow layers:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

float circle (vec2 center, vec2 pos, float mul){
float d = 1./((center.x-pos.x)*(center.x-pos.x)+(center.y-pos.y)*(center.y-pos.y));
d /=mul*30.;
return d;
}

void main( void ) {

vec2 position = ( gl_FragCoord.xy / resolution.xy );

vec2 circle1 = vec2(sin(time/2.)/2.+0.5, 0.75);
vec2 circle2 = vec2(0.3, cos (time/2.)/3.+0.3);
vec2 circle3 = vec2(sin(time/3.)/4.+0.6, cos (time/5.)/3.+0.6);

float color = 0.;

color += circle (circle1, position, (2.+sin(time*2.))*3.5);
color += circle (circle2, position, (2.+cos(time/2.))*4.);
color += circle (circle3, position, (2.+sin(time))*3.);
color += circle (vec2(f0,f1), position, (2.+sin(time)*1.5)*5.);

float step = f2+0.001;
float colorSimp = floor(color/step)*step;

float verge = 0.1;
float tresh = 0.003;
if (color<verge+tresh && color>verge-tresh){
colorSimp=f2/2.+f1/2.;
}

gl_FragColor = vec4( vec3( colorSimp*(0.5+sin(time)/2.),  colorSimp*(0.5+cos(time/2.)/2.),  colorSimp*(f0+f1)), 1.0 );
}


