// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;//
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:dot scale:
//f1:dot zoom:
//f2::

float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;

float map(float value, float beforeMin, float beforeMax, float afterMin, float afterMax) {
    return afterMin + (afterMax - afterMin) * ((value - beforeMin) / (beforeMax - beforeMin));
}

//---------------------------------------------------------------------------------------------------
//http://www.glslsandbox.com/e#41972.1
void main(void) {

    vec2 uv = (gl_FragCoord.xy * 2.0 - resolution) / min(resolution.x, resolution.y);

    float scale = 30. * f0;
    vec2 repeatedUv = uv * scale;
    vec2 newUv = fract(repeatedUv);

    vec2 center = floor(repeatedUv) * vec2(1.-f2,f2);
    float dist = distance(center, vec2(0.0));  // Same as length(center)
    dist /= scale * f1;

    vec3 color = vec3(0.0);
    float offset = map(sin(time * 2.0), -1.0, 1.0, 0.8, 0.9);

    if (dist < offset) {
        // Make circle with small circle.
        newUv -= 0.5;

        float radius = map(sin((uv.x + uv.y) + time * 8.0), -1.0, 1.0, 0.1, 0.4);
        float v = 1.0 - step(radius, length(newUv));  // Circle
        v *= time;
        color.rg += v;

        newUv += 0.5;
    }

    gl_FragColor = vec4(color, 1.0);

} //endof main


