// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in 
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
varying vec2 tcoord;// location
//f0:move 1:
//f1:move 2:
//f2:dots:
        float f0 = mix(0.05, 0.95, fparams[0]);
        float f1 = mix(0.05, 0.95, fparams[1]);
        float f2 = mix(0.05, 0.95, fparams[2]);

// https://www.shadertoy.com/view/MsXfzr
#define PI 3.1415926535897932384626
float time = float(itime) + ftime;
vec2 resolution = tres;// for easier glslsandbox.com conversion

void zebra(inout vec4 O, in vec2 uv, in float t, in float speed, float bands) {
    vec4 final_color;
    float d = uv.y + t * speed;
    final_color = vec4(smoothstep(.4, .41, abs(1.0 + sin( d * bands))*0.5));
    O = vec4(final_color.rgb, 1.0);
}
void dots(inout vec4 O, in vec2 uv, in float t, in float speed) {
    vec4 final_color;
    uv.y -= time / 10.0;
    //O = vec4(round(1.0-length(vec2(0.5) - fract(uv*20.))*5.));
    final_color = vec4(floor(1.0-length(vec2(0.5) - fract(uv*20.))*5.+.5));
    O = vec4(final_color.rgb, 1.0);
}

//---------------------------------------------------------------------------------------------------
void main(void) {

    vec2 uv = tcoord.xy;
    vec2  mouse2 = (vec2(vec2(f0,f1)/ resolution.y) - .5 )*2.;
    float t = time, a = atan(mouse2.y,mouse2.x);
    uv-=.5;
    uv = mat2(cos(a),-sin(a),sin(a),cos(a)) * uv + .5;

//    float speed = 0.1 + round( fract( cos( 3.37 * uv.x + 7.5 )) * 2. * (1. - .5 / resolution.x * 2.) - 1.0);
    float speed = 0.1 + floor( fract( cos( 3.37 * uv.x + 7.5 )) * 2. * (1. - sin(time) / resolution.x * 2.) - 1.0 + .5);

    if(abs(speed) > .9) {
      zebra(gl_FragColor, uv, t, speed, 13.7 -(f1 * .05)  ) ;
    } else if(abs(speed) > .3) {
      dots(gl_FragColor, uv * f2, t, speed);
    } else {
      zebra(gl_FragColor, uv, t, speed, 70.2 + (5.0 * f0 *.5));
    }   

} //endof main


