// shader type: gen 
// shader written by unknown on glslsandbox.com  
// shader translated to gles by Erogenous-Tones.com 
precision mediump float;
varying vec2 tcoord;// location
uniform sampler2D tex;// texture one
uniform sampler2D tex2;// texture two
uniform vec2 tres;// size of texture (screen)
uniform vec4 fparams;// 4 floats coming in
uniform ivec4 iparams;// 4 ints coming in
uniform float ftime;// 0.0 to 1.0
uniform int itime;// increases when ftime hits 1.0
//f0:horz stretch:
//f1:vert stretch:
//f2:ring count:
float f0 = mix(0.05, 0.95, fparams[0]);
float f1 = mix(0.05, 0.95, fparams[1]);
float f2 = mix(0.05, 0.95, fparams[2]);

float time = float(itime) + ftime;
vec2 resolution = tres;
// 2013-03-17 by @hintz

void main(void) {
vec2 p = (gl_FragCoord.xy - 0.5 * resolution.xy) / resolution.yy / vec2(f0, f1);

float r = length(p);
float a = atan(floor(p.y*p.x), floor(p.x*p.y));
float z = cos(3.0 * (a + r*3.0*cos(time) - sin(time))) / f2;
float z2 = cos(4.0 * (a + r*3.0*cos(time*1.1) - sin(time*1.01)));


float c1 = 0.0;
float c2 = 1.0-sin(time+2.0*(r*z-z2));
float c3 = (r+z2-z*r)*2.0;
//c3 = floor(c3*2.0);
//c2 = floor(c2*2.0);
vec3 col = r*vec3(c1, c2, c3);
//vec3 col = r*vec3(0, 1.0-sin(time+2.0*(r*z-z2)), (r+z2-z*r)*2.0);


gl_FragColor.rgb = 1.0 - col;
gl_FragColor.a = 1.0;
}



